      PROGRAM DDM
C##########################################################################
C        Powder Diffraction Structure Analysis Program DDM
C                          Version 1.95d
C Includes Rietveld and Derivative Difference Minimization (DDM) methods
C        [L.A. Solovyov, J. Appl. Cryst. 37 (2004) 743-749]
C##########################################################################
C
C  Incorporated codes:
C
C   PROGRAM FOR RIETVELD ANALYSIS OF X-RAY AND NEUTRON
C   (NUCLEAR SCATTERING ONLY) POWDER DIFFRACTION PATTERNS
C   VERSION DBWS-9006PC
C   SCHOOL OF PHYSICS (R. A. YOUNG)
C   GEORGIA INSTITUTE OF TECHNOLOGY, ATLANTA, GA. 30332  USA
C
C   SUBROUTINE SGHALL
C   WRITTEN BY DAVID R. MOSSCROP (7901822)
C   THIS PROCEDURE USES THE HALL SPACE GROUP NAME TO GENERATE 
C   THE CORRESPONDING MATRIX TRANSFORMATIONS.
C   MODIFIED 84.2.14 BY I D BROWN TO ALLOW ORIGIN SHIFT
C   UPDATED BY D. ALTERMATT
C
      INCLUDE 'DDM.inc'
c
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS),LAU1(MPH), ICZ
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
        character fwhfix(irs)*1
        common/fwcntr/ fwhfix
c
!DEC$ IF DEFINED (G95)
      CALL get_command_argument(1,datfnm) ! Variant for G95 Fortran compiler
      open(iddmin,file=datfnm,ERR=100) 
      goto 10
!DEC$ ELSE
      open (iddmin,file=' ',ERR=100) ! Variant for other compilers
!DEC$ ENDIF
10    open(iddmout,file='ddm_out.txt ')
      open(iconout,file='ddm_sum.txt')
c
      CALL DDMINPUT
c
      if(ndec.NE.0) then
       CALL LIMITS
       CALL READFF
      end if
      CALL ITER
c
      CALL EXPUT
c
      close(iddmin)
      close(iddmout)
      close(iconout)
c
      write(0,*) ' DDM terminated.'
      STOP
100   write(0,'(/A)') 'Command Line: DDM.exe InputFile.ddm'
      END PROGRAM DDM
C
      SUBROUTINE DDMINPUT
      INCLUDE 'DDM.inc'

      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS), cntyp
      integer*1 intyp(4)
      equivalence(intyp(1), cntyp(1:1))
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/CELLX/AA,B,C,ALPHA,BETA,GAMMA,AL(3,3)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      integer*4 IREFG
      COMMON/REFG/NSM,NLV,ISM(3,3,48),IT(3,48),LV(3,5),IREFG(IRS)
      DIMENSION XRYZ(10),BACK(6),FBACK(6),ABSORP(3),FABSOR(3)
      EQUIVALENCE (GLB(1),ZER),(GLB(2),BACK(1))
      EQUIVALENCE (GLB(10),DISP),(GLB(11),SHASM) 
      EQUIVALENCE (GLB(12),ABSORP(1)),(AGLB(12),FABSOR(1)) 
      EQUIVALENCE (AGLB(1),FLGZER),(AGLB(2),FBACK(1))
      EQUIVALENCE (AGLB(10),FLDISP),(AGLB(11),FLTRNS)
      DATA XRYZ(1), XRYZ(2),  XRYZ(3),  XRYZ(4),  XRYZ(5)
     *   /2.748510,2.289620, 1.935970, 1.788965, 1.540520/
      DATA XRYZ(6), XRYZ(7),  XRYZ(8),  XRYZ(9), XRYZ(10)
     * /  0.709260,0.559360, 0.215947, 0.209010, 0.180195/
      DIMENSION XYZ(3), itmp(MPH), jtmp(MPH)
      CHARACTER Rbuf*129
      character bin*6
      data bin /'binary'/
c
      do i = 1, 16
       AGLB(i) = 0.
      end do
      do i = 1, MPH
       do j = 1, npar
        APAR(i,j) = 0.
       end do
      end do
      do i = 1, NATS
       do j = 1, 11
        A(i,j) = 0.
       end do
      end do
c
      read(iddmin,1,END=99999)TITLE
1001  FORMAT(1X,A80)
1     FORMAT(BZ,A80)
      read(iddmin,'(A)',END=99999) datfnm
c  Exclude leading spaces
       j = 0
       do i = 1, 128
        if((j.EQ.0).AND.(datfnm(i:i).EQ.' ')) cycle
        j = j+1
        Rbuf(j:j) = datfnm(i:i)
       end do
       Rbuf(j+1:j+1)=CHAR(0)
c
      read(iddmin,*,END=99999,ERR=19999)
     * JOBTYP,NPROF,NPHASE,NBCKGD,NEXCRG,NSCAT,INSTRM,IPREF,iSzStr
c  Open data file
      if(INSTRM.EQ.2.OR.INSTRM.LT.0) then ! For XRDML
!DEC$ IF DEFINED (G95)
       open(idatain,file=Rbuf,ACCESS='stream',STATUS='OLD',ERR=99998) ! For G95
       goto 1002
!DEC$ ELSE
       open(idatain,file=Rbuf,FORM=bin,STATUS='OLD',ERR=99998)
!DEC$ ENDIF
      else
       open(idatain,file=Rbuf)
      end if
1002  IF(NPHASE.EQ.0)NPHASE=1 
      JOBTYP=JOBTYP+1
      NPROF=NPROF+1 
      write(iddmout,3)
3     FORMAT(/,' Powder Diffraction Analysis Program DDM version 1.95d',/)
      write(iddmout,1001)TITLE

      write(0,3)
      write(0,'(A/)') TITLE

      IF(JOBTYP.EQ.1)write(iddmout,4)
4     FORMAT(15H FOR X-RAY DATA )
      IF(JOBTYP.EQ.2)write(iddmout,5)
      IF(JOBTYP.EQ.3)write(iddmout,6)
6     FORMAT(25H PATTERN CALCULATION,XRAY  )
      IF(JOBTYP.EQ.4)write(iddmout,7)
7     FORMAT(28H PATTERN CALCULATION,NEUTRON  )
      IF(JOBTYP.LT.1.OR.JOBTYP.GT.4)STOP 7777
5     FORMAT(43H FOR NEUTRON DATA, NUCLEAR INTENSITIES ONLY )
      write(iddmout,9)NPHASE,NEXCRG,NSCAT
9     FORMAT(19H NUMBER OF PHASES=  ,I4,/,
     * 29H NUMBER OF EXCLUDED REGIONS=  ,I4,/,
     *  28H NUMBER OF SCATTERING SETS=  ,I4)
c      IF(NBCKGD-1)110,111,112 
c110   write(iddmout,10)
c10    FORMAT(22H POLYNOMIAL BACKGROUND)
c      GOTO 113
c111   write(iddmout,11)
c11    FORMAT(37H BACKGROUND DATA TO BE READ FROM FILE )
c      GOTO 113
c112   write(iddmout,12)NBCKGD
c12    FORMAT(39H BACKGROUND CORRECTION BY INTERPOLATION  ,
c     * 12HBETWEEN THE  ,I4,12HPOINTS GIVEN )
c113   CONTINUE
      IF(NPROF-1.EQ.0) THEN
       write(iddmout,14001) NPROF-1
14001  FORMAT (' GAUSSIAN PROFILE, NPROF = ',I4)
       ELSE IF(NPROF-1.EQ.1) THEN
       write(iddmout,14002)NPROF-1
14002  FORMAT (' LORENTZIAN (CAUCHY) PROFILE , NPROF = ',I4)
       ELSE IF(NPROF-1.EQ.2) THEN
       write(iddmout,14003) NPROF-1
14003  FORMAT       (' MOD 1 LORENTZIAN PROFILE , NPROF = ',I4)
       ELSE IF(NPROF-1.EQ.3) THEN
       write(iddmout,14004) NPROF-1
14004  FORMAT (' MOD 2 LORENTZIAN PROFILE , NPROF = ',I4)
       ELSE IF(NPROF-1.EQ.4) THEN
       write(iddmout,14005) NPROF-1
14005  FORMAT (' THIS CHOICE NOT AVAILABLE ',I4)
       STOP
       ELSE IF(NPROF-1.EQ.5) THEN
       write(iddmout,14006) NPROF-1
14006  FORMAT (' PSEUDO-VOIGT (PV) PROFILE , NPROF = ',I4)
       ELSE IF(NPROF-1.EQ.6) THEN
       write(iddmout,14007) NPROF-1
14007  FORMAT (' PEARSON VII PROFILE , NPROF = ',I4)
       ELSE IF(NPROF-1.EQ.7) THEN
       write(iddmout,14008)NPROF-1
14008  FORMAT (' THOMPSON-COX-HASTINGS (PV) PROFILE , NPROF = ',I4)
      END IF

      IF (IPREF.EQ.0) THEN
         write(iddmout,7445)
      ELSE
         write(iddmout,7446)
      ENDIF
7445  FORMAT (1X,'IPREF=0, UDA-RIETVELD PREFERRED ORIENTATION FUNCTION')
7446  FORMAT(1X,'IPREF=1,MARCH-DOLLASE PREFERRED ORIENTATION FUNCTION')
c
      Rbuf = ' 0 1 1 0 1 0 0 0 0 0'
      READ(Rbuf,*) IWP,IPL,IPC,MAT,NXT,LST1,LST2,LST3,LST4,IFWE
      read(iddmin,'(A)',END=99999) Rbuf
      READ(Rbuf,*,ERR=88880)
     * IWP,IPL,IPC,MAT,NXT,LST1,LST2,LST3,LST4
88880 IF(IPC.NE.0) write(iddmout,*) 'OUTPUT REFLECTION LISTING'
      IF(MAT.NE.0.AND.JOBTYP.LT.3)write(iddmout,19)
19    FORMAT(26H OUTPUT CORRELATION MATRIX )
      IF(NXT.NE.0.AND.JOBTYP.LT.3)write(iddmout,20)
20    FORMAT(24H GENERATE NEW INPUT FILE )
c
      bkcurv=0
      read(iddmin,'(A)',END=99999) Rbuf
      READ(Rbuf,*,ERR=88800)
     * WLAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,SAMPLE,bkcurv
         go to 88801
88800 READ(Rbuf,*,ERR=29999)
     * WLAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,SAMPLE
c
88801 write(iddmout,24)WLAMDA
24    FORMAT(14H WAVELENGTHS=  ,2F8.4)
      RATIO(1)=1.
      write(iddmout,223)RATIO(2)
223   FORMAT(23H ALPHA2:ALPHA1 RATIO =  ,F8.4)
      DO 109 IX=1,10
      IF(1.03*WLAMDA(1).GT.XRYZ(IX))GOTO 119
109     CONTINUE
119   IXRAY=IX
      write(iddmout,26) WDT
26    FORMAT(23H BASE OF PEAK = 2.0*HW*,F8.2)
      write(iddmout,27)CTHM
27    FORMAT(27H MONOCHROMATOR CORRECTION =,F8.4) 
      write(iddmout,29)RLIM
29    FORMAT(43H ASYMMETRY CORRECTION FOR ANGLES LESS THAN ,F8.3,
     * 8H DEGREES ) 
c
      Rbuf = ' 1 .3 1. .3 .5 1.'
      READ(Rbuf,*) MCYCLE, EPS, RELAX
      read(iddmin,'(A)',END=99999) Rbuf
      READ(Rbuf,*,ERR=88881) MCYCLE, EPS, RELAX
c
88881 IF(JOBTYP.GT.2)MCYCLE=1
      write(iddmout,31)MCYCLE
31    FORMAT(20H NUMBER OF CYCLES =  ,I4)
      write(iddmout,32)RELAX
32    FORMAT(19H RELAXATION FACTORS,/,17H FOR COORDINATES=,F5.2,
     * /,36H FOR ANISOTRPIC TEMPERATURE FACTORS= ,F5.2,/,
     *  22H FOR FWHM PARAMETERS= ,F5.2,/,
     *   23H FOR LATTICE CONSTANTS= ,F5.2)
      write(iddmout,33)EPS
33    FORMAT(11H EPS-VALUE=,F6.1)
      ndec = 0 
      MAXSi = 0
      cddm = 1.
      wddm = 1.
      iwght = 1
      read(iddmin,'(A)',END=99999) Rbuf
      READ(Rbuf,*,ERR=88804) ndec, MAXSi, wddm, cddm, iwght
      go to 88805
88804 READ(Rbuf,*,ERR=69999) ndec, MAXSi, wddm, cddm
88805 MAXS = MAXSi
      IF(JOBTYP.GT.2)MAXS=0
      write(iddmout,44)MAXS
44    FORMAT(29H NUMBER OF PARAMETERS VARIED= ,I5)
      if(cddm.EQ.0) then
       write(iddmout,'(/'' Rietveld refinement''/)')
      else
       write(iddmout,'(/'' DDM refinement''/)')
       write(iddmout,'(2(A,F9.4),A,I3/)')
     *  ' WDDM:', wddm,'  CDDM:', cddm,'  IWGHT:', iwght
      end if
c
      read(iddmin,'(A)',END=99999) Rbuf
      read(Rbuf,*,END=99999,ERR=79999) ZER,DISP,SHASM,ABSORP
      read(iddmin,'(A)',END=99999) Rbuf
      read(Rbuf,*,ERR=88873) FLGZER,FLDISP,FLTRNS,FABSOR
c
88873 read(iddmin,*,END=99999,ERR=89999) BACK
      read(iddmin,'(A)',END=99999) Rbuf
      READ(Rbuf,*,ERR=88883) FBACK
c
88883 write(iddmout,52) BACK,BKPOS
52    FORMAT(22H Background parameters,/,6G12.6,/
     * ' Origin of background polynomial at',F8.3,' 2Theta degrees')
c
c49    IF(NBCKGD.LT.2)GOTO 120 
c      read(iddmin,*,END=99999,ERR=39999)(POS(I),BCK(I),I=1,NBCKGD)
c      write(iddmout,35)(POS(I),BCK(I),I=1,NBCKGD)
c35    FORMAT(12H Background ,/,9H Position,4X,9HIntensity,/,
c     * 20(2F9.4,/)) 
120   IF(NEXCRG.LE.0)GOTO 122 
      read(iddmin,*,END=99999,ERR=49999)(ALOW(I),AHIGH(I),I=1,NEXCRG)
      write(iddmout,37)(ALOW(I),AHIGH(I),I=1,NEXCRG)
37    FORMAT(18H Excluded regions /5H From,5X,2HTo/,20(2F9.4,/))
122   IF(NSCAT.LE.0)GOTO 124
      DO 125 I=1,NSCAT
        read(iddmin,*,END=99999,ERR=59999)NAM(I),DFP(I),DFPP(I),XMAS(I),AMAC(I)
        IF(JOBTYP.EQ.2.OR.JOBTYP.EQ.4)GOTO 125
        K=0
126     read(iddmin,*,END=99999,ERR=59999)(AC(J,I),J=1,9)
        IF(AC(1,I).EQ.-100.) CALL COEF(I,K)
        IF(AC(3,I).NE.0.)GOTO 125
        K=K+1
        POSI(K)=AC(1,I)
        SCAT(K)=AC(2,I)
        IF(K.LE.29)GOTO126
        write(iddmout,40) 
40      FORMAT(34H TOO MANY SCATTERING TABLE ENTRIES )
        STOP 7700
125     CONTINUE
      IF(JOBTYP.EQ.1.OR.JOBTYP.EQ.3)GOTO 129
      write(iddmout,422)
422   FORMAT(/19H Scattering lengths)
      write(iddmout,423)(NAM(I),DFP(I),I=1,NSCAT)
423   FORMAT(5H For ,A4,5H     ,F10.6)
      DO 424 I=1,NSCAT
        DO 425 J=1,9
425       AC(J,I)=0.
424     DFPP(I)=0.
      GOTO 124
129   write(iddmout,42)
42    FORMAT(/12H Formfactors)
      write(iddmout,41)
     * (NAM(I),DFP(I),DFPP(I),XMAS(I),(AC(J,I),J=1,9),I=1,NSCAT)
41    FORMAT(5H For ,A4,5H DFP:,F10.6,6H DFPP:,F10.6,6H XMAS:,F10.6,/,
     * 14H Coefficients: ,9F10.6)
124   CONTINUE
c
      if(iSzStr.EQ.0) then
       do i = 1, 4
        UZXYS(i) = 0.
       end do
      end if
      if((NPROF.EQ.8).AND.(iSzStr.EQ.1))
     * read(iddmin,*,END=99999,ERR=90999) UZXYS
c
      write(iddmout,46)ZER,FLGZER
46    FORMAT(/12H Zero-point: ,F9.4,F8.2) 
      write(iddmout,7100) DISP,SHASM
7100  FORMAT (' Displacement peak shift parameter:',F10.4
     * ,/,' Asymmetry peak shift parameter:',F10.4)
      write(iddmout,7101) ABSORP
7101  FORMAT (' Absorption parameters:',3F10.4)
c
      if(INSTRM.EQ.1.OR.INSTRM.EQ.0) read(idatain,*,END=99998) THMIN,STEP,THMAX
      if(INSTRM.EQ.2.OR.INSTRM.LT.0) CALL READXRDML(-INSTRM)
      NPTS=(THMAX-THMIN)/STEP+1.5
      if(INSTRM.EQ.3.OR.INSTRM.EQ.4) CALL READXYE(INSTRM)
      IF (NPTS.GT.IDSZ) THEN
        write(iddmout,1000) IDSZ,NPTS
c        write(iconout,1000) IDSZ,NPTS
1000    FORMAT(1X,'PROGRAM CAN HANDLE ',I5,'POINTS',/,
     *      1X,I5,' POINTS WERE INPUT',/,
     *        ' INCREASE IDSZ IN PARAMETER STATEMENT')
        STOP ' TOO MANY DATA POINTS '
      ENDIF
      if(INSTRM.EQ.0) read(idatain,*,END=99998) (Y(I), I=1,NPTS)
      if(INSTRM.EQ.1) read(idatain,*,END=99998) (Y(I), VAR(I), I=1,NPTS)
      iddm = cddm*0.5/STEP
      if(iddm.GE.mddm/2) iddm = mddm/2-1
c
      do I=1,NPTS
       if(Y(I).LE.0) Y(I) = 1
       if((INSTRM.NE.1).AND.(INSTRM.NE.4)) VAR(I) = Y(I)
       if(cddm.EQ.0.AND.iwght.EQ.1) VAR(I) = VAR(I)*VAR(I) ! Rietveld, squared weighting
       TH=THMIN+STEP*float(I-1)
       if(SAMPLE.LT.0.AND.ABS(SAMPLE).GT.TH) then
        st = (1.+(.0128+.0106*(SAMPLE+TH))*(SAMPLE+TH))
        Y(I) = Y(I)*st
        VAR(I) = VAR(I)*st*st
       end if
       if(CTHM.LT.0) then
        TH=TH*0.0087266462599716478846184538424431
        TH=sin(TH)*sin(2*TH)
        Y(I) = Y(I)*TH
        VAR(I) = VAR(I)*TH*TH
       end if
      end do
c
	close(idatain)
      CALL INTERV
c
c
c      IF(NBCKGD-1)474,475,476 
c475   open(idatain,file='ddm_bckgr',STATUS='OLD',ERR=4475)
c      READ(idatain,*,END=99997)(BKM(I),I=1,NPTS)
c      close(idatain)
c      GOTO 474
c4475  write(0,*) "No ddm_bckgr file found!"
c474   DO 473 I=1,NPTS
c        TH=THMIN+STEP*float(I-1)
c        THX=TH/BKPOS-1.
c        BK(I)=BACK(1)+BKM(I)
c        DO 473 J=2,6
c473       BK(I)=BK(I)+BACK(J)*THX**(J-1)
c      GOTO 477
c476   DIFB=POS(1)-THMIN
c      IF(DIFB)4760,4761,4761
c4761  NBX=DIFB/STEP+2.5
c      DO 4762 I=1,NBX
c4762    BK(I)=BCK(1)
c      NXX=1
c      GOTO 4764
c4760  NBX=(POS(2)-THMIN)/STEP+1.5
c      BK(1)=BCK(1)-DIFB/(POS(2)-POS(1))*(BCK(2)-BCK(1))
c      BSTEP=STEP/(POS(2)-POS(1))*(BCK(2)-BCK(1))
c      DO 4763 I=2,NBX
c4763    BK(I)=BK(I-1)+BSTEP
c      NXX=2
c4764  NBC=NBCKGD-1
c      IF(POS(NBCKGD).GE.THMAX)GOTO 4767 
c      POS(NBCKGD+1)=THMAX
c      BCK(NBCKGD+1)=BCK(NBCKGD)
c      NBC=NBC+1
c4767  DO 4765 J=NXX,NBC
c        BSTEP=STEP*(BCK(J+1)-BCK(J))/(POS(J+1)-POS(J))
c        NINC=(POS(J+1)-POS(J))/STEP+1.5 
c        N2X=MIN0(NPTS,NBX+NINC)
c        DO 4766 I=NBX,N2X
c4766      BK(I)=BK(I-1)+BSTEP 
c        NBX=N2X
c        IF(NBX.EQ.NPTS)GOTO 477
c4765    CONTINUE
c
c477   CONTINUE
c
      do K=1,NPHASE
        IC(K)=0
      end do
c
      KREF=0   ! Counter of refinable parameters
c
      IBFILE = 0
      IQPA = 0
      IGEO = 0
      do
       read(iddmin,'(A)',END=99999) Rbuf
c
       if(Rbuf(1:6).EQ.'$BFILE') then
        do i = 8, 127
         if(Rbuf(i:i).NE.' ') exit
        end do
        bacfnm = Rbuf(i:128)
        CALL READXYE(0)
        IBFILE = 1
        cycle
       end if
c
       if(Rbuf(1:4).EQ.'$QPA') then
        SWT  = 0.
        DIFC = 0.
        TPS  = 0.
        OMAC = 0.
        read(Rbuf(5:80),*,ERR=91099) SWT,DIFC,TPS,OMAC
        IQPA = 1
        cycle
       end if
c
       if(Rbuf(1:6).EQ.'$IGEOM') then
        read(Rbuf(8:80),*,ERR=92099) IGEO
        cycle
       end if
c
       exit
      end do
c
      do I=1,NPTS
       TH=THMIN+STEP*float(I-1)
       THX=TH/BKPOS-1.
       BK(I)=BACK(1)+BKM(I)
       do J=2,6
        BK(I)=BK(I)+BACK(J)*THX**(J-1)
       end do
      end do
c
      read(Rbuf,'(A)') PHSNM(1)
      DO 81 K=1,NPHASE
       if(K.GT.1)
     *  read(iddmin,'(A)',END=99999) PHSNM(K)
       write(iddmout,47)K,PHSNM(K) 
47     FORMAT(/,'======================================================='
     *         ,/,7H PHASE ,I2,2H: ,A70,/,
     *	'=======================================================',/)
       PARS(K) = 1.
       read(iddmin,'(A)',END=99999) Rbuf
       READ(Rbuf,*,ERR=88844)
     * NATOM(K),ifur(K),ndpar(K),(PREF(K,I),I=1,3),PARS(K)
       go to 88855
88844  READ(Rbuf,*,ERR=91999)
     * NATOM(K),ifur(K),ndpar(K),(PREF(K,I),I=1,3)
88855  N=NATOM(K)
       write(iddmout,480)N,ifur(K),ndpar(K),(PREF(K,I),I=1,3)
480    FORMAT(18H Number of atoms: ,I3,/,20H Fourier output flag ,
     *     9H (IFUR): ,I2,9H  NDPAR: ,I4,/,
     *     30H Preferred orientation vector:  ,3F8.4)
       read(iddmin,'(20A1)',END=99999) (HMSYMB(K)(I:I),I=1,20)
C-----READ AND PRINT FOR EACH ATOM
       IOF=0
       IF(K.GT.1) THEN
        DO 4325 IIPHAS=2,K
4325      IOF = IOF + NATOM(IIPHAS-1) 
        END IF
       do I = 1, N
        IANIS(I+IOF)=0
        ADIST(I+IOF)=0.
        read(iddmin,'(A)',END=99999) Rbuf
        READ(Rbuf,*,ERR=88884) ATEXT(I+IOF),NTYP(I+IOF),
     *    (XL(I+IOF,J),J=1,5), IANIS(I+IOF), ADIST(I+IOF)
        go to 88885
88884   READ(Rbuf,*,ERR=92999) ATEXT(I+IOF),NTYP(I+IOF),
     *    (XL(I+IOF,J),J=1,5)
c
c  Lowercase to Uppercase
88885    cntyp = NTYP(I+IOF)
         do j = 1, 4
          if(cntyp(j:j).GT.'Z') intyp(j) = intyp(j) - 32
         end do
         NTYP(I+IOF) = cntyp
c
         read(iddmin,'(A)',END=99999) Rbuf
         READ(Rbuf,*,ERR=88886) (A(I+IOF,J),J=1,5)
c
88886    if(IANIS(I+IOF).EQ.1) then
          read(iddmin,*,END=99999,ERR=93999) (XL(I+IOF,J),J=6,11)
          read(iddmin,'(A)',END=99999) Rbuf
          READ(Rbuf,*,ERR=88887) (A(I+IOF,J),J=6,11)
88887     continue
         else
          do j = 6, 11
           XL(I+IOF,J) = 0.
          end do
         end if
       end do               
c
       CALL SYMGEN(K)
c        
       write(iddmout,57) 
57     FORMAT(/25H ***INITIAL PARAMETERS***//13H Atom  NTYP  ,
     *  6X,1HX,9X,1HY,9X,1HZ,9X,1HB,9X,1HN)
       write(iddmout,170)
     * (ATEXT(I+IOF),NTYP(I+IOF),(XL(I+IOF,J),J=1,5), I=1,N)
170    FORMAT(1X,A4,2X,A4,2X,3F10.5,2F10.4) 
       iprint = 0
       do I = 1, N
        if(IANIS(I+IOF).EQ.1) then
         if(iprint.EQ.0) write(iddmout,
     * '(/5H Atom,4X,3HB11,7X,3HB22,7X,3HB33,7X,3HB12,7X,3HB13,7X,3HB23)')
         iprint = 1
         write(iddmout,'(1X,A4,1X,6F10.5)') ATEXT(I+IOF),(XL(I+IOF,J),J=6,11)
        end if
       end do
       read(iddmin,*,END=99999,ERR=94999) PAR(K,1), PAR(K,2)
       read(iddmin,'(A)',END=99999) Rbuf
       READ(Rbuf,*,ERR=88888) APAR(K,1),APAR(K,2)
88888  read(iddmin,*,END=99999,ERR=95999)
     *  PAR(K,3),PAR(K,4),PAR(K,5),PAR(K,20),PAR(K,15),PAR(K,16)
       read(iddmin,'(A)',END=99999) Rbuf
       READ(Rbuf,*,ERR=88889)
     *  APAR(K,3),APAR(K,4),APAR(K,5),APAR(K,20),APAR(K,15),APAR(K,16)
88889  LAU1(K) = 0.0
       read(iddmin,'(A)',END=99999) Rbuf
       read(Rbuf,*,ERR=88899) (PAR(K,I),I=6,11), LAU1(K)
       go to 88890
88899  read(Rbuf,*,ERR=96999) (PAR(K,I),I=6,11)
88890  read(iddmin,'(A)',END=99999) Rbuf
       read(Rbuf,*,ERR=88810) (APAR(K,I),I=6,11)
c     Read PREF1 PREF2 ASYM1 ASYM2
       PAR(K,12) = 0.
       PAR(K,13) = 0.
       PAR(K,14) = 0.
       PAR(K,48) = 0.
       PAR(K,49) = 0.
88810  read(iddmin,'(A)',END=99999) Rbuf
       READ(Rbuf,*,ERR=88910) PAR(K,12), PAR(K,13),
     *  PAR(K,14), PAR(K,48), PAR(K,49)
88910  read(iddmin,'(A)',END=99999) Rbuf
       READ(Rbuf,*,ERR=88811) APAR(K,12), APAR(K,13),
     *  APAR(K,14), APAR(K,48), APAR(K,49)
88811  read(iddmin,*,END=99999,ERR=98999)  PAR(K,17),PAR(K,18),PAR(K,19)
       read(iddmin,'(A)',END=99999) Rbuf
       READ(Rbuf,*,ERR=88812)  APAR(K,17),APAR(K,18),APAR(K,19)
        fwhmlim(K,1)=0.1
        fwhmlim(K,2)=0.2
       ians(K,3) = 0
88812  read(iddmin,'(A)',END=99990) Rbuf
       READ(Rbuf,*,ERR=99990)  fwhmlim(K,1), fwhmlim(K,2), ians(K,3)
        fwhmlim(K,1)=0. ! Temporarily disabled for the WEB-release
        fwhmlim(K,2)=0.
C
99990  do i = 21, 47
        PAR(K,i) = 0.
        APAR(K,i) = 0.
       end do
C
       ians(K,1) = 0
       read(iddmin,*,END=99991) (PAR(K,I),I=21,26)
       read(iddmin,'(A)',END=99991) Rbuf
       READ(Rbuf,*,ERR=99991) (APAR(K,I),I=21,26)
c  To avoid correlations between pref. orient. ellipsoid and scale factor
99991  if(APAR(K,1)*APAR(K,21)*APAR(K,22)*APAR(K,23).NE.0) then
        i = 0
        do kk = 1,NPHASE
         if(APAR(K,21).GT.1.AND.APAR(K,21).EQ.APAR(kk,21)) i = 1
        end do
        if(i.EQ.0) APAR(K,1)=0
       end if
       sy = 0.
       do i = 21, 26
        sy = sy + abs(PAR(K,i)) + abs(APAR(K,i))
       end do
       if(sy.GT.0) ians(K,1) = 1
C 
       read(iddmin,*,END=99992) (PAR(K,I),I=27,32)
       read(iddmin,'(A)',END=99992) Rbuf
       READ(Rbuf,*,ERR=99992) (APAR(K,I),I=27,32)
99992  sy = 0.
       do i = 27, 32
        sy = sy + abs(PAR(K,i)) + abs(APAR(K,i))
       end do
       if(sy.GT.0) ians(K,2) = 1
C 
       read(iddmin,*,END=99995) (PAR(K,I),I=33,38)
       read(iddmin,'(A)',END=99995) Rbuf
       READ(Rbuf,*,ERR=99995) (APAR(K,I),I=33,38)
99995  sy = 0.
       do i = 33, 38
        sy = sy + abs(PAR(K,i)) + abs(APAR(K,i))
       end do
       if(sy.GT.0.AND.ians(K,3).EQ.0) ians(K,3) = 1 ! Ellips-model
       if(abs(ians(K,3)).EQ.2) then   ! Stephens-model
        read(iddmin,*,END=99906) (PAR(K,I),I=39,44)
        read(iddmin,'(A)',END=99906) Rbuf
        READ(Rbuf,*,ERR=99906) (APAR(K,I),I=39,44)
        read(iddmin,*,END=99906) (PAR(K,I),I=45,47)
        read(iddmin,'(A)',END=99906) Rbuf
        READ(Rbuf,*,ERR=99906) (APAR(K,I),I=45,47)
       end if
C
c        IF(NPROF.NE.8) THEN
c           PAR(K,20)=0.
c          APAR(K,20)=0. 
c        END IF
99906  write(iddmout,66) PAR(K,1),PAR(K,2),
     * PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,20),PAR(K,15),PAR(K,16),
     *         (PAR(K,I),I=6,11),
     *   PAR(K,12),PAR(K,13),PAR(K,14),PAR(K,48),PAR(K,49),
     *   PAR(K,17),PAR(K,18),PAR(K,19)
66      FORMAT(/' Overall scale factor=',G12.5,/,
     *    ' Overall B=',F10.4,/,' FWHM terms=',6(1X,E10.4E1),/,' Lattice
     * constants=',6F9.4,/,' Preferred orientation parameters=',2F10.4,/
     *   ,          ' Asymmetry parameters=',3(1X,F10.5),/,
     * ' Peak shape parameters= ',3F10.4)
c
       XFAC = 3.141592654 / 180.000000
       DCA1 = XFAC * PAR(K,9)
       DCA2 = XFAC * PAR(K,10)
       DCA3 = XFAC * PAR(K,11)
       VOL(K) = PAR(K,6) * PAR(K,7) * PAR(K,8) *
     * SQRT(1-COS(DCA1)**2-COS(DCA2)**2-COS(DCA3)**2 +
     * 2 * COS(DCA1) * COS(DCA2) * COS(DCA3))
        if(ians(K,1).NE.0) 
     *   write(iddmout,'('' Pref-Orient. Anisotropy:'',/,6(1X,E12.4))')
     *   (PAR(K,I), I=21,26)
        if(ians(K,2).NE.0) 
     *   write(iddmout,'('' Crystal Size Anisotropy:'',/,6(1X,E12.4))')
     *   (PAR(K,I), I=27,32)
        if(ians(K,3).NE.0) 
     *   write(iddmout,'('' Microstrain  Anisotropy:'',/,6(1X,E12.4))')
     *   (PAR(K,I), I=33,38)
        if(abs(ians(K,3)).EQ.2)
     *   write(iddmout,'(6(1X,E12.4),/,3(1X,E12.4),/)')
     *   (PAR(K,I), I=39,47)
c
       AA=PAR(K,6) 
       B=PAR(K,7)
       C=PAR(K,8)
       ALPHA=PAR(K,9)
       BETA=PAR(K,10)
       GAMMA=PAR(K,11)
       CALL CELL2
       DO 72 I=1,6 
72      SAVL(K,I)=PAR(K,I+5)
       DO 73 I=1,3 
73      PAR(K,I+5)=AL(I,I)
       PAR(K,9)=AL(2,3)
       PAR(K,10)=AL(1,3)
       PAR(K,11)=AL(1,2)
c       write(iddmout,82) 
c82    FORMAT(/26H ***CODING OF VARIABLES***//5H Atom,7X,1HX,9X,1HY,9X,1HZ
c     * ,9X,1HB,9X,1HN)
C-----PRINT CODEWORDS FOR ATOMIC PARAMETERS
c       write(iddmout,'(1X,A4,4F10.2,F10.4)')
c     * (ATEXT(I+IOF),(A(I+IOF,J),J=1,5), I=1,N)
c       iprint = 0
       DO 83 I=1,N 
c        if(IANIS(I+IOF).EQ.1) then
c         if(iprint.EQ.0) write(iddmout,
c     * '(/5H Atom,5X,3HB11,5X,3HB22,5X,3HB33,5X,3HB12,5X,3HB13,5X,3HB23)')
c         iprint = 1
c         write(iddmout,'(1X,A4,1X,6F8.2)') ATEXT(I+IOF),(A(I+IOF,J),J=6,11)
c        end if
        DO 84 J=1,11
         X=A(I+IOF,J)
         IYY=INT(ABS(X)/10.)
         IF(IYY.GT.MSZ) GO TO 99996
         LP(I+IOF,J)=IYY
84       A(I+IOF,J)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
83     CONTINUE
C-----PRINT CODEWORDS FOR PROFILE PARAMETERS
c       write(iddmout,89)  APAR(K,1),APAR(K,2),
c     *  APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,20),APAR(K,15),APAR(K,16),
c     *          (APAR(K,I),I=6,11),
c     *  APAR(K,12),APAR(K,13),APAR(K,14),APAR(K,48),
c     *  APAR(K,17),APAR(K,18),APAR(K,19)
c89     FORMAT(/' Overall scale factor:',F8.2,/' Overall B: ',F8.2,/,
c     *           ' FWHM terms:',6F8.2,/,
c     *              ' Lattice constants: ',6F8.2,/,
c     *                 ' Preferred orientation parameters:  ',2F8.2,/,
c     *                    ' Asymmetry parameters: ',2F8.2,/,
c     *      ' Peak shape parameters:',3F8.2)
c        if(ians(K,1).NE.0) 
c     *   write(iddmout,'('' Pref-Orient. Anisotropy:'',/,6(F10.2))')
c     *   (APAR(K,I), I=21,26)
c        if(ians(K,2).NE.0) 
c     *   write(iddmout,'('' Crystal Size Anisotropy:'',/,6(F10.2))')
c     *   (APAR(K,I), I=27,32)
c        if(ians(K,3).NE.0) 
c     *   write(iddmout,'('' Microstrain  Anisotropy:'',/,6(F10.4))')
c     *   (APAR(K,I), I=33,38)
c        if(abs(ians(K,3)).EQ.2)
c     *   write(iddmout,'(6(F10.4),/,3(F10.4),/)')
c     *   (APAR(K,I), I=39,47)
c
       DO 87 I=1,npar
        X=APAR(K,I)
        IYY=INT(ABS(X)/10.) 
        LPAR(K,I)=IYY
87      APAR(K,I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
151     CALL LOOKUP(K,NATOM(K),NSCAT,
     *   (WLAMDA(1)+WLAMDA(2)*RATIO(2))/(1+RATIO(2)),JOBTYP)
        U=PAR(K,3)
        V=PAR(K,4)
        W=PAR(K,5)
        ZZZ = PAR(K,20)
        IF (NPROF.EQ.8) THEN
         ULOR=PAR(K,15)
         VLOR=PAR(K,16)
        END IF
c
        CALL REFGEN(K,ZER,DISP,SHASM,PREF,PAR(K,12))
c
        do I = 1, N
        if(XL(I+IOF,5).EQ.-1.) then
         do j = 1, 3
          XYZ(j) = XL(I+IOF,j)
         end do
         XL(I+IOF,5) = MULPOS(K,XYZ)
        end if
       end do
       ICY=1
       ICZ=0
       DO 4101 IIPHAS=1,K
4101     ICZ = ICZ + IC(IIPHAS)
       IF(K.GE.2) ICY=1+ICZ-IC(K)
81    CONTINUE ! End of NPHASE loop
c
c For accuracy calculations
      if((LST3.GT.0).AND.(NPHASE.GT.1)) then
       NPHASE = NPHASE - 1 
       NXT = 0
      end if
c
      DO 88 I=1,16
        X=AGLB(I)
        IYY=INT(ABS(X)/10.)
        LGLB(I)=IYY 
88      AGLB(I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
c
67    FORMAT(BZ,4F8.2)
76    FORMAT(16H CELL CONSTANTS=,6F12.8)
77    FORMAT(BZ,2F8.4)
86    FORMAT(BZ,8F8.2)
c      IF (JOBTYP.GT.2) RETURN 
c
      NATOMS = 0
      do K=1,NPHASE
       itmp(K) = 0
       jtmp(K) = 0
       if(ndpar(K).NE.0) then
        do i = 1, NATOM(K)
         do j = 1, 11
          if(LP(i+NATOMS,j).EQ.IABS(ndpar(K))) then
           itmp(K) = i+NATOMS
           jtmp(K) = j
          end if
         end do
        end do
        if(itmp(K).EQ.0.AND.jtmp(K).EQ.0) ndpar(K) = 0
       end if
       NATOMS = NATOMS + NATOM(K)
      end do

c
      KNUM=0
      do I=1,16
       if(LGLB(I).GT.KNUM) KNUM = LGLB(I)
      end do
      do I=1,NATOMS
       do J=1,11
        if(LP(I,J).GT.KNUM) KNUM = LP(I,J)
       end do
      end do
      do K=1,NPHASE
       do I=1,npar
        if(LPAR(K,I).GT.KNUM) KNUM = LPAR(K,I)
       end do
      end do
c
      do K=1,NPHASE
       CALL SETSYM(K,KNUM) ! Set symmetry restrictions 
      end do
c
      NATOMS = 0  ! Riding constraint
      do K=1,NPHASE
       do i = 1, NATOM(K)
        if(ATEXT(i+NATOMS)(1:1).EQ.'+') then
         IAT = i
         CALL GEOM(K,0,0,0,IAT)
         if(IAT.GT.0) then
          if(LP(IAT+NATOMS,4).EQ.0) then
           KNUM = KNUM + 1
           LP(IAT+NATOMS,4) = KNUM
          end if
          do j = 1, 3
           LP(i+NATOMS,j) = LP(IAT+NATOMS,j)
           A(i+NATOMS,j) = A(IAT+NATOMS,j)
          end do
           LP(i+NATOMS,4) = LP(IAT+NATOMS,4)
           A(i+NATOMS,4) = A(IAT+NATOMS,4)
           XL(i+NATOMS,4) = XL(IAT+NATOMS,4)
         end if
        end if
       end do
       NATOMS = NATOMS + NATOM(K)
      end do
c
      N = 0
      do I=1,16
       CALL NUMCW(LGLB(I),1,I,0,NATOMS) ! Remove singular numbered codeword
       if(LGLB(I).NE.0) N = N + 1 ! Count if yet numbered
      end do
      do I=1,NATOMS
       do J=1,11
        CALL NUMCW(LP(I,J),2,I,J,NATOMS)
        if(LP(I,J).NE.0) N = N + 1
       end do
      end do
      do K=1,NPHASE
       do I=1,npar
        CALL NUMCW(LPAR(K,I),3,K,I,NATOMS)
        if(LPAR(K,I).NE.0) N = N + 1
       end do
      end do
      call CWORDS(N) ! Arrange codeword numbers
C
      KREF=0   ! Counter of refinable parameters
      KNUM=0   ! Counter of numbered parameters
c
      do I=1,16
       if((LGLB(I).EQ.0).AND.(AGLB(I).NE.0)) then
         LGLB(I) = NKREF(KREF, NATOMS)
       else if(LGLB(I).GT.KNUM) then
         KNUM = LGLB(I)
       end if
      end do
      do I=1,NATOMS
        do J=1,11
          if((LP(I,J).EQ.0).AND.(A(I,J).NE.0)) then
           LP(I,J) = NKREF(KREF, NATOMS)
          elseif (LP(I,J).GT.KNUM) then
            KNUM = LP(I,J)
          end if
        end do
      end do
      do K=1,NPHASE
        do I=1,npar
         if((LPAR(K,I).EQ.0).AND.(APAR(K,I).NE.0)) then
          LPAR(K,I) = NKREF(KREF, NATOMS)
         else if(LPAR(K,I).GT.KNUM) then 
           KNUM = LPAR(K,I)
         end if
        end do
      end do
C
      do K=1,NPHASE
       if(itmp(K).GT.0.AND.jtmp(K).GT.0)
     *  ndpar(K) = ISIGN(LP(itmp(K),jtmp(K)),ndpar(K))
      end do
C     COUNT NO. OF USES OF SAME LOCATION IN NORMAL MATRIX
      if(MAXS.EQ.0.AND.MCYCLE.GE.0) MAXS = MSZ
      DO I=1,MAXS
       LCOUNT = ICOUNT(NPHASE,I)
      IF (LCOUNT.GT.1)   write(iddmout,17204) I, LCOUNT
17204 FORMAT (' ******* CODEWORD ',I3,' IS USED ',I3,' TIMES **')
      END DO
C                                                             
C     CHECK FOR HOLES IN THE NORMAL MATRIX
      ISTOP=0
      DO 7200 I=1,MAXS
C
        DO 7201 J =1,16
          IF (I.EQ.LGLB(J)) GO TO 7200
7201      CONTINUE
C
        DO 7202 K=1,NPHASE
          DO 7202 J=1,npar
            IF(I.EQ.LPAR(K,J)) GO TO 7200
7202        CONTINUE
C
        DO 7203 K=1,NATOMS
          DO 7203 J=1,11
            IF(I.EQ.LP(K,J)) GO TO 7200 
7203        CONTINUE
c        write(iconout,7204) I-1
        write(iddmout,7204) I-1
c        write(iconout,7205) KNUM
        write(iddmout,7205) KNUM
7204    FORMAT (/5X,'***** THE ACTUAL NUMBER OF REFINABLE PARAMETERS IS'
     *  I4,1X,'*****')
7205    FORMAT (18X,'The last numbered parameter is ',I4/)
        ISTOP = 1
        MAXS=I-1
        go to 7222
7200    CONTINUE
      IF (ISTOP.EQ.1) STOP 'HOLE IN THE MATRIX'
7222    CONTINUE
C     END CHECKING FOR HOLES IN THE NORMAL MATRIX
      write(iddmout,'(/''*** NUMBERING OF PARAMETERS ***''/)')
      write(iddmout,'(''Zero-point:'',I4,''  Displacement peak shift:'',I4,
     *''  Asymmetry peak shift:'',I4)') LGLB(1),LGLB(10),LGLB(11)
      write(iddmout,'(''Absorption coeffs:'',3I4)')
     * LGLB(12),LGLB(13),LGLB(14)
      write(iddmout,'(''Background coeffs:'',6I4)') (LGLB(i+1), i=1,6)
c
      DO K=1,NPHASE 
       IOF=0
       DO I=2,K
        IOF = IOF + NATOM(I-1)
       END DO
       write(iddmout,47) K, PHSNM(K) 
       write(iddmout,*)
     * ' Atom   X    Y    Z  Biso   N  B11  B22  B33  B12  B13  B23'
       write(iddmout,'(1X,A4,11I5)')
     * (ATEXT(I+IOF),(LP(I+IOF,J),J=1,11), I=1,NATOM(K))
       write(iddmout,891)  LPAR(K,1),LPAR(K,2),
     *  LPAR(K,3),LPAR(K, 4),LPAR(K,5),LPAR(K,20),LPAR(K,15),LPAR(K,16),
     *          (LPAR(K,I),I=6,11),
     *  LPAR(K,12),LPAR(K,13),LPAR(K,14),LPAR(K,48),LPAR(K,49),
     *  LPAR(K,17),LPAR(K,18),LPAR(K,19)
891     FORMAT(/' Overall scale factor:',I5,/' Overall B: ',I5,/,
     *           ' FWHM terms:',6I5,/,
     *              ' Lattice constants: ',6I5,/,
     *                 ' Preferred orientation parameters:  ',2I5,/,
     *                    ' Asymmetry parameters: ',3I5,/,
     *      ' Peak shape parameters:',3I5)
        if(ians(K,1).NE.0) 
     *   write(iddmout,'('' Pref-Orient. Anisotropy:'',/,6(I5))')
     *   (LPAR(K,I), I=21,26)
        if(ians(K,2).NE.0) 
     *   write(iddmout,'('' Crystal Size Anisotropy:'',/,6(I5))')
     *   (LPAR(K,I), I=27,32)
        if(ians(K,3).NE.0) 
     *   write(iddmout,'('' Microstrain  Anisotropy:'',/,6(I5))')
     *   (LPAR(K,I), I=33,38)
        if(abs(ians(K,3)).EQ.2)
     *   write(iddmout,'(6(I5),/,3(I5),/)')
     *   (LPAR(K,I), I=39,47)
      END DO
      write(iddmout,
     *'(/''*******************************************************''/)')
c
C     CHECK FOR NON-ZERO COUNTS AT ALL POINTS
      DO 5678 I=1,NPTS
         IF (VAR(I).LE.1.0E-6) VAR(I)= 0.0001
         IF (Y(I).LE.1.0E-6) Y(I)= 0.0001
5678    CONTINUE
      ICZ=0
      do I=1,NPHASE
       ICZ = ICZ + IC(I)
      end do
c
      CALL QPA(0)
c
      do I=1,ICZ
       FAZA=0.
       PRECOR=1.
       FDER = 1.
       CALL CALCUL(I,FAZA,PRECOR,FDER)
      end do
c
C******************* Read FWHMs from file 'ddm_fwobs' ************
      CALL READFW

      RETURN
99999 STOP 'END OF PARAMETERS FILE'
99998 STOP 'END OF DATA FILE'
99996 STOP 'Too many refinable parameters! Increase MSZ in ddm.inc.'
19999 STOP 'Error Reading LINE 2.'
29999 STOP 'Error Reading LINE 4.'
39999 STOP 'Error Reading Background POS, BCK (LINE *9.)'
49999 STOP 'Error Reading Excluded Regs ALOW, AHIGH (LINE *10.)'
59999 STOP 'Error Reading Scattering Factors (LINE *11.)'
69999 STOP 'Error Reading NDEC MAXS WDDM CDDM (LINE 7.)'
79999 STOP 'Error Reading ZER DISP SHASM ABSORP (LINE 8.1)'
89999 STOP 'Error Reading Backgroubd Coeffs (LINE 8.3)'
90999 STOP 'Error Reading US ZS XS YS (LINE *12.)'
91999 STOP 'Error Reading NATOM IFUR NDPAR PREF (LINE 13.2)'
92999 STOP 'Error Reading Atoms (LINE 13.41)'
93999 STOP 'Error Reading Aniso-Temperature Params (LINE *13.43)'
94999 STOP 'Error Reading Scale and Overall B (LINE 13.51)'
95999 STOP 'Error Reading U V W Z X Y (LINE 13.61)'
96999 STOP 'Error Reading Cell Params (LINE 13.71)'
97999 STOP 'Error Reading Pref1,2 and Asymmetry (LINE 13.81)'
98999 STOP 'Error Reading NA NB NC Peak Shape Parameters (LINE 13.91)'
91099 STOP 'Error Reading QPA entry!'
92099 STOP 'Error Reading IGEOM entry!'
      END 
c
      SUBROUTINE READXYE(MODE)
        INCLUDE 'DDM.inc'
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv

      if(MODE.EQ.0) then
       open(idatain,file=bacfnm,STATUS='OLD',ERR=200)
      else
       x0 = 0
       x1 = 0
       e0 = 1
       e1 = 1
       dxmin = 180
       n = 0
       do                                                 
        if(MODE.EQ.3) READ(idatain,*,END=10,ERR=10) x1, y1
        if(MODE.EQ.4) READ(idatain,*,END=10,ERR=10) x1, y1, e1
        if(x1.GT.x0.AND.x1.LT.180.AND.y1.GT.0.AND.e1.GT.0) then
         if(x1-x0.LT.dxmin) dxmin = x1-x0
         if(n.EQ.0) THMIN = x1
         if(n.GT.0) THMAX = x1
         x0 = x1
         n = n + 1
        else
         exit
        end if
       end do
10     if(n.LT.2) STOP 'Error Reading DATA File'
       STEP = dxmin
       if(STEP.GT.0) NPTS=(THMAX-THMIN)/STEP+1.5
       if(NPTS.GT.IDSZ) STOP ' TOO MANY DATA POINTS: INCREASE IDSZ IN ddm.inc'
       REWIND idatain
      end if
      if(MODE.LE.3) READ(idatain,*,END=100,ERR=200) x0, y0
      if(MODE.EQ.4) READ(idatain,*,END=100,ERR=200) x0, y0, e0
      do
       if(MODE.LE.3) READ(idatain,*,END=100,ERR=200) x1, y1
       if(MODE.EQ.4) READ(idatain,*,END=100,ERR=200) x1, y1, e1
       i0 = NINT((x0 - THMIN)/STEP) + 1
       i1 = NINT((x1 - THMIN)/STEP) + 1
       do i = i0, i1
        if(i.GT.NPTS) exit
        x = THMIN + (i-1)*STEP
        if(x.LT.x0) cycle
        if(MODE.EQ.0) then 
         BKM(i) = y0 + (x-x0)*(y1-y0)/(x1-x0)
        else
         Y(i) = y0 + (x-x0)*(y1-y0)/(x1-x0)
         if(MODE.EQ.3) then
          VAR(i) = Y(i)
         else
          VAR(i) = e0 + (x-x0)*(e1-e0)/(x1-x0)
          VAR(i) = VAR(i)*VAR(i)
         end if
        end if
       end do
       x0 = x1
       y0 = y1
       e0 = e1
      end do
 100  close(idatain)
      RETURN
 200  STOP 'Error Reading Background File'
      END
c
      SUBROUTINE READXRDML(NSCAN)
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     * IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv

      character*26 cfind, mask
      character*1 c
      character*14 mask1
	character*12 mask2

      data mask  /'intensities unit="counts">'/
	data mask1 /'startPosition>'/
	data mask2 /'endPosition>'/

      do i = 1, IDSZ
       y(i) = 0.
      end do
	n = 0
      do
       read(idatain,END=100,ERR=100) c
       if(c.EQ.'<') then
        read(idatain,END=100,ERR=100) cfind(1:14)
        if(cfind(1:14).EQ.mask1) then
         do i = 1, 26
          read(idatain,END=100,ERR=100) cfind(i:i)
          if(cfind(i:i).EQ.' '.OR.cfind(i:i).EQ.'<') exit
         end do
         read(cfind(1:i-1),*) THMIN
	   exit
        end if
       end if
      end do
      do
       read(idatain,END=100,ERR=100) c
       if(c.EQ.'<') then
        read(idatain,END=100,ERR=100) cfind(1:12)
        if(cfind(1:12).EQ.mask2) then
         do i = 1, 26
          read(idatain,END=100,ERR=100) cfind(i:i)
          if(cfind(i:i).EQ.' '.OR.cfind(i:i).EQ.'<') exit
         end do
         read(cfind(1:i-1),*) tend
	   exit
        end if
       end if
      end do
      nsc = 0
      do
       read(idatain,END=100,ERR=100) c
       if(c.EQ.'<') then
        read(idatain,END=100,ERR=100) cfind
        if(cfind.EQ.mask) then
        nsc = nsc + 1
        n = 1
         do
          do i = 1, 26
           read(idatain,END=100,ERR=100) cfind(i:i)
           if(cfind(i:i).EQ.' '.OR.cfind(i:i).EQ.'<') exit
          end do
          read(cfind(1:i-1),*) s
          if(NSCAN.LT.0.OR.NSCAN.EQ.nsc) y(n) = y(n) + s
          if(cfind(i:i).EQ.'<') exit
          n = n + 1
         end do
        end if
       end if
      end do
100   STEP = (tend-THMIN)/(n-1)
      THMAX = tend
      RETURN
1000  STOP 'Error in Data File!'
      END
c
      FUNCTION ICOUNT(NPHASE,I)
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     * IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
       
       LCOUNT = 0
       NATOMS = 0
       DO 17201 J =1,16
          IF (I.EQ.LGLB(J)) LCOUNT = LCOUNT + 1
17201      CONTINUE 
        DO 17202 K=1,NPHASE
         NATOMS = NATOMS + NATOM(K)
          DO 17202 J=1,npar
            IF(I.EQ.LPAR(K,J)) THEN
             LCOUNT = LCOUNT + 1
             if(LCOUNT.EQ.1) N = J
             if(LCOUNT.GT.1.AND.ABS(APAR(K,J)).NE.ABS(APAR(K,N))) 
     *        PAR(K,J) = PAR(K,N)*APAR(K,J)/APAR(K,N) ! Correct rounding biases
            END IF
17202        CONTINUE
        DO 17203 K=1,NATOMS
          DO 17203 J=1,11
            IF(I.EQ.LP(K,J)) THEN
             LCOUNT = LCOUNT + 1
             if(LCOUNT.EQ.1) N = J
             if(LCOUNT.GT.1.AND.ABS(A(K,J)).NE.ABS(A(K,N))) then
              x = XL(K,J)
              XL(K,J) = XL(K,N)*A(K,J)/A(K,N) ! Correct rounding biases
              if(J.LE.3) then
               xmin = XL(K,J)-x
               do l=-2, 2
                if(ABS(XL(K,J)+l-x).LT.ABS(xmin)) then
                 XL(K,J) = XL(K,J) + l
                 xmin = XL(K,J) - x
                end if
               end do
              end if
             end if
            END IF
17203    CONTINUE
      ICOUNT = LCOUNT
      RETURN
      END
c
      SUBROUTINE INTERV
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     * IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv

      do i=1,NPTS
       BKM(i)=0.
       if(iddm.EQ.0) cycle 
       iconv(i) = 2
       if((i.LE.2).or.(i.GE.NPTS-1)) cycle
c  Convolution intervals assignment
       ia = iddm
       if(i-ia.LT.1) ia = i - 1
       if(i+ia.GT.NPTS) ia = NPTS - i
       do while ((ia.GT.1).AND.(wddm.NE.0))
        cn0 = ia*2+1
        cn1 = ia*(ia+1)*cn0
        cn2 = (4*ia*(ia+1)-3)*cn0
        c00 = (9*ia*(ia+1)-3)/cn2 ! smoothing and deriv. coeffs
        c01 = -15./cn2  ! equals to c20         
        c10 = 3./cn1    
        c21 = 45./(cn2*ia*(ia+1))
        p0 = 0.
        p1 = 0.
        p2 = 0.
        do j=-ia,ia  ! Calculate Svitzky-Golay coefficients
         p0=p0+Y(i+j)*(c00+c01*j*j)
         p1=p1+Y(i+j)*c10*j
         p2=p2+Y(i+j)*(c01+c21*j*j)
        end do
        tj = 0.
        if(wddm.GT.0) then
c Compare the mean deviation of the polynomial from Y
c with wddm-weighted standard deviation
         do j=-ia,ia
          sy = p0+p1*j+p2*j*j-Y(i+j)
          tj  = tj + sy*sy/VAR(i+j)
         end do
         if(tj/cn0.GT.wddm*wddm) then
          ia = ia - 1
          cycle
         end if
        else
c Calculate Durbin-Watson statistics
         sy1 = p0-p1*ia+p2*ia*ia-Y(i-ia)
         sy0 = sy1*sy1
         do j= 1-ia,ia
          sy =  p0+p1*j+p2*j*j-Y(i+j)
          sy0 = sy0 + sy*sy
          tj  = tj + (sy-sy1)*(sy-sy1)
          sy1 = sy
         end do
         if(tj.eq.0.or.sy.eq.0) exit
         if(tj/sy0-4./(cn0-3.)+1./cn0.LT.4.+2.*wddm) then
          ia = ia - 1
          cycle
         end if
        end if
        exit
       end do
       iconv(i) = ia
      end do
c
      do I=3,NPTS-2
       ia = iconv(I)
       cn0 = ia*2+1
       cn1 = ia*(ia+1)*cn0
       cn2 = (4*ia*(ia+1)-3)*cn0
       c01 = -15./cn2  ! equals to c20         
       c10 = 3./cn1    
       c21 = 45./(cn2*ia*(ia+1))
       VAR1(I)=0.
       VAR2(I)=0.
       do l = -ia, ia
        c1 = l*c10
        c2 = c01+c21*l*l
        if(iwght.EQ.1) then ! Optimal weighting
         c1 = c1*sqrt(float(ia))
         c2 = c2*sqrt(float(ia))
        end if
        if(iwght.EQ.2) then ! Interval-dependent weighting
         c1 = c1*ia
         c2 = c2*ia
        end if
        VAR1(I)=VAR1(I)+VAR(I+l)*c1*c1
        VAR2(I)=VAR2(I)+VAR(I+l)*c2*c2
       end do
      end do
      RETURN
      END
c
      SUBROUTINE SYMGEN(IPH)
        INCLUDE 'DDM.inc'
C
C  SYMGEN finds Hall's equivalent of Space Group name in the SGSY table
C  and calls SGHALL that generates the symmetry matrices
C  Temporary integer symmetry matrices and vectors (ISM, IT) and
C  lattice centering vectors LV are generated for further use in REFGEN
C  The matrices are then packed to IMS integers
C
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     * IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      integer*4 IREFG
      COMMON/REFG/NSM,NLV,ISM(3,3,48),IT(3,48),LV(3,5),IREFG(IRS)
c
      CHARACTER tmp*2, symt*20, HALL*80 
      integer*1    isymt(20)
      integer*4 i4
      integer*1 i14(4)
      equivalence (isymt, symt), (i4, i14)
c	
      INCLUDE 'SGSY.INC' ! Table of Space Group symbols
c
      do i = 1, 20
       symt(i:i) = HMSYMB(IPH)(i:i)	
       if(symt(i:i).GT.'Z') isymt(i) = isymt(i) - 32 ! To Uppercase
      end do
c
      if(symt(1:4).NE.'HALL') then
c
       j = 1
       do i = 1, 20
        symt(i:i) = ' '
        if((HMSYMB(IPH)(i:i).EQ.' ').OR.(HMSYMB(IPH)(i:i).EQ.'Z').OR.
     *    (HMSYMB(IPH)(i:i).EQ.'H')) cycle
        symt(j:j) = HMSYMB(IPH)(i:i)	
        if(symt(j:j).GT.'Z') isymt(j) = isymt(j) - 32 ! To Uppercase
        j = j + 1
       end do
       do i = 1, 15
        tmp(1:2) = symt(i:i+1)
        if(tmp.EQ.'1-'.OR.tmp.EQ.'3-'.OR.tmp.EQ.'4-'.OR.tmp.EQ.'6-') then
         tmp(1:1) = symt(i+1:i+1)
         tmp(2:2) = symt(i:i)
         symt(i:i+1) = tmp(1:2)
        end if
       end do
       HALL = ' '
       do i = 1, NSGSY ! Finds Hall's equivalent of Space Group name in the SGSY table
        if(SGSY(i)(5:12).EQ.symt(1:8)) then
         HALL = SGSY(i)(14:28)
         exit
        end if
       end do
       if(i.GT.NSGSY) CALL GOTOER
c
      else
c
       HMSYMB(IPH)(1:4) = symt(1:4)
       j = 1
       do i = 6, 20
        symt(j:j) = HMSYMB(IPH)(i:i)	
        if(symt(j:j).EQ.'_') symt(j:j) = ' '
        if(symt(j:j).GT.'Z') isymt(j) = isymt(j) - 32 ! To Uppercase
        j = j + 1
       end do
       do i = 1, NSGSY ! Finds Hall's name in the SGSY table
        if(SGSY(i)(14:28).EQ.symt(1:15)) exit
       end do
       if(i.GT.NSGSY) CALL GOTOER
       HALL = symt(1:15)
c
      end if
c
      ns = i
      write(iddmout, '(/,2A)') ' Space Group ', SGSY(ns)(1:12)
      read(SGSY(ns),'(I3)') NSG(IPH)
      MAXIS(IPH) = 0
      if(NSG(IPH).GT.2.AND.NSG(IPH).LT.16) then ! Detect monoclinic unique axis
       MAXIS(IPH) = 3
       do i = 1, 15
        if(HALL(i:i).EQ.'Y') MAXIS(IPH) = 2
        if(HALL(i:i).EQ.'X') MAXIS(IPH) = 1
       end do
      end if
c
      CALL SGHALL(HALL,NSM,NLV,ISM,IT,LV,ICET(IPH))
c
      HALLSYM(IPH) = HALL
      MLT(IPH) = NLV*NSM ! Space Group multiplicity
c
c Pack integer matrices
c
      m = 1
      do n = 1, NLV ! Lattice centering vectors
       do i = 1, NSM ! Symmetry matrices
        do j = 1, 3
         do k = 1, 3
          i14(k) = ISM(j,k,i) ! Set 1,2,3 bytes of i4
         end do
         i14(4) = MOD(IT(j,i) + LV(j,n),12) ! 4th byte
         IMS(IPH,j,m) = i4 ! Write i4 (4 bytes) to IMS
        end do
        m = m + 1
       end do 
      end do
c
      RETURN
      END
c 
      SUBROUTINE GOTOER
        INCLUDE 'DDM.inc'
      write(iddmout,10)
      write(0,10)
10    format(1x,'Error in Space Group Interpretation!')
      STOP
      END
*
      SUBROUTINE SGHALL(HALL,NSYM,NLT,ISM,IT,LV,ICET)
*
* WRITTEN BY DAVID R. MOSSCROP (7901822)
* MAY-JUNE ; 1982.
*
* FROM AN ARTICLE AND PROGRAM: NEW SPACE GROUP NAMES.
*      BY HALL 1982  REF:ACTA CRYST .A36, 517-523.
*
* THIS PROCEDURE USES THE HALL SPACE GROUP NAME TO GENERATE 
* THE CORRESPONDING MATRIX TRANSFORMATIONS.
C
C   MODIFIED 84.2.14 BY I D BROWN TO ALLOW ORIGIN SHIFT
C   UPDATED BY D. ALTERMATT
*
C  Modified by L. Solovyov
c
      IMPLICIT CHARACTER*8 (G)
       INCLUDE 'DDM.inc'
c
c Returned parameters
      INTEGER NSYM,NLT,ISM(3,3,48),IT(3,48),LV(3,5),ICET
      CHARACTER*80 HALL
c HALL - Hall symbol string
c NSYM - number of generated symmetry operators 
c NLAT - number of lattice centering vectors
c ISM  - symmetry matrices
c IT   - symmetry vectors (multiplied by 12)
c LV   - lattice centering vectors (multiplied by 12)
c ICET - inversion center flag
c
c Internal parameters
      INTEGER OLD
      INTEGER ROT(12,20)
      INTEGER SMAT(16,50)
      INTEGER SVEC(3)
      DIMENSION ISHIFT(3),GCHR(30),TU(3,4)
      INTEGER TAB(3,9)
      INTEGER VEC(3,8)
*
* VARIABLE DICTIONARY: 
*
* GCENT IS CENTROSYMMETRIC FLAG (N OR C)
* GLAT IS LATTICE FLAG (P,R,A,B,C,I,F). 
* IAXS IS CURRENT AXIS POINTER TO TAB.
* ISGN IS MATRIX SIGN FLAG.
* IROT IS CURRENT ORDER POINTER TO TAB. 
* JAXS IS PREVIOUS AXIS POINTER TO TAB. 
* JROT IS PREVIOUS ORDER POINTER TO TAB.
* NIN IS INPUT DEVICE NUMBER. 
* NOUT IS OUTPUT DEVICE NUMBER.
* NSYM IS NUMBER OF EQUIVALENT POSITIONS.
* NGEN IS NUMBER OF GENERATED SEITZ MATRICES.
* NROT IS CURRENT ROTATION ORDER (1,2,3,4,6).
* NEW IS POSITION OF MATRIX PRODUCT.
* OLD IS MATRIX COUNT BEFORE INNER LOOP.
* ROT(12,20) IS TABLE OF ROTATION MATRICES.
* SMAT(16,50) IS SEITZ MATRIX ARRAY.
* SVEC(3) IS TEMPORARY T-VECTOR ARRAY.
* ISHIFT IS THE ORIGIN SHIFT
* TAB(3,9) POINTS TO ROT(AXIS,ORDER).
* VEC(3,8) IS THE T-VETORS FOR A,B,C,N,U,V,W,D.
*
******************************************************************
* LOADING INITIAL DATA
*
      DATA ROT/
     1 1,0,0,0, 0,1,0,0, 0,0,1,0,
     2 1,0,0,0, 0,-1,0,0, 0,0,-1,0,
     3 -1,0,0,0, 0,1,0,0, 0,0,-1,0,
     4 -1,0,0,0, 0,-1,0,0, 0,0,1,0,
     5 1,0,0,0, 0,0,1,0, 0,-1,-1,0,
     6 -1,0,-1,0, 0,1,0,0, 1,0,0,0,
     7 0,1,0,0, -1,-1,0,0, 0,0,1,0,
     8 1,0,0,0, 0,0,1,0, 0,-1,0,0,
     9 0,0,-1,0, 0,1,0,0, 1,0,0,0,
     1 0,1,0,0, -1,0,0,0, 0,0,1,0,
     2 1,0,0,0, 0,1,1,0, 0,-1,0,0,
     3 0,0,-1,0, 0,1,0,0, 1,0,1,0,
     4 1,1,0,0, -1,0,0,0, 0,0,1,0,
     5 0,0,1,0, 1,0,0,0, 0,1,0,0,
     6 -1,0,0,0, 0,0,-1,0, 0,-1,0,0,
     7 0,0,-1,0, 0,-1,0,0, -1,0,0,0,
     8 0,-1,0,0, -1,0,0,0, 0,0,-1,0,
     9 -1,0,0,0, 0,0,1,0, 0,1,0,0,
     1 0,0,1,0, 0,-1,0,0, 1,0,0,0,  0,1,0,0, 1,0,0,0, 0,0,-1,0/
*
      DATA GCHR/'1','2','3','4','5','6','P','R','A','B','C','I','F',
     1'N','U','V','W','D',' ','-','X','Y','Z','*','''','"','(','0','H',
     2'H'/
*
      DATA TAB/1,1,1,2,3,4,5,6,7,8,9,10,0,0,0,11,12,13,                 
     1  14,14,14,15,16,17,18,19,20/
*
      DATA VEC/6,0,0, 0,6,0, 0,0,6, 6,6,6,                              
     1  3,0,0, 0,3,0, 0,0,3, 3,3,3/
*
* VARIABLE INITIALIZATION.
*
      JCENT=0
      GCENT=GCHR(14) 
      GLAT=' '
      NGEN=1
      NSYM=1
      ISGN=12
      NLT=1
*
      NROT=0
      LLTCODE=0
      IROT=0
      JROT=0
      IAXS=0
      JAXS=0
*
******************************************************************
* THE PROGRAM: SGHALL
*
* ARRAY INITIALIZATION.
*
*
* ZERO VECTOR ACCUMULATOR.
*
      DO 1 I=1,3
      SVEC(I)=0
      TU(I,NLT)=0.0
    1 CONTINUE
*
* SET THE (4,4) ELEMENT TO 1.0.
*
      DO 2 I=1,50
      SMAT(16,I)=12 
      SMAT(4,I)=0
      SMAT(8,I)=0
      SMAT(12,I)=0
    2 CONTINUE
*
* SET ORIGIN SHIFT TO ZERO
*
      DO 30 I=1,3
   30   ISHIFT(I)=0 
*
* SET IDENTITY ROTATIONS.
*
      DO 3 I=1,12
      SMAT(I,1)=ROT(I,1)*12
    3 CONTINUE
*
* SET IDENTITY TRANSLATIONS.
*
      DO 4 I=13,16
      SMAT(I,1)=ROT(I-10,1)*12
    4 CONTINUE
*
* CHECKING ELEMENT BY ELEMENT AND SET VARIABLES AS NEEDED.
*
      DO 66 N=1,15
      DO 6 M=1,29
      IF (HALL(N:N).EQ.GCHR(M)) GO TO 606
    6 CONTINUE
*
* ERROR CONDITION CHARACTER NOT IDENTIFIED.
*
      write(iddmout,1670) HALL(N:N),N
 1670 FORMAT(' ++ERROR++SGHALL++1670++ ILLEGAL CHARACTER: ',A1,
     1       ' IN COLUMN ',I1)
*
* SKIP INACTIVE BLANKS.
*
  606 IF ((M.EQ.19).AND.(NROT.EQ.0)) GO TO 66
C
C  BLANK INITIATES CONSTRUCTION OF SYMMETRY GENERATOR
C
      IF ( M.EQ.19 ) GO TO 1011
C
C PARENTHESIS INITIATES READING OF ORIGIN SHIFT
C
      IF(M.EQ.27) GO TO 40
*
*
* SET GCENT AND GLAT, DEPENDENT ON FIRST ELEMENT(S).
*
      IF ( LLTCODE .NE. 0) GO TO 1000
*
* FIRST NEGATIVE SIGN INDICATES CENTRE. 
*
      IF (M .NE. 20) GO TO 1001
      JCENT=1
      GCENT=GCHR(11)
      GO TO 66
*
* ALLOWED CHARACTERS: P,R,A,B,C,I,F TO SET LTCODE.
*
 1001 IF ((M .GE. 7).AND.(M .LE.13)) GO TO 2000
      write(iddmout,1600) GCHR(M)
 1600 FORMAT(' ++ERROR++SGHALL++1600++ UNRECOGNISED LATTICE TYPE ',
     1 A1)
      GO TO 150
 2000 CONTINUE
      LLTCODE=M-6
      GLAT=GCHR(M)
*
* SPACE GROUPS WITH NAMES 'R' TYPE ARE ASSIGNED
* GLAT 'H' FOR A HEXAGONAL SETTING. THIS IS A
* LOCAL CONVENTION. 
*
      IF ( M .EQ. 8 ) GLAT=GCHR(30)
*
* ADD CENTERING TRANSLATIONS TO =TU=
*
      IF(GLAT.EQ.'P') GOTO 660
      IF(GLAT.EQ.'I') THEN
        NLT=NLT+1
        DO 60 I=1,3
   60   TU(I,NLT)=0.5
        GOTO 660
        ENDIF
      IF(GLAT.EQ.'A'.OR.GLAT.EQ.'F') THEN
        NLT=NLT+1
        TU(1,NLT)=0.0
        TU(2,NLT)=0.5
        TU(3,NLT)=0.5
        IF(GLAT.EQ.'A') GOTO 660
        ENDIF
      IF(GLAT.EQ.'B'.OR.GLAT.EQ.'F') THEN
        NLT=NLT+1
        TU(1,NLT)=0.5
        TU(2,NLT)=0.0
        TU(3,NLT)=0.5
        IF(GLAT.EQ.'B') GOTO 660
        ENDIF
      IF(GLAT.EQ.'C'.OR.GLAT.EQ.'F') THEN
        NLT=NLT+1
        TU(1,NLT)=0.5
        TU(2,NLT)=0.5
        TU(3,NLT)=0.0
        GOTO 660
        ENDIF
      IF(GLAT.EQ.'H') THEN
        NLT=NLT+1
        TU(1,NLT)=0.3333333
        TU(2,NLT)=0.6666667
        TU(3,NLT)=0.6666667
        NLT=NLT+1
        TU(1,NLT)=0.6666667
        TU(2,NLT)=0.3333333
        TU(3,NLT)=0.3333333
        ENDIF
c  660 IF(NDEBUG.NE.0) write(iddmout,2020) ((TU(I1,I2),I1=1,3),I2=1,NLT)
c 2020 FORMAT(/,' ++DEBUG++SGHALL++2020++  TU(3,NLT)',4(/,26X,3F5.2))
660   GOTO 66
*
* IF CHARACTER IS A NEGATIVE SIGN, SET ISGN TO NEGATIVE,
* OTHERWISE POSITIVE. THE LATER NEGATIVE SIGNS INDICATE
* INVERSIONS.
*
 1000 IF (M.NE.20) GO TO 999
      ISGN=-12
      GO TO 66
*
* ROTATION PMUT FOLLOW LATTICE TYPE.
*
*
* IF ROTATION AXIS ALREADY SET GO TO 1003.
*
  999 IF (NROT .NE. 0) GO TO 1003
      IF (M .LE.6) GO TO 2011 
      write(iddmout,2010) GCHR(M)
 2010 FORMAT(' ++ERROR++SGHALL++2010++ ILLEGAL ROTATION CHARACTER '
     1 ,A1)
      GO TO 150
 2011 CONTINUE
*
* SET ROTATION AXIS IN NROT.
*
      IF ((M .EQ. 1) .AND. (ISGN .LT.0)) NSYM=NSYM*2
      NROT=M
      IROT=M
      IF ((M.NE.1).OR.(ISGN.LT.0)) NGEN=NGEN+1
      IF(NGEN.LE.48) GO TO 1005
      write(iddmout,1501)
 1501 FORMAT(' ++ERROR++SGHALL++1501++ NGEN GREATER THAN 48.')
      NSYM=0
      RETURN
*
*********** SELECT AXIS EXPLICILY **************
*
* IF CHARACTER DOES NOT SET AXIS GO TO 1005.
*
 1003 IF (M .LE. 20) GO TO 1009
      IAXS=M-20
      GO TO 1004
*
* SET AXIS IMPLICITLY.
*
*
*  IF DEFAULT AXIS NOT REQUIRED GO TO 1004.
*
 1005 CONTINUE
*
*  FIRST AXIS ASSUMED Z.
*
      IF ((NGEN .NE.2).AND.(IROT .NE.1)) GO TO 1006
      IAXS=3
      GO TO 1004
*
* SECOND AXIS ASSUMED X IF NROT=2 AND PREVIOUS AXIS WAS 2 OR 4.
*
 1006 IF ((NROT .NE.2) .OR. (JROT .NE.2)) GO TO 1007
      IAXS=1
      GO TO 1004
*
* AXIS AFTER 3,6 ASSUMED AS X-Y.
*
 1007 IF (( NROT .NE.2) .OR.(JROT .NE.3))  GO TO 1008
      IAXS=5
      GO TO 1004
 1008 IF (NROT .EQ.3) GO TO 2500
      write(iddmout,1639)
 1639 FORMAT(' ++ERROR++SGHALL++1639++ UNABLE TO ASSIGN IMPLICIT ',
     1 'AXIS.')
      GO TO 150
 2500 IAXS=4
*
*
* FOR NON-PRINCIPAL AXES.
*
 1004 IF (IAXS .LE.3) GO TO 66
      IROT=IAXS+3
      IAXS=JAXS
      IF((IAXS.EQ.0).AND.(IROT.EQ.7))IAXS=1
      GO TO 66
*
********** SPECIFY TRANSLATION ***********
*
*
* ONLY FOR X,Y,Z DIRECTIONS.
*
 1009 IF(M .GT. 6) GO TO 1010 
      IF (IROT .GT.M) GO TO 2510
      write(iddmout,1660) GCHR(M)
 1660 FORMAT(' ++ERROR++SGHALL++1660++ ILLEGAL SCREW AXIS SYMBOL ',
     1 A1)
      GO TO 150
 2510 CONTINUE
*
* CALCULATE TRANSLATIONS IN 12 THS.
*
      SVEC(IAXS)=SVEC(IAXS)+M*12/NROT
*
* TEST FOR A,B,C,N,U,V,W,D.
*
 1010 IF(((M.LE.8).OR.(M.GE.12)).AND.((M.LE.13).OR.(M.GE.19)))GOTO1011
      IF (M .GE. 12) GO TO 1111
      I=M-8
      GO TO 1112
 1111 I=M-10
 1112 DO 7 J=1,3
      SVEC(J)=SVEC(J)+VEC(J,I)
    7 CONTINUE
      GO TO 66
*
* CONSTRUCT GENERATOR WHEN BLANK IS REACHED.
*
 1011 IF (M .NE.19) GO TO 66
*
* POINT TO ROTATION MATIX.
*
      K=TAB(IAXS,IROT)
      DO 8 I=1,12
      SMAT(I,NGEN)=ROT(I,K)*ISGN
    8 CONTINUE
      DO 9 I=13,15
*
* DEPOSIT TRANSLATON BASE 12. 
*
      SMAT(I,NGEN)=MOD(SVEC(I-12)+120,12)
    9 CONTINUE
*
* CALCULATE THE NUMBER OF EQUIVALENT POSITIONS.
*
      NSYM=NSYM*NROT
      IF (NROT .GT. 3) NROT=NROT/2
*
* RESET ORDER FLAGS AND AXIS FLAGS.
*
      JROT=NROT
      NROT=0
      IROT=0
      JAXS=IAXS
      IAXS=0
      ISGN=12
*
* ZERO VECTOR ACCUMULATOR.
*
      DO 10 I=1,3
      SVEC(I)=0
   10 CONTINUE
*
      IF(HALL(N:N+1).EQ.'  ') GOTO 666
      GO TO 66
C
C   READ ORIGIN SHIFT
C
   40 IAX=0
      NN=N
   41 ISIGN=1
      IAX=IAX+1
      IF(IAX.GT.3) GO TO 666
   42 NN=NN+1
      DO 45 M=1,29
   45 IF(HALL(NN:NN).EQ.GCHR(M)) GO TO 47
      write(iddmout,1670) HALL(NN:NN),NN
      GO TO 150
   47 IF(M.EQ.20) THEN
        ISIGN=-1
        GO TO 42
        ENDIF
      IF(M.EQ.28) THEN
        ISHIFT(IAX)=0
        GO TO 41
        ENDIF
      IF(M.LE.6) THEN
        ISHIFT(IAX)=ISIGN*M
        GO TO 41
        ENDIF
      IF(M.EQ.29) GO TO 666
      write(iddmout,200) HALL(NN:NN),NN
      NSYM=0
      RETURN
   66 CONTINUE
  666 CONTINUE
c      IF(NDEBUG.NE.0) THEN
c        write(iddmout,1666) GLAT,NROT,ISHIFT
c        DO 667 I=1,NGEN
c          write(iddmout,1667) (SMAT(J,I),J=1,16)
c  667     CONTINUE
c 1666   FORMAT(' ++DEBUG++SGHALL++1666++ LATCODE=',A1,' NROT=',I3,
c     1   ' ISHIFT=',3I4)
c 1667   FORMAT(10X,16I4)
c        ENDIF
*
* END OF INPUT DATA (HALL SPACE GROUP NAME) EVALUATION LOOPS.
*
* CHECK FOR ERROR CONDITION.
*
      IF ((NROT .LE.0).AND.(LLTCODE .NE.0)) GO TO 151
  150 CONTINUE
*
* ERROR CONDITION.
*
      write(iddmout,200) HALL(N:N),N,NROT,LLTCODE,GLAT,GCENT
  200 FORMAT (' ++DEBUG++SGHALL++200++  ILLEGAL CONSTRUCTION AT',
     1       ' CHARACTER ',A1,' IN COL.',I3,/,25X,'NROT =',I3,
     1       ', LLTCODE =',I3,', GLAT = ',A1,', GCENT = ',A1,/)
      NSYM=0
      RETURN
  151 CONTINUE
*
*
*GENERATE MATRICES BY PROGRESSIVE BINARY PRODUCTS.
*
*
*
* SKIP GENERATOR IF P1 OR -P1.
*
      IF (NGEN .LE.1) GO TO 117
      M=2 
  723 IF(M.LE.NGEN) GO TO 273 
      GO TO 105
*
* SAVE CURRENT MATRIX COUNT.
*
  273 OLD=NGEN
      N=M 
  724 IF(N.LE.NGEN) GO TO 274 
      GO TO 11
*
* POINT TO GENERATED MATRIX IN SMAT.
*
  274 NEW=NGEN+1
*
      DO 13 I=1,3
      DO 131 J=1,13,4
  131 SMAT(I+J-1,NEW)=((SMAT(I,M)*SMAT(J,N))+(SMAT(I+4,M)*SMAT(J+1,N))+ 
     1   (SMAT(I+8,M)*SMAT(J+2,N))+(SMAT(I+12,M)*SMAT(J+3,N)))/12
      SMAT(I+12,NEW)=MOD(SMAT(I+12,NEW)+120,12)
   13 CONTINUE
*
* IS MATRIX UNIQUE? 
*
      LFLAG=1
      DO 14 L=1,NGEN
      DO 103 I=1,12 
  103 IF (SMAT(I,L).NE.SMAT(I,NEW)) GO TO 1674
      IF (LLTCODE .NE. 1) GO TO 251
      DO 15 II=13,16
      IF (SMAT(II,L) .EQ. SMAT(II,NEW)) GO TO 15
*
* ERROR CONDITION FOUND.
*
      WRITE(iddmout,300)
  300 FORMAT('++SGHALL++ERROR: MATRICES RELATED BY PURE TRANSLATION.')
      NSYM=0
      RETURN
   15 CONTINUE
*
      GO TO 251
*
 1674 DO 16 J=1,12
   16 IF (SMAT(J,L) .NE. SMAT(J,NEW)) GO TO 20
*
* ERROR CONDITION NOT AVOIDED ( IE NOT SKIPPED OVER).
*
      write(iddmout,400)
  400 FORMAT('++SGHALL++ERROR: SOME MATRICES RELATED BY INVERSION.')
      NSYM=0
      RETURN
*
   20 CONTINUE
      LFLAG=LFLAG+1 
   14 CONTINUE
  251 IF (LFLAG .GT. NGEN) NGEN=NEW
      N=N+1
      GO TO 724
   11 IF ((NGEN.EQ.OLD).AND.(NGEN.GE. NSYM)) GO TO 105
      M=M+1
      GO TO 723
  105 CONTINUE
*
*
* SORT ON ZERO PATTERN.
*
      DO 17 N=2,NGEN
      DO 18 L=N,NGEN
      DO 181 K=1,12 
*
* EXIST ON ZERO MISMATCH.
*
  181 IF((SMAT(K,N-1).EQ.0).AND.(SMAT(K,L).NE.0))GO TO 18
      GO TO 1171
   18 CONTINUE
      GO TO 17
*
*
* EXCHANGE SORTED ELEMENTS.
*
 1171 DO 19 K=1,16
      I=SMAT(K,L)
      SMAT(K,L)=SMAT(K,N)
      SMAT(K,N)=I
   19 CONTINUE
*
   17 CONTINUE
  117 CONTINUE
*
* ERROR CHECK OF NGEN RELATIVE TO NSYM. 
*
      IF (NGEN .LE. NSYM) GO TO 1013
      write(iddmout,500) NGEN,NSYM
  500  FORMAT('++SGHALL++ERROR: ',I5,' MATRICES GENERATED,',I5,
     1       ' EXPECTED')
      NSYM=0
*
 1013 ICET = 1
      if(GCENT.EQ.GCHR(11)) ICET=2 ! Centrosymmetric
      do M=1,NSYM
       do J=1,3 
        do I=1,3 
         K=4*(J-1)+I
         ISM(I,J,M)=SMAT(K,M)/12
         if(ICET.EQ.2) ISM(I,J,M+NSYM)=-ISM(I,J,M)
        end do
        IF(ISM(J,J,M).LT.0) THEN ! Add origin Shift
         IT(J,M)=MOD(SMAT(J+12,M)+ISHIFT(J)*2,12)
         IF(IT(J,M).GT.12) IT(J,M)=IT(J,M)-12
         IF(IT(J,M).LT.0) IT(J,M)=IT(J,M)+12
        ELSE
         IT(J,M)=MOD(SMAT(J+12,M),12)
        END IF
        if(ICET.EQ.2) IT(J,M+NSYM) = IT(J,M)
       end do
      end do
c
      NSYM = NSYM*ICET
c
c Lattice translations
c
      do i = 1, NLT
       do j = 1, 3
        LV(j,i) = NINT(TU(j,i)*12.0)
       end do
      end do

      RETURN
      END 
C
C
      SUBROUTINE REFGEN(IPH,ZERO,DISP,SHASM,PREF,PREFOR)
c
c  Generates reflections and calls SORT to arrange them
c
        INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),ICX(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3) 
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      character fwhfix(irs)*1
      common/fwcntr/ fwhfix
      integer*4 IREFG
      COMMON/REFG/NSM,NLV,ISM(3,3,48),IT(3,48),LV(3,5),IREFG(IRS)
c
      DIMENSION PREF(MPH,3)
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     * (AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
      INTEGER H1,H2,H3
      INTEGER*1 HI(4)
      INTEGER*4 H4I
      EQUIVALENCE (H4I, HI)
      LOGICAL ORH1,ORH2,ORH3
c
      SIN1(A)=SIN(A*6.28318531)
      RAD=3.14159265359/360.0 
      TMIN = (SIN1(THMIN/720.0)/WLAMDA(1))**2
      SMAX = (SIN1(THMAX/720.0)/WLAMDA(1))**2
      IF(WLAMDA(2).GT.WLAMDA(1))TMIN=TMIN*(WLAMDA(1)/WLAMDA(2))**2
      IF(WLAMDA(2).GT.0..AND.WLAMDA(2).LT.WLAMDA(1))SMAX=SMAX* 
     * (WLAMDA(1)/WLAMDA(2))**2
c 
      I1MAX=A*2.0*SQRT(SMAX)
c      IF ( MAXIS(IPH).LT.3 ) THEN
        I2MAX=B*2.0*SQRT(SMAX)
        I3MAX=C*2.0*SQRT(SMAX)
c      ELSE
c        I2MAX = 2.0*C*SQRT(SMAX)
c        I3MAX = 2.0*B*SQRT(SMAX)
c      END IF
c
      IC = 0
      IF (IPH.GE.2) THEN
       DO IIPHAS=2,IPH
        IC = IC+ICX(IIPHAS-1)
       END DO
      END IF
      LXN=2
      IF(WLAMDA(2).EQ.0..OR.WLAMDA(2).EQ.WLAMDA(1)) LXN=1
      IC0 = IC + 1
      IC1 = 0
c
      DO I1 = 0, I1MAX
       DO I2 = I2MAX, -I2MAX, -1
        DO I3 = I3MAX, -I3MAX, -1
         IF ( IC.GT.IRS-2 ) GO TO 3000
         if(I1.LE.0.AND.I2.LE.0) then  ! Skip Friedel pairs
          if(I2.LT.0.OR.I3.LT.0) CYCLE
         end if
         do i = 1, NLV  ! Skip lattice centering absences
          if(MOD(LV(1,i)*I1+LV(2,i)*I2+LV(3,i)*I3, 12).NE.0) exit
         end do
         if(i.LE.NLV) CYCLE
C
         H1 = I1
         H2 = I2
         H3 = I3
C
         SQ=(H1*H1*ASTAR+H2*H2*BSTAR+H3*H3*CSTAR
     *    +H1*H2*BACOSC+H1*H3*CACOSB+H2*H3*BCCOSA)*0.25
         IF ((SQ.GT.SMAX).OR.SQ.LT.TMIN) CYCLE
c
c Detect forbidden reflections, previously generated equivalents,
c calculate multiplicity
c
C  
         IC2 = IC1
         if(LAU1(IPH).EQ.1) IC2 = 0 ! To generate reflections as for triclinic lattice
C
         MULT = MULTHKL(H1,H2,H3,IC2)
         IF(MULT.EQ.0) CYCLE
         if(LAU1(IPH).EQ.1) MULT = 2
C
C        NEXT IF BLOCK FOR PHASE WITH DISTINCT ORIENTATION ALONG PREF(K,I)
C
         IF (PREFOR.GT.99.) THEN 
          ORH1 = IFIX(PREF(IPH,1)).EQ.H1
          IF (.NOT.(ORH1).AND.H1.NE.0.AND.IFIX(PREF(IPH,1)).NE.0)
     *          ORH1 = MOD(H1,IFIX(PREF(IPH,1))).EQ.0
          IF (.NOT.ORH1) GO TO 2000
C        
          ORH2 = IFIX(PREF(IPH,2)).EQ.H2
          IF (.NOT.(ORH2).AND.H2.NE.0.AND.IFIX(PREF(IPH,2)).NE.0)
     *          ORH2 = MOD(H2,IFIX(PREF(IPH,2))).EQ.0
          IF (.NOT.ORH2) GO TO 2000
C        
          ORH3 = IFIX(PREF(IPH,3)).EQ.H3
          IF (.NOT.(ORH3).AND.H3.NE.0.AND.IFIX(PREF(IPH,3)).NE.0)
     *          ORH3 = MOD(H3,IFIX(PREF(IPH,3))).EQ.0
          IF (.NOT.ORH3) GO TO 2000
          IORDR1=0
          IORDR2=0
          IORDR3=0
          IF (H1.NE.0) IORDR1 = INT(H1/IFIX(PREF(IPH,1)))
          IF (H2.NE.0) IORDR2 = INT(H2/IFIX(PREF(IPH,2)))
          IF (H3.NE.0) IORDR3 = INT(H3/IFIX(PREF(IPH,3)))
          IF (IORDR1.EQ.IORDR2.AND.IORDR2.EQ.IORDR3) GO TO 1000
          IF (IORDR1.EQ.0.AND.(IORDR2.EQ.IORDR3)) GO TO 1000
          IF (IORDR2.EQ.0.AND.(IORDR3.EQ.IORDR1)) GO TO 1000
          IF (IORDR3.EQ.0.AND.(IORDR1.EQ.IORDR2)) GO TO 1000
          IF (IORDR1.EQ.0.AND.IORDR2.EQ.0) GO TO 1000
          IF (IORDR2.EQ.0.AND.IORDR3.EQ.0) GO TO 1000
          IF (IORDR3.EQ.0.AND.IORDR1.EQ.0) GO TO 1000
          GO TO 2000
         END IF
C
1000     IC1 = IC1 + 1 ! Index of temporary array IREFG
         HI(1) = H1    ! for finding previous hkl equivalents
         HI(2) = H2
         HI(3) = H3
         HI(4) = 0
         IREFG(IC1) = H4I
c
         do LX1=1,LXN ! Alpha1,2 loop
          SQH=SQ*WLAMDA(LX1)*WLAMDA(LX1)
          TAN2=SQH/(1.-SQH)
          IF(SQH.GE.1.) CYCLE
          TANX=SQRT(TAN2)
c       
c Peak shift due to sample displacement and asymmetry
c
          POS = ATAN(TANX)/RAD
          SHIFT =  PSHIFT(DISP,SHASM,POS)
          POS = POS + ZERO + SHIFT
          IF(POS.GT.THMAX.OR.POS.LT.THMIN) CYCLE
c        
          IC=IC+1 ! A valid reflection is included
          if(LX1.EQ.1) HI(4) = IPH
          if(LX1.EQ.2) HI(4) = -IPH
          IREFS(IC) = H4I
          fwhfix(IC)='n'
c
c          IF(TMV.LE.0.000001) TMV=1.
          PLOR=1.
          if(CTHM.GE.0) PLOR=1./(2.*SQH*SQRT(1.-SQH))
          IF(JOBTYP.EQ.3.OR.JOBTYP.EQ.1)
     *     PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*ABS(CTHM))
          REFS(IC,2)=POS
          REFS(IC,3)=PLOR*MULT
          REFS(IC,4)=1.
         end do  
c
2000     CONTINUE
        END DO 
       END DO 
      END DO 
c
      ICX(IPH)=IC
      IF (IPH.GE.2) THEN
       DO IIPHAS=2,IPH
        ICX(IPH) = ICX(IPH)-ICX(IIPHAS-1)
       END DO
      END IF
c
      CALL SORT(IPH)
c
      RETURN
3000  write(iddmout,24) IRS
      write(0,24) IRS
24    FORMAT (//'TOO MANY REFLECTIONS, INCREASE *IRS* IN THE PARAMETER
     *  STATEMENT IN DDM.INC') 
      STOP
      END 
c 
      FUNCTION MULTHKL(IH,IK,IL,IC1)
c
c Detects forbidden reflections and previously generated equivalents
c Calculates reflection multiplicity
c
        INCLUDE 'DDM.inc'
      integer*4 IREFG
      COMMON/REFG/NSM,NLV,ISM(3,3,48),IT(3,48),LV(3,5),IREFG(IRS)
      INTEGER*1 H(4), HI(4)
      INTEGER*4 H4, H4I
      EQUIVALENCE (H4, H), (H4I, HI)
      logical ipos
c
      MULTHKL = 0
      MUL = 0
      MH = IH
      MK = IK
      ML = IL
      ipos = MH.GE.0.AND.MK.GE.0.AND.ML.GE.0 ! All hkl are positive
      DO n=1,NSM
       NH=ISM(1,1,n)*MH+ISM(2,1,n)*MK+ISM(3,1,n)*ML
       NK=ISM(1,2,n)*MH+ISM(2,2,n)*MK+ISM(3,2,n)*ML
       NL=ISM(1,3,n)*MH+ISM(2,3,n)*MK+ISM(3,3,n)*ML
       if(NH.EQ.MH.AND.NK.EQ.MK.AND.NL.EQ.ML) then ! Systematic absense check
        if(MOD(IT(1,n)*MH+IT(2,n)*MK+IT(3,n)*ML, 12).NE.0) RETURN 
        MUL = MUL + 1
       else if(-NH.EQ.MH.AND.-NK.EQ.MK.AND.-NL.EQ.ML) then
        MUL = MUL + 1
       end if
       H(1) = NH
       H(2) = NK
       H(3) = NL
       HI(1) = -NH
       HI(2) = -NK
       HI(3) = -NL
       do i = IC1, 1, -1 ! Find previously generated equivalents
        if(H4.EQ.IREFG(i).OR.H4I.EQ.IREFG(i)) RETURN
       end do
       if(ipos.OR.IC1.EQ.0) CYCLE
       if(NH.GE.0.AND.NK.GE.0.AND.NL.GE.0) then
        IH = NH ! Change hkl if a positive equivalent is found
        IK = NK
        IL = NL
       end if
      END DO
      MULTHKL = 2*NSM/MUL ! Reflection multiplicity
      RETURN
      END
c
      SUBROUTINE SORT(IPHASE) 
        INCLUDE 'DDM.inc'
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),ICX(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      character*1 fwhfix(irs), ctemp(IRS)
      common/fwcntr/ fwhfix
      DIMENSION L(IRS),TEMP(IRS),ITEMP(IRS)
      EQUIVALENCE (ITEMP(1),TEMP(1))
c
      IOF=0
      IF(IPHASE.GE.2.AND.IPHASE.NE.1000) THEN
        DO 4100 IIPHAS=2,IPHASE
4100      IOF = IOF + ICX(IIPHAS-1)
      END IF
      IF (IPHASE.EQ.1000) THEN
        IC=0
        DO 4101 IIPHAS=1,MPH
4101      IC  = IC  + ICX(IIPHAS)
      ELSE
        IC=ICX(IPHASE)
      END IF
      DO 2 I=1,IC
2       L(I)=I
      M=IC-1
      DO 15 LL=1,5000
        K=0
        DO 10 J=1,2 
          DO 10 I=J,M,2
            INP=L(I)+IOF
            INP1=L(I+1)+IOF
            R=REFS(INP1,2)-REFS(INP,2)
            IF(R) 20,10,10
20          IZ=L(I) 
            L(I)=L(I+1)
            L(I+1)=IZ
            K=K+1
10          CONTINUE
        IF(K.EQ.0) GO TO 5
15      CONTINUE
5     DO 30 I=1,IC
30      ITEMP(I)=IREFS(I+IOF) 
      DO 31 I=1,IC
        LX=L(I)
        IREFS(I+IOF)=ITEMP(LX)
31      CONTINUE
      DO 33 J=1,3
        DO 32 I=1,IC
32        TEMP(I)=REFS(I+IOF,J)
        DO 33 I=1,IC
          LX=L(I)
33        REFS(I+IOF,J)=TEMP(LX)
      DO 34 I=1,IC
34       TEMP(I)=FF(I+IOF)
      DO 35 I=1,IC
        LX=L(I)
35      FF(I+IOF)=TEMP(LX)
        DO 70 I=1,IC
70        ctemp(I)=fwhfix(I+IOF)
        DO 71 I=1,IC
          LX=L(I)
71        fwhfix(I+IOF)=ctemp(LX) 
      IF (NPROF.EQ.8) THEN
        DO 40 I=1,IC
40        TEMP(I)=HALFL(I+IOF)
        DO 41 I=1,IC
          LX=L(I)
41        HALFL(I+IOF)=TEMP(LX)
        DO 50 I=1,IC
50        TEMP(I)=HALFG(I+IOF)
        DO 51 I=1,IC
          LX=L(I)
51        HALFG(I+IOF)=TEMP(LX)
        DO 60 I=1,IC
60        TEMP(I)=GAM(I+IOF)
        DO 61 I=1,IC
          LX=L(I)
61        GAM(I+IOF)=TEMP(LX) 
      END IF
      RETURN
      END 
c
      SUBROUTINE SETSYM(IPH,KNUM) ! KNUM - temporary index of last numbered codeword
C
C  Sets symmetry restrictions 
C
        INCLUDE 'DDM.inc'
C
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS),LAU1(MPH), ICZ
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
c
      INTEGER LATTC(9,6) ! Lattice symmetry constriants
c
      DATA (LATTC(1,i),i=1,6)   / 1, 2, 3, 4, 5, 6 / ! Triclinic 
      DATA (LATTC(2,i),i=1,6)   / 1, 2, 3, 4, 0, 0 / ! Monoclinic a axis
      DATA (LATTC(3,i),i=1,6)   / 1, 2, 3, 0, 4, 0 / ! Monoclinic b axis
      DATA (LATTC(4,i),i=1,6)   / 1, 2, 3, 0, 0, 4 / ! Monoclinic c axis
      DATA (LATTC(5,i),i=1,6)   / 1, 2, 3, 0, 0, 0 / ! Orthorhombic
      DATA (LATTC(6,i),i=1,6)   / 1, 1, 2, 0, 0, 0 / ! Tetragonal
      DATA (LATTC(7,i),i=1,6)   / 1, 1, 2, 0, 0, 1 / ! Hexagonal setting
      DATA (LATTC(8,i),i=1,6)   / 1, 1, 1, 0, 0, 0 / ! Cubic
      DATA (LATTC(9,i),i=1,6)   / 1, 1, 1, 2, 2, 2 / ! Rhombohedral setting
c
      INTEGER T2NC(9,6) ! Symmetry constriants for 2nd rank tensor
c
      DATA (T2NC(1,i),i=1,6)   / 1, 2, 3, 4, 5, 6 / ! Triclinic 
      DATA (T2NC(2,i),i=1,6)   / 1, 2, 3, 0, 0, 4 / ! Monoclinic a axis
      DATA (T2NC(3,i),i=1,6)   / 1, 2, 3, 0, 4, 0 / ! Monoclinic b axis
      DATA (T2NC(4,i),i=1,6)   / 1, 2, 3, 4, 0, 0 / ! Monoclinic c axis
      DATA (T2NC(5,i),i=1,6)   / 1, 2, 3, 0, 0, 0 / ! Orthorhombic
      DATA (T2NC(6,i),i=1,6)   / 1, 1, 2, 0, 0, 0 / ! Tetragonal
      DATA (T2NC(7,i),i=1,6)   / 1, 1, 2, 1, 0, 0 / ! Hexagonal setting
      DATA (T2NC(8,i),i=1,6)   / 1, 1, 1, 0, 0, 0 / ! Cubic
      DATA (T2NC(9,i),i=1,6)   / 1, 1, 1, 2, 2, 2 / ! Rhombohedral setting
c
      INTEGER T4NC(12,15)! Symmetry constriants for 4th rank tensor
c
c                                400 040 004 220 202 022
      DATA (T4NC( 1,i),i=1, 6)  /  1,  2,  3,  4,  5,  6 / ! Triclinic 
c                                310 103 031 130 301 013   
      DATA (T4NC( 1,i),i=7,12)  /  7,  8,  9, 10, 11, 12 /             
c                                211 121 112
      DATA (T4NC( 1,i),i=13,15) / 13, 14, 15 /              
      DATA (T4NC( 2,i),i=1, 6)  /  1,  2,  3,  4,  5,  6 / ! Monoclinic a axis
      DATA (T4NC( 2,i),i=7,12)  /  0,  0,  7,  0,  0,  8 /             
      DATA (T4NC( 2,i),i=13,15) /  9,  0,  0 /              
      DATA (T4NC( 3,i),i=1, 6)  /  1,  2,  3,  4,  5,  6 / ! Monoclinic b axis
      DATA (T4NC( 3,i),i=7,12)  /  0,  7,  0,  0,  8,  0 /             
      DATA (T4NC( 3,i),i=13,15) /  0,  9,  0 /              
      DATA (T4NC( 4,i),i=1, 6)  /  1,  2,  3,  4,  5,  6 / ! Monoclinic c axis
      DATA (T4NC( 4,i),i=7,12)  /  7,  0,  0,  8,  0,  0 /             
      DATA (T4NC( 4,i),i=13,15) /  0,  0,  9 /              
      DATA (T4NC( 5,i),i=1, 6)  /  1,  2,  3,  4,  5,  6 / ! Orthorhombic
      DATA (T4NC( 5,i),i=7,12)  /  0,  0,  0,  0,  0,  0 /             
      DATA (T4NC( 5,i),i=13,15) /  0,  0,  0 /              
      DATA (T4NC( 6,i),i=1, 6)  /  1,  1,  2,  3,  4,  4 / ! Tetragonal
      DATA (T4NC( 6,i),i=7,12)  /  0,  0,  0,  0,  0,  0 /             
      DATA (T4NC( 6,i),i=13,15) /  0,  0,  0 /              
      DATA (T4NC( 7,i),i=1, 6)  /  1,  1,  1,  2,  2,  2 / ! Trigonal -3 
      DATA (T4NC( 7,i),i=7,12)  /  3,  3,  3,  4,  4,  4 / ! rhombohedral setting
      DATA (T4NC( 7,i),i=13,15) /  5,  5,  5 /             
      DATA (T4NC( 8,i),i=1, 6)  /  1,  1,  1,  2,  2,  2 / ! Trigonal -3m1
      DATA (T4NC( 8,i),i=7,12)  /  3,  3,  3,  3,  3,  3 / ! rhombohedral setting
      DATA (T4NC( 8,i),i=13,15) /  4,  4,  4 /             
      DATA (T4NC( 9,i),i=1, 6)  /  1,  1,  2,  1,  3,  3 / ! Trigonal -3m1
      DATA (T4NC( 9,i),i=7,12)  /  1,  0,  4,  1,  4,  0 / ! hexagonal setting
      DATA (T4NC( 9,i),i=13,15) /  4,  4,  3 /             
      DATA (T4NC(10,i),i=1, 6)  /  1,  1,  2,  1,  3,  3 / ! Trigonal -31m
      DATA (T4NC(10,i),i=7,12)  /  1,  0,  0,  1,  0,  0 / ! hexagonal setting
      DATA (T4NC(10,i),i=13,15) /  4,  4,  3 /             
      DATA (T4NC(11,i),i=1, 6)  /  1,  1,  2,  1,  3,  3 / ! Hexagonal
      DATA (T4NC(11,i),i=7,12)  /  1,  0,  0,  1,  0,  0 /             
      DATA (T4NC(11,i),i=13,15) /  0,  0,  3 /             
      DATA (T4NC(12,i),i=1, 6)  /  1,  1,  1,  2,  2,  2 / ! Cubic
      DATA (T4NC(12,i),i=7,12)  /  0,  0,  0,  0,  0,  0 / 
      DATA (T4NC(12,i),i=13,15) /  0,  0,  0 /              
C
      INTEGER XYZC(6,28) ! XYZ restrictions
c
      DATA (XYZC(I, 1),I=1,6)/0,0,0, 0, 0, 0/
      DATA (XYZC(I, 2),I=1,6)/1,1,1, 1, 1, 1/
      DATA (XYZC(I, 3),I=1,6)/1,1,1, 1, 1,-1/
      DATA (XYZC(I, 4),I=1,6)/1,1,1, 1,-1, 1/
      DATA (XYZC(I, 5),I=1,6)/1,1,1, 1,-1,-1/
      DATA (XYZC(I, 6),I=1,6)/1,1,0, 1, 1, 0/
      DATA (XYZC(I, 7),I=1,6)/1,1,0, 1,-1, 0/
      DATA (XYZC(I, 8),I=1,6)/1,0,1, 1, 0, 1/
      DATA (XYZC(I, 9),I=1,6)/1,0,1, 1, 0,-1/
      DATA (XYZC(I,10),I=1,6)/0,1,1, 0, 1, 1/
      DATA (XYZC(I,11),I=1,6)/0,1,1, 0, 1,-1/
      DATA (XYZC(I,12),I=1,6)/1,0,0, 1, 0, 0/
      DATA (XYZC(I,13),I=1,6)/0,1,0, 0, 1, 0/
      DATA (XYZC(I,14),I=1,6)/0,0,1, 0, 0, 1/
      DATA (XYZC(I,15),I=1,6)/1,1,0, 1, 2, 0/
      DATA (XYZC(I,16),I=1,6)/1,1,0, 2, 1, 0/
      DATA (XYZC(I,17),I=1,6)/1,1,2, 1, 1, 1/
      DATA (XYZC(I,18),I=1,6)/1,1,2, 1,-1, 1/
      DATA (XYZC(I,19),I=1,6)/1,2,1, 1, 1, 1/
      DATA (XYZC(I,20),I=1,6)/1,2,1, 1, 1,-1/
      DATA (XYZC(I,21),I=1,6)/1,2,2, 1, 1, 1/
      DATA (XYZC(I,22),I=1,6)/1,2,2, 1, 1,-1/
      DATA (XYZC(I,23),I=1,6)/1,2,0, 1, 1, 0/
      DATA (XYZC(I,24),I=1,6)/1,0,2, 1, 0, 1/
      DATA (XYZC(I,25),I=1,6)/0,1,2, 0, 1, 1/
      DATA (XYZC(I,26),I=1,6)/1,1,2, 1, 2, 2/
      DATA (XYZC(I,27),I=1,6)/1,1,2, 2, 1, 2/
      DATA (XYZC(I,28),I=1,6)/1,2,3, 1, 1, 1/ 
c
      INTEGER UIJC(12,29) ! Uij restrictions
c      
      DATA (UIJC(I, 1),I=1,12)/1,1,1,0,0,0, 2, 2, 2, 0, 0, 0/
      DATA (UIJC(I, 2),I=1,12)/1,1,2,0,0,0, 2, 2, 2, 0, 0, 0/
      DATA (UIJC(I, 3),I=1,12)/1,2,1,0,0,0, 2, 2, 2, 0, 0, 0/
      DATA (UIJC(I, 4),I=1,12)/1,2,2,0,0,0, 2, 2, 2, 0, 0, 0/
      DATA (UIJC(I, 5),I=1,12)/1,1,1,2,2,2, 2, 2, 2, 2, 2, 2/
      DATA (UIJC(I, 6),I=1,12)/1,1,1,2,2,2, 2, 2, 2, 2,-2,-2/
      DATA (UIJC(I, 7),I=1,12)/1,1,1,2,2,2, 2, 2, 2, 2,-2, 2/
      DATA (UIJC(I, 8),I=1,12)/1,1,1,2,2,2, 2, 2, 2, 2, 2,-2/
      DATA (UIJC(I, 9),I=1,12)/1,1,2,1,0,0, 2, 2, 2, 1, 0, 0/
      DATA (UIJC(I,10),I=1,12)/1,2,3,0,0,0, 2, 2, 2, 0, 0, 0/
      DATA (UIJC(I,11),I=1,12)/1,1,2,3,0,0, 2, 2, 2, 2, 0, 0/
      DATA (UIJC(I,12),I=1,12)/1,2,1,0,3,0, 2, 2, 2, 0, 2, 0/
      DATA (UIJC(I,13),I=1,12)/1,2,2,0,0,3, 2, 2, 2, 0, 0, 2/
      DATA (UIJC(I,14),I=1,12)/1,2,3,2,0,0, 2, 2, 2, 1, 0, 0/
      DATA (UIJC(I,15),I=1,12)/1,2,3,1,0,0, 2, 2, 2, 1, 0, 0/
      DATA (UIJC(I,16),I=1,12)/1,2,3,4,0,0, 2, 2, 2, 2, 0, 0/
      DATA (UIJC(I,17),I=1,12)/1,2,3,0,4,0, 2, 2, 2, 0, 2, 0/
      DATA (UIJC(I,18),I=1,12)/1,2,3,0,0,4, 2, 2, 2, 0, 0, 2/
      DATA (UIJC(I,19),I=1,12)/1,1,2,3,4,4, 2, 2, 2, 2, 2,-2/
      DATA (UIJC(I,20),I=1,12)/1,1,2,3,4,4, 2, 2, 2, 2, 2, 2/
      DATA (UIJC(I,21),I=1,12)/1,2,1,3,4,3, 2, 2, 2, 2, 2,-2/
      DATA (UIJC(I,22),I=1,12)/1,2,1,3,4,3, 2, 2, 2, 2, 2, 2/
      DATA (UIJC(I,23),I=1,12)/1,2,2,3,3,4, 2, 2, 2, 2,-2, 2/
      DATA (UIJC(I,24),I=1,12)/1,2,2,3,3,4, 2, 2, 2, 2, 2, 2/
      DATA (UIJC(I,25),I=1,12)/1,2,3,2,4,4, 2, 2, 2, 1, 1, 2/
      DATA (UIJC(I,26),I=1,12)/1,2,3,1,0,4, 2, 2, 2, 1, 0, 2/
      DATA (UIJC(I,27),I=1,12)/1,2,3,2,4,0, 2, 2, 2, 1, 2, 0/
      DATA (UIJC(I,28),I=1,12)/1,2,3,1,4,4, 2, 2, 2, 1, 2, 1/
      DATA (UIJC(I,29),I=1,12)/1,2,3,4,5,6, 2, 2, 2, 2, 2, 2/
c
      REAL        x(3), x1(3), x2(3), val(15)
      INTEGER     ih(3), ind(15)
c
c Set XYZ constraints
c
      iof = 0
      if(IPH.GT.1) then
       do i = 2, IPH
        iof = iof + NATOM(i-1) 
       end do
      end if
      DO i = 1, NATOM(IPH)
       do j = 1, 3
        if(NSG(IPH).GE.143.AND.NSG(IPH).LE.194.AND.j.LE.2) then
         if(ABS(0.333333-ABS(XL(i+iof,j))).LE.0.000033)
     *     XL(i+iof,j) = SIGN(0.333333,XL(i+iof,j))
         if(ABS(0.666667-ABS(XL(i+iof,j))).LE.0.000067)
     *     XL(i+iof,j) = SIGN(0.666667,XL(i+iof,j))
        end if
        x(j) = XL(i+iof,j) ! Atom position in x
       end do
       m1 = MULPOS(IPH, x) ! Calc. multiplicity of x
       x2(1) = 0.03		 ! Choose arbitrary shift vector x2
       x2(2) = 0.04
       x2(3) = 0.05
C  Find the easiest constraint preserving (or reducing) the site multiplicity
       do k = 28, 1, -1 
        do j = 1, 3		  ! Shift x by restrained x2
         x1(j) = x(j)
         if(XYZC(j,k).GT.0) x1(j) = x1(j) + x2(XYZC(j,k))*XYZC(j+3,k)
        end do
        if(MULPOS(IPH,x1).LE.m1) exit ! Constraint found
       end do
       if(k.LT.1) k = 1
       c05 = 1.
       do j = 1, 3
        if(XYZC(j+3,k).eq.2) c05 = 0.5 ! For positions x, 2x, z
       end do
       do j = 1, 3
        ind(j) = XYZC(j,k)
        val(j) = XYZC(j+3,k)*c05
       end do
       CALL SETCONSTR(ind,val,A,LP,3,0,i+iof,NATS,KNUM) ! Apply xyz constraints
c
       if(IANIS(i+iof).EQ.1) then ! If Uij are turned on
c
C  Find the easiest constraint for which Uij ellipsoid is invariant
C  to the site symmetry
        do j = 1, 3
         x(j) = x(j) - INT(x(j))
         if(x(j).LT.0.) x(j) = x(j) + 1.
        end do
        do k = 29, 1, -1
         iu1= UIJC(1,k)*UIJC( 7,k)*1*1 + ! Ellipsoid with constrained
     *        UIJC(2,k)*UIJC( 8,k)*2*2 + ! coeffitients UIJC and arbitrary
     *        UIJC(3,k)*UIJC( 9,k)*3*3 + ! HKL indexes (123)
     *      2*UIJC(4,k)*UIJC(10,k)*1*2 + 
     *      2*UIJC(5,k)*UIJC(11,k)*1*3 + 
     *      2*UIJC(6,k)*UIJC(12,k)*2*3
         DO IR=2,MLT(IPH)
          do j = 1, 3   ! Check whether the operator preserves the site position
           x1(j) = FLOAT(IND4(IMS(IPH,j,IR),4))/12.0
           do l = 1, 3
            x1(j) = x1(j)+IND4(IMS(IPH,j,IR),l)*x(l)
           end do
           if(x1(j).LT.0.) x1(j) = x1(j) + 1.
           if(x1(j).GE.1.) x1(j) = x1(j) - 1.
           if(ABS(x(j)-x1(j)).GT.0.00002) exit ! Position is not preserved
          end do
          if(j.LE.3) cycle ! Skip symmetry operator  
          do j = 1, 3  ! A valid operator is found
           ih(j) = 0   
           do l = 1, 3
            ih(j) = ih(j)+IND4(IMS(IPH,l,IR),j)*l ! Transform the HKL indexes (123)
           end do
          end do
          iu2= UIJC(1,k)*UIJC( 7,k)*ih(1)*ih(1) + ! Calculate transformed
     *         UIJC(2,k)*UIJC( 8,k)*ih(2)*ih(2) + ! ellipsoid 
     *         UIJC(3,k)*UIJC( 9,k)*ih(3)*ih(3) + 
     *       2*UIJC(4,k)*UIJC(10,k)*ih(1)*ih(2) + 
     *       2*UIJC(5,k)*UIJC(11,k)*ih(1)*ih(3) + 
     *       2*UIJC(6,k)*UIJC(12,k)*ih(2)*ih(3)
          if((iu1-iu2).NE.0) exit ! The ellipsoid was changed - wrong constraint
         END DO
         if(IR.GT.MLT(IPH)) exit ! The ellipsoid was preserved by all the 
        end do				  ! valid symmetry operations
        if(k.LT.1) k = 1
        do j = 1, 6
         ind(j) = UIJC(j,k)
         val(j) = FLOAT(UIJC(j+6,k))*0.5
        end do
        CALL SETCONSTR(ind,val,A,LP,6,5,i+iof,NATS,KNUM) ! Apply Uij constraints
       end if
      END DO ! NATOM loop
C
      il = 1
      if(NSG(IPH).GE.  1.AND.NSG(IPH).LE.  2) il = 1      ! Triclinic
      if(NSG(IPH).GE.  3.AND.NSG(IPH).LE. 15) il = MAXIS(IPH) + 1 ! Monoclinic
      if(NSG(IPH).GE. 16.AND.NSG(IPH).LE. 74) il = 5      ! Orthorhombic
      if(NSG(IPH).GE. 75.AND.NSG(IPH).LE.142) il = 6      ! Tetragonal
      if(NSG(IPH).GE.143.AND.NSG(IPH).LE.194) il = 7      ! Hexagonal setting
      if(NSG(IPH).GE.195.AND.NSG(IPH).LE.230) il = 8      ! Cubic
      if(NSG(IPH).GE.143.AND.NSG(IPH).LE.167) then
       ir = 0
       do i = 1, 20
        if(HMSYMB(IPH)(i:i).EQ.'R') ir = ir + 1  ! Detect rhombohedral setting
        if(HMSYMB(IPH)(i:i).EQ.'*') il = 9 ! Rhombohedral setting in Hall notation
       end do
       if(ir.GE.2) then
        il = 9 !'R' letter was met twice
        MAXIS(IPH) = -1 ! Remember the Rhombohedral setting
       end if
      end if
c
c Lattice constraints
c
      if(il.EQ.7) then ! Constrain hexagonal reciprocal lattice 
       APAR(IPH, 11) = APAR(IPH, 6)
       LPAR(IPH, 11) = LPAR(IPH, 6)
      end if
      do i = 1,6
       ind(i) = LATTC(il,i)
       val(i) = 0.
       if(LATTC(il,i).NE.0) val(i) = 1.
      end do
      CALL SETCONSTR(ind,val,APAR,LPAR,6,5,IPH,MPH,KNUM)
c
      if(LAU1(IPH).EQ.1) RETURN ! Skip further constraints if Laue -1 is imposed
c
c 2nd rank tensor constraints (Aniso. Pref.Or., Size, Strain broadening)
c
      do i = 1,6
       ind(i) = T2NC(il,i)
       val(i) = 0.
       if(T2NC(il,i).NE.0) val(i) = 1.
      end do
      if(il.EQ.7) val(4) = 0.5
      do l = 20, 37, 6 
       CALL SETCONSTR(ind,val,APAR,LPAR,6,l,IPH,MPH,KNUM)
       if(l.EQ.26.AND.abs(ians(IPH,3)).EQ.2) exit ! Aniso strain is of rank 4
      end do
      if(abs(ians(IPH,3)).NE.2) RETURN ! Aniso strain is of rank 2
c
c 4th rank (Aniso. strain) tensor constraints
c
      if(NSG(IPH).GE.143.AND.NSG(IPH).LE.148) then
       if(ir.GE.2) il = 7 ! -3 Rhomb. setting
       if(ir.LT.2) il = 9 ! -3 Hex. setting (not quite correct, but let it be)
      end if
      if(NSG(IPH).GE.149.AND.NSG(IPH).LE.159) then
       if(MOD(NSG(IPH),2).EQ.0) il = 9  ! Trigonal -3m1
       if(MOD(NSG(IPH),2).NE.0) il = 10 ! Trigonal -31m
      end if
      if(NSG(IPH).GE.162.AND.NSG(IPH).LE.163) il = 10 ! Trigonal -31m
      if(NSG(IPH).GE.164.AND.NSG(IPH).LE.167) il = 9  ! Trigonal -3m1
      if(NSG(IPH).GE.149.AND.NSG(IPH).LE.167.AND.ir.GE.2) il = 8 ! -3m1 Rhomb.
      if(NSG(IPH).GE.168.AND.NSG(IPH).LE.194) il = 11 ! Hexagonal
      if(NSG(IPH).GE.195.AND.NSG(IPH).LE.230) il = 12 ! Cubic
      do i = 1,15
       ind(i) = T4NC(il,i)
       val(i) = 0.
       if(T4NC(il,i).NE.0) val(i) = 1.
      end do
      if(il.EQ.9) then ! Trigonal -3m1, hexagonal setting
       val( 4) = 0.333333
       val( 7) = 0.5
       val( 9) = -1.0
       val(10) = 0.5
       val(13) = 0.666667
       val(14) = -.666667
      else if(il.EQ.10.OR.il.EQ.11) then ! Hexagonal or Trigonal -31m
       val(4)  = 0.3333333
       val(7)  = 0.5
       val(10) = 0.5
      end if
      CALL SETCONSTR(ind,val,APAR,LPAR,15,32,IPH,MPH,KNUM)
c
      RETURN
      END
c
      SUBROUTINE SETCONSTR(ind, val, ap, lp, ns, np, ip, mp, KNUM)
c
c Generates and assigns constrained codewords
c
      dimension ind(*), val(*), ap(mp,*), lp(mp,*)
c
      do i = 1, ns
       if(lp(ip,i+np).EQ.0.AND.ap(ip,i+np).NE.0.) then
        do k = 1, ns
         if(lp(ip,k+np).EQ.0.AND.ap(ip,k+np).NE.0.) then
          ap(ip,k+np) = val(k)
          if(ind(k).NE.0) lp(ip,k+np) = KNUM + ind(k)
         end if
        end do
        n = 0
        do k = 1, ns
         if(ind(k).GT.n) n = ind(k)
        end do
        KNUM = KNUM + n
        exit
       end if
      end do
c
      RETURN
      END
c
      SUBROUTINE NUMCW(ncw,i1,i2,i3,NATOMS)
c
c  Checks singular numbered codewords
c
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
C
      if(ncw.EQ.0) return
      if(i1.EQ.1) then
       do I=1,16
        if(i2.EQ.I) cycle
        if(LGLB(I).EQ.ncw) return
       end do
      else if(i1.EQ.2) then
       do I=1,NATOMS
        do J=1,11
         if(i2.EQ.I.AND.i3.EQ.J) cycle
         if(LP(I,J).EQ.ncw) return
        end do
       end do
      else if(i1.EQ.3) then
       do K=1,NPHASE
        do I=1,npar
         if(i2.EQ.K.AND.i3.EQ.I) cycle
         if(LPAR(K,I).EQ.ncw) return
        end do
       end do
      end if
      ncw = 0
      RETURN
      END
C
C
      SUBROUTINE CWORDS(N)
      INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      dimension lc(N), lc1(N)

      if(N.LE.1) RETURN
      NATOMS = 0
      do i=1,NPHASE
       NATOMS = NATOMS + NATOM(i)
      end do
      k = 0
      do i=1,16
       if(LGLB(i).NE.0) then
        k = k + 1
        lc(k) = LGLB(i)
       end if
      end do
      do i=1,NATOMS
       do j=1,11
        if(LP(i,j).NE.0) then
         k = k + 1
         lc(k) = LP(i,j)
        end if
       end do
      end do
      do i=1,NPHASE
       do j=1,npar
        if(LPAR(i,j).NE.0) then
         k = k + 1
         lc(k) = LPAR(i,j)
        end if
       end do
      end do
      k = 10000
      do j = 1, N
       do i = 1, N
        if(lc(i).LT.k) k = lc(i)
       end do
       if(k.EQ.10000) exit
       do i = 1, N
        if(lc(i).EQ.k) then
         lc1(i) = j
         lc(i) = 10000
        end if
       end do
       k = 10000
      end do
      k = 0
      do i=1,16
       if(LGLB(i).NE.0) then
        k = k + 1
        LGLB(i) = lc1(k)
       end if
      end do
      do i=1,NATOMS
       do j=1,11
        if(LP(i,j).NE.0) then
         k = k + 1
         LP(i,j) = lc1(k)
        end if
       end do
      end do
      do i=1,NPHASE
       do j=1,npar
        if(LPAR(i,j).NE.0) then
         k = k + 1
         LPAR(i,j) = lc1(k)
        end if
       end do
      end do
      RETURN
      END
C
c
      SUBROUTINE LIMITS
        INCLUDE 'DDM.inc'
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
c
      DIMENSION KRR(2,NPTS)
c
      ICX=0
      DO 4100 J =1,NPHASE
4100    ICX = ICX + IC(J)
      IF(NPHASE.GT.1)CALL SORT(1000)
      DO 2 J=1,2
        DO 2 K=1,NPTS
2         KRR(J,K)=0
      DO 479 I=1,ICX
        RMIN=REFS(I,2)-WDT*REFS(I,1)
        RMAX=REFS(I,2)+WDT*REFS(I,1)
        MIN=(RMIN-THMIN)/STEP+1.5
        MAX=(RMAX-THMIN)/STEP+1.5
        MIN=MAX0(MIN,1)
        MIN=MIN0(MIN,NPTS)
        MAX=MIN0(MAX,NPTS)
        DO 479 K=MIN,MAX
          KRR(2,K)=I
479       IF(KRR(1,K).EQ.0)KRR(1,K)=I
      DO 482 J=1,NEXCRG
        IF(AHIGH(J).LE.THMIN)GOTO 482
        IN1=(ALOW(J)-THMIN)/STEP+1.5
        IN1=MAX0(IN1,1)
        IN2=(AHIGH(J)-THMIN)/STEP+1.5
        IN2=MIN0(IN2,NPTS)
        DO 483 I=IN1,IN2
          KRR(2,I)=1
483       KRR(1,I)=0
        IF(IN2.EQ.NPTS)GOTO 484
482   CONTINUE
484   DO 600 I=1,NPTS
        IF(KRR(2,I)-KRR(1,I).GT.NOV)THEN
c          write(iconout,601) I,KRR(2,I)-KRR(1,I),NOV
          write(iddmout,601) I,KRR(2,I)-KRR(1,I),NOV
601       FORMAT(1X,'EXCESSIVE PEAK OVERLAP',/,
     *          5X,'AT THE',I5,'TH STEP THERE ARE ',I5,' REFLECTIONS',/,
     *               5X,'INCREASE THE VALUE OF *NOV* WHICH IS NOW',I5/)
          STOP 'EXCESSIVE PEAK OVERLAP' 
        ENDIF
600     CONTINUE
      DO 531 I=1,NPTS
        KR(I)=KRR(1,I)+IRS *KRR(2,I)
531     CONTINUE
      DO 602 I=1,NPTS
        IF(KR(I).NE.0.AND.KR(I).NE.IRS )GOTO 603
602     CONTINUE
      STOP 'NO REFLECTIONS FOUND '
C THE FOLLOWING TEST IS REALLY ONLY VALID FOR THE SINGLE PHASE CASE
603   IF(REFS(KRR(1,I),2).GE.RLIM.AND.LPAR(1,14).NE.0)THEN
        write(iddmout,604)
c        write(iconout,604)
604     FORMAT(1X,'ASYMMETRY PARAMETER USAGE INVALID')
        STOP 'ASYMMETRY PARAMETER USAGE INVALID'
      ENDIF
c      DO 606 I=1,NPHASE
c        IF(PAR(I,12).EQ.0..AND.PAR(I,13).EQ.0..AND.LPAR(I,13).NE.0)THEN
c          write(iddmout,605)
c          write(iconout,605)
c605       FORMAT(1X,'PREFERRED ORIENTATION USAGE INVALID')
c          STOP 'PREFERRED ORIENTATION USAGE INVALID'
c        ENDIF
c606     CONTINUE
      RETURN
      END 
c
      SUBROUTINE CHISQ
        INCLUDE 'DDM.inc'
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/G2/S0,S1,S2,S2e,S3,S4,D0,D1,D2,D3,D4,R1,R2,R3,DC1,DS1,DS2,SYZ(MPH)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
c       dimension cov1(mddm,mddm), vec1(mddm)
c
c       do i = 1,mddm
c        vec1(i) = 0.
c        do j = 1,mddm
c         cov1(i,j) = 0.
c        end do
c       end do
      S0=0.
      S1=0.
      S2=0.
c      S2e=0.
      S3=0.
      S4=0.
      D0=0.
      D1=0.
      D2=0.
      D3=0.
      D4=0.
      DS1=0.
      DS2=0.
      DC0=0.
      DC1=0.
      DC2=0.
      DD1=0.
      DD2=0.
      DELW =  1.0E+25
      DELWP=  1.0E+25
      DO 10 I=1,NPTS
c        IF((NBCKGD.GT.1.AND.KR(I).EQ.0).OR.KR(I).EQ.IRS )GOTO 10
        IF(NEXCRG.GT.0) THEN
          DO 1400 IEXC=1,NEXCRG
            NPTLOW = (ALOW(IEXC)-THMIN)/STEP + 1.5
            NPTHI  = (AHIGH(IEXC)-THMIN)/STEP + 1.5
            IF (I.GE.NPTLOW.AND.I.LE.NPTHI) GO TO 10
1400        CONTINUE
        END IF
      if(iddm.EQ.0) then ! least squares
        DEL=Y(I)-BK(I)-YC(I)
        IF (DELW.LT.1.0E+24) DELWP = DELW
        DELW = DEL/SQRT(VAR(I))
        S1=S1+ABS(DEL)
        S2=S2+DEL*DEL/VAR(I)
        IF (DELWP.LT.1.0E+24) S4=S4+(DELW-DELWP)*(DELW-DELWP)
      else ! DDM
       if((I.LT.3).or.(I.GT.NPTS-2)) go to 10
        ia = iconv(I)
        cn0 = ia*2+1
        cn1 = ia*(ia+1)*cn0
        cn2 = (4*ia*(ia+1)-3)*cn0
        c01 = -15./cn2  ! equals to c20         
        c10 = 3./cn1    
        c21 = 45./(cn2*ia*(ia+1))
        DEL1 = 0.0
        DEL2 = 0.0
        DEL1e = 0.0
        DEL2e = 0.0
        do l = -ia, ia
         c1 = l*c10
         c2 = c01+c21*l*l
         DEL = Y(I+l)-YC(I+l)-BK(I+l)
         DEL1=DEL1+DEL*c1
         DEL2=DEL2+DEL*c2
c         DEL1e=DEL1e+VAR(i)*c1
c         DEL2e=DEL2e+VAR(i)*c2
c         if(I.EQ.mddm) then
c          do l1 = -ia, ia
c           ia1 = iconv(I+l1)
c           cn01 = ia1*2+1
c           cn11 = ia1*(ia1+1)*cn01
c           cn21 = (4*ia1*(ia1+1)-3)*cn01
c           c011 = -15./cn21  ! equals to c20         
c           c101 = 3./cn11    
c           c211 = 45./(cn21*ia1*(ia1+1))
c           do l2 = -ia1, ia1
c            if(I+l2.cov1(l+ia+1,l1+ia+1) = cov1(l+ia+1,l1+ia+1) + l*c10*l1*c101*
c           end do
c          end do
c         end if
        end do
        IF (DELW.LT.1.0E+24) DELWP = DELW
        DELW = DEL1/SQRT(VAR1(I))+DEL2/SQRT(VAR2(I))
        S1=S1+ABS(DEL1)+ABS(DEL2)
        S2=S2+DEL1*DEL1/VAR1(I)+DEL2*DEL2/VAR2(I)
c        S2e=S2e+DEL1e*DEL1e/VAR1(I)+DEL2e*DEL2e/VAR2(I)
        DS1=DS1+DEL1*DEL1/VAR1(I)
        DS2=DS2+DEL2*DEL2/VAR2(I)
        IF (DELWP.LT.1.0E+24) S4=S4+(DELW-DELWP)*(DELW-DELWP)
       end if
c
10      CONTINUE
      DO 15 I=1,NPTS
c        IF((NBCKGD.GT.1.AND.KR(I).EQ.0).OR.KR(I).EQ.IRS )GOTO 15
        IF(NEXCRG.GT.0) THEN
          DO 1401 IEXC=1,NEXCRG
            NPTLOW = (ALOW(IEXC)-THMIN)/STEP + 1.5
            NPTHI  = (AHIGH(IEXC)-THMIN)/STEP + 1.5
            IF (I.GE.NPTLOW.AND.I.LE.NPTHI) GO TO 15
1401        CONTINUE
        END IF
      if(iddm.EQ.0) then ! least squares
        D1=D1+Y(I)-BK(I)
        D2=D2+(Y(I)-BK(I))*(Y(I)-BK(I))/VAR(I)
        S3=S3+BK(I)+YC(I)
        if(iwght.EQ.1) D4 = D4 + 1./SQRT(VAR(I))
        if(iwght.EQ.0) D4 = D4 + 1.
      else ! DDM
       if((I.LT.3).or.(I.GT.NPTS-2)) go to 15
        ia = iconv(I)
        cn0 = ia*2+1
        cn1 = ia*(ia+1)*cn0
        cn2 = (4*ia*(ia+1)-3)*cn0
        c00 = (9*ia*(ia+1)-3)/cn2
        c01 = -15./cn2  ! equals to c20         
        c10 = 3./cn1    
        c21 = 45./(cn2*ia*(ia+1))
         Y1  = 0.0
         YC1 = 0.0
         Y2  = 0.0
         YC2 = 0.0
         p0 = 0.
         var11 = 0.
         var22 = 0.
         do l = -ia, ia
          c1 = l*c10
          c2 = c01+c21*l*l
          p0=p0+Y(I+l)*(c00+c01*l*l)
          Y1=Y1+Y(I+l)*c1
          Y2=Y2+Y(I+l)*c2
          YC1=YC1+(YC(I+l)+BK(I+l))*c1
          YC2=YC2+(YC(I+l)+BK(I+l))*c2
          var11 = var11+VAR(I+l)*c1*c1
          var22 = var22+VAR(I+l)*c2*c2
         end do
        S0=S0+(Y(I)-p0)*(Y(I)-p0)/VAR(I)
        D0=D0+Y(I)*Y(I)/VAR(I)
        D2=D2+Y1*Y1/VAR1(I)+Y2*Y2/VAR2(I)
        D3 = D3 + var11/VAR1(I) + var22/VAR2(I)
        var0 = VAR(I)
        if(iwght.EQ.1) var0 = var0*ia
        if(iwght.EQ.2) var0 = var0*ia*ia
        DC0=DC0+YC(I)*YC(I)/var0
        DC1=DC1+YC1*YC1/VAR1(I)
        DC2=DC2+YC2*YC2/VAR2(I)
        DD1=DD1+Y1*Y1/VAR1(I)
        DD2=DD2+Y2*Y2/VAR2(I)
       end if
15      CONTINUE
       R1=0.0
      if(iddm.EQ.0) then ! least squares
       R2=100.*S1/D1 
       R3=100.*SQRT(S2/D2)
      else ! DDM
       if(DC0.LE.0) then
        DC1 = 1.
        DC2 = 1.
       else
        DC1 = DC1/DC0
        DC2 = DC2/DC0
       end if
       R1=100.*SQRT(DS1*DC1/DD1)
       R2=100.*SQRT(DS2*DC2/DD2)
       R3=50.*SQRT(S2/D2+S0/D0)
c       write(0,*) SQRT(DS2/(NPTS*DC2))
      end if
      RETURN
      END 
C
      SUBROUTINE ITER
        INCLUDE 'DDM.inc'

      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/G2/S0,S1,S2,S2e,S3,S4,D0,D1,D2,D3,D4,R1,R2,R3,DC1,DS1,DS2,SYZ(MPH)
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/G3/COND,IORD1,IORD2,TH,NUM 
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
c
      DOUBLE PRECISION cov(MAXS,MAXS), sigm1(MAXS,MAXS), sigm2(MAXS,MAXS), chi2
      DOUBLE PRECISION cov1(MAXS,MAXS), cov2(MAXS,MAXS), bias(MAXS)
      DIMENSION deri(iddm*2+1,MAXS), derv(iddm*2+1,MAXS), deli(iddm*2+1)
      DIMENSION VLAST(MAXS), KS(50)
C

      CALL INDDER ! Determine derivatives to be calculated in SUMMAT
c
      do I=1,MAXS 
       VLAST(I)=0.
      end do
      ns0 = 0
c
c  ITERATIONS
c
      DO 10 IX=0,MCYCLE
       CALL LIMITS 
11     DO 1 I=1,MSZ
        VX(I)=0.
        DO 1 J=1,MSZ
1        SMM(I,J)=0.
c
       do i = 1, MAXS
         BIAS1(i) = 0.0
         BIAS2(i) = 0.0
        do j = 1, MAXS
         cov(i,j) = 0.0
         cov1(i,j) = 0.0
         cov2(i,j) = 0.0
         sigm1(i,j) = 0.0
         sigm2(i,j) = 0.0
        end do
       end do
c
       nconv = iddm*2+1
       do i = 1, nconv
        deli(i) = 0.
        do j = 1, MAXS
         deri(i,j) = 0.
         derv(i,j) = 0.
        end do
       end do
c
       NUM=0
       IPREV=1
       IF(NBCKGD.GE.0) THEN
        DO 31 I=1,NPTS
         TH=THMIN+STEP*float(I-1)
         THX=TH/BKPOS-1.
         BK(I)=GLB(2)+BKM(I)
         DO 31 J=2,6
31        BK(I)=BK(I)+GLB(J+1)*THX**(J-1)
       ELSE
         if(IX.EQ.0) call CALCY(-1, YC)
         call CALCBK(BK)
       END IF
c
       CALL QPA(0)
c
        chi2 = 0.0
        DO 9 IPM=1,NPTS
          TH=THMIN+FLOAT(IPM-1)*STEP
          IF((KR(IPM).EQ.IRS).AND.(iddm.EQ.0)) GOTO 9
          IORD1=MOD(KR(IPM),IRS )
          IORD2=MOD(KR(IPM)/IRS ,IRS )
          IF((IORD2.EQ.0.OR.IORD1.EQ.0).AND.(iddm.EQ.0)) GOTO 9
15        NUM=NUM+1 
          IF(IPREV.GT.IORD2)GOTO 40
          DO 21 J=IPREV,IORD2 
            FAZA=0.
            PRECOR=1.
            FDER = 0.
21          CALL CALCUL(J,FAZA,PRECOR,FDER)
40        IPREV=MAX0(IPREV,IORD2+1)
          CALL SUMMAT(IPM,cov,cov1,cov2,sigm1,sigm2,deri,derv,deli,chi2)
9       CONTINUE
        if(ns0.EQ.0) then ! Estimate scale factors if zero
         CALL CALCS0(ns0)
         if(ns0.EQ.1) go to 11
        end if
        IF(JOBTYP.GT.2)RETURN 
        DO 50 I=1,MAXS
          LCOUNT = ICOUNT(NPHASE,I) ! Correct rounding biases
          DO 50 J=I,MAXS
            cov(J,I)=cov(I,J)
            cov1(J,I)=cov1(I,J)
            cov2(J,I)=cov2(I,J)
50          SMM(J,I)=SMM(I,J)
        COND=DPINV(SMM,VX,MAXS,MSZ)
        CALL CHISQ
c
c Calculate e.s.u.
        if(iddm.NE.0) COND=DPINV(cov1,bias,MAXS,MAXS)
        if(LST2.EQ.-2) then 
         do i=1,MAXS
          do j = 1,MAXS
           if(iddm.EQ.0) SMM(i,j)=SMM(i,j)*chi2/FLOAT(NUM-MAXS)
           if(iddm.NE.0) SMM(i,j)=cov1(i,j)*chi2/FLOAT(NUM-MAXS)
          end do
         end do
        else
         co = 0.
         do i=1,MAXS
          do j = 1,MAXS
           if(iddm.EQ.0) co = co + SMM(i,j)*cov(i,j)
           if(iddm.NE.0) co = co + cov1(i,j)*cov2(i,j)
          end do
         end do
         co = chi2/(chi2-co)
         CALL MULMAT(SMM,MSZ,cov,MAXS)
         CALL MULMAT(cov,MAXS,SMM,MSZ)
         do i=1,MAXS
          do j = 1,MAXS
           SMM(i,j) = SMM(i,j)*co
          end do
         end do
        end if
c
C CODE TO ATTEMPT TO STABILIZE OSCILLATIONS
        DO 60 I=1,MAXS
          vxi = VX(I)
          IF(SIGN(1.,vxi).EQ.SIGN(1.,VLAST(I)))GOTO 60
          IF(ABS(vxi).GT.1.2*ABS(VLAST(I)))GOTO 60
          IF(ABS(vxi).LT..8*ABS(VLAST(I)))GOTO 60
          VX(I)=VX(I)/2.
60        VLAST(I)=VX(I)
        IIX = -1
        DO 5 I=1,MAXS
         if(SMM(I,I).LT.0) then
         write(iddmout,1110) I
         write(iconout,1110) I
1110     FORMAT(/' !!! Invalid variance of parameter ',I4,
     *   ' - check CORRELATIONS !!!'/)
         end if
         SMM(I,I) = ABS(SMM(I,I))
         X1=SQRT(SMM(I,I))*EPS
         if(ABS(VX(I)).GT.X1) IIX = IX
5       CONTINUE
c
        if(IIX.EQ.-1) then
         IIX = MCYCLE
         write(iddmout,1111)
         write(iconout,1111)
1111     FORMAT(/' Shifts for all parameters are < EPS*ESU'/)
        end if
c
c Systematic contribution to e.s.u.
       if(IIX.EQ.MCYCLE.AND.LST2.GT.0) then
        do i=1,MAXS
         do j=i,MAXS
          sigm1(j,i)=sigm1(i,j)
          sigm2(j,i)=sigm2(i,j)
         end do
        end do
        COND=DPINV(sigm1,BIAS1,MAXS,MAXS)
        COND=DPINV(sigm2,BIAS2,MAXS,MAXS)
        do i=1,MAXS
         bias(i) = DMAX1(SMM(i,i), 4.*BIAS1(i)*BIAS1(i), 2.*BIAS2(i)*BIAS2(i))
        end do
        do i=1,MAXS
         do j=1,MAXS
          if(i.NE.j) 
     *     SMM(i,j)=SMM(i,j)*SQRT(bias(i)*bias(j)/(SMM(i,i)*SMM(j,j)))
         end do
        end do
        do i=1,MAXS
         SMM(i,i)=bias(i)
        end do
       end if
       CALL OUTPTR(IIX)
       if(IIX.EQ.MCYCLE) exit
10    CONTINUE
c
      IF(MAT.EQ.0.OR.MAXS.EQ.0) RETURN
C
C     CODE FOR PRINTING CORRELATION MATRIX
C
      write(iddmout,7)
7     FORMAT(//,20H CORRELATION MATRIX )
      IA=1
      LIM=19
38    LIM=MIN0(MAXS,LIM)
      write(iddmout,8)(I,I=IA,LIM)
8     FORMAT(/4HParN ,19(I4,1H|))
      DO 39 I=1,MAXS
        L=0
        X=SMM(I,I)
        iprint = 0
        DO 400 J=IA,LIM
          L=L+1
          YY=SMM(J,J)*X
          KS(L)=100.*SMM(I,J)/(SQRT(ABS(YY))*SIGN(1.,YY))+0.5
400       if(I.NE.J.AND.KS(L).GE.MAT) iprint = 1
39     if(iprint.EQ.1) write(iddmout,12)I,(KS(J),J=1,L)
12    FORMAT(I4,19I5)
      IF(LIM.GE.MAXS)GOTO 37
      IA=LIM+1
      LIM=LIM+19
      GOTO 38
37    RETURN
      END 
c
      SUBROUTINE MULMAT(A, NA, B, NB) 
      DOUBLE PRECISION A(NA,NA), B(NB,NB), c(MIN(NA,NB))
c Multiplies matrix A to B, result in B
      N=MIN(NA,NB)
      do i=1,N
       do j=1,N
        c(j)=0.
        do k=1,N
         c(j)=c(j)+A(j,k)*B(k,i)
        end do
       end do
       do j=1,N
        B(j,i) = c(j)
       end do
      end do
      RETURN
      END
c
      SUBROUTINE MULMAT3(A,  B) 
      DIMENSION A(3,3), B(3,3), c(3)
c Multiplies matrix A to B, result in B
      do i=1,3
       do j=1,3
        c(j)=0.
        do k=1,3
         c(j)=c(j)+A(j,k)*B(k,i)
        end do
       end do
       do j=1,3
        B(j,i) = c(j)
       end do
      end do
      RETURN
      END
c
      SUBROUTINE MULMATT(A, B) 
      DIMENSION A(3,3), B(3,3), ab(3,3)
c Multiplies matrix A to transposed B, result in A
      do i=1,3
       do j=1,3
        c=0.
        do k=1,3
         c=c+A(j,k)*B(i,k)
        end do
        ab(j,i) = c
       end do
      end do
      do i=1,3
       do j=1,3
        A(i,j)=ab(i,j)
       end do
      end do
      RETURN
      END
C
      FUNCTION DPINV(A1,B1,N,NN) 
        INCLUDE 'DDM.inc'
      DOUBLE PRECISION A,B,A1,B1,C,T,U
      DIMENSION A1(NN,NN),B1(N),A(N,N),B(N),U(N),M(N)
c
      IF ( N.NE.1 ) GOTO 50
      A1(1,1) = 1./A1(1,1)
      B1(1) = B1(1)*A1(1,1)
      DPINV = 1
      GOTO 99
50    DPINV = 0
      DO 1 I=1,N
        B(I)=B1(I)
        DO 1 J=1,N
1         A(I,J)=A1(I,J)  
      DO 2 I=1,N
        U(I)=DABS(A(I,1))
        C=U(I)
        DO 3 J=2,N
          U(I)=DMAX1(U(I),DABS(A(I,J))) 
3         C=C+DABS(A(I,J))
        DPINV=AMAX1(DPINV,C)
        M(I)=I
        B(I)=B(I)/U(I)
        DO 2 J=1,N
2         A(I,J)=A(I,J)/U(I)
      DO 10 I=1,N
      IF(I.EQ.N)GOTO 15
      J=I
      I1=I+1
      MI=M(I)
      S=DABS(A(MI,I))
      DO 4 K=I1,N 
        MI=M(K)
        IF(DABS(A(MI,I)).LE.S)GOTO 4
        S=DABS(A(MI,I))
        J=K
4         CONTINUE
      MK1=M(J)
      M(J)=M(I)
      M(I)=MK1
15      MI1=M(I)
      A(MI1,I)=1./A(MI1,I)
      B(MI1)=B(MI1)*A(MI1,I)
      DO 20 J=1,N 
        IF(I.EQ.J)GOTO 20
        A(MI1,J)=A(MI1,J)*A(MI1,I)
20        CONTINUE
      DO 30 J=1,N 
        IF(J.EQ.I)GOTO 30
        MJ=M(J)
        T=A(MJ,I)
        MI1=M(I)
        B(MJ)=B(MJ)-T*B(MI1)
        A(MJ,I)=-T*A(MI1,I)
        DO 40 K=1,N
          IF(K.EQ.I)GOTO 40 
          A(MJ,K)=A(MJ,K)-T*A(MI1,K)
40          CONTINUE
30        CONTINUE
10      CONTINUE
      DO 93 I=1,N
      MI1=M(I)
      B1(I)=B(MI1)
      DO 94 J=1,N 
        MJ=M(J)
94        A1(I,MJ)=A(MI1,J)/U(MJ)
93      CONTINUE
      C=0 
      DO 91 I=1,N
      D=ABS(A1(I,1))
      DO 92 J=2,N 
92        D=D+ABS(A1(I,J))
91      C=AMAX1(C,D)
      DPINV=DPINV*C 
99    RETURN
      END 
c
      SUBROUTINE DIRECT(SM,V,IPH)
        INCLUDE 'DDM.inc'
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      DIMENSION V(6),SM(6,6)
      DO 1 J=1,6
        V(J)=PAR(IPH,J+5)
        K=LPAR(IPH,J+5)
        IF(K.LE.0) THEN
         X=0.
        ELSE
         X=APAR(IPH,J+5)
        END IF
        DO 1 L=J,6
          M=LPAR(IPH,L+5)
          SM(L,J)=0.
          IF((M.EQ.0).OR.(K.EQ.0))GOTO 1
          SM(L,J)=SMM(M,K)*X*APAR(IPH,L+5)
1         SM(J,L)=SM(L,J)
      CALL ESD(SM,V,1.,IPH)
      RETURN
      END 
c
      SUBROUTINE ESD(SM,V,SUM,IPH)
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      DIMENSION SM(6,6),V(6),S(6),R(6),E(6)
      I=0 
      DO 1 IA=1,3
        I=I+1
        IB=IA+1
        IF(IB.GT.3)IB=IB-3
        IC=IB+1
        IF(IC.GT.3)IC=IC-3
        ID=IA+3
        IE=IB+3
        IP=IC+3
        FNUM=4.*V(IB)*V(IC)-V(ID)*V(ID) 
        DEN=4.*V(IA)*V(IB)*V(IC)-V(IA)*V(ID)*V(ID)-V(IB)*V(IE)*V(IE)-V(I
     *   C)*V(IP)*V(IP)+V(ID)*V(IE)*V(IP)
        S(I)=SQRT(ABS(FNUM/DEN))
        R(IA)=-S(I)**4
        DENL=1./(DEN*DEN)
        R(IB)=DENL*(4.*V(IC)*DEN-(4.*V(IA)*V(IC)-V(IE)*V(IE))*FNUM)
        R(IC)=DENL*(4.*V(IB)*DEN-(4.*V(IA)*V(IB)-V(IP)*V(IP))*FNUM)
        R(ID)=-DENL*(2.*V(ID)*DEN-(2.*V(IA)*V(ID)-V(IE)*V(IP))*FNUM)
        R(IE)=DENL*FNUM*(2.*V(IB)*V(IE)-V(ID)*V(IP))
        R(IP)=DENL*FNUM*(2.*V(IC)*V(IP)-V(ID)*V(IE))
        E(I)=ERROR(SM,R,SUM)
        E(I)=E(I)/(2.*S(I))
        if(LPAR(IPH,I+8).EQ.0) then
         S(I+3) = SAVL(IPH,I+3)
         E(I+3) = 0.
         goto 1
        end if
        FNUM=V(IE)*V(IP)-2.*V(IA)*V(ID) 
        DEN=16.*V(IA)*V(IA)*V(IB)*V(IC)+V(IE)*V(IE)*V(IP)*V(IP)-4.*(V(IA
     *   )*V(IB)*V(IE)*V(IE)+V(IC)*V(IA)*V(IP)*V(IP))
        DENL=1./(DEN*DEN)
        FNUML=FNUM*FNUM
        S(I+3)=FNUML/DEN
        R(IA)=-4.*FNUM*DENL*(V(ID)*DEN+FNUM*(8.*V(IA)*V(IB)*V(IC)-V(IB)*
     *   V(IE)*V(IE)-V(IC)*V(IP)*V(IP)))
        R(IB)=-4.*FNUML*DENL*(4.*V(IA)*V(IA)*V(IC)-V(IA)*V(IE)*V(IE)) 
        R(IC)=-4.*FNUML*DENL*(4.*V(IA)*V(IA)*V(IB)-V(IA)*V(IP)*V(IP)) 
        R(ID)=-4.*FNUM/DEN*V(IA)
        R(IE)=2.*FNUM*DENL*(V(IP)*DEN-FNUM*(V(IE)*V(IP)*V(IP)-4.*V(IA)*V
     *   (IB)*V(IE)))
        R(IP)=2.*FNUM*DENL*(V(IE)*DEN-FNUM*(V(IE)*V(IE)*V(IP)-4.*V(IC)*V
     *   (IA)*V(IP)))
        E(I+3)=ERROR(SM,R,SUM)
        IF(S(I+3).EQ.0.0) GOTO 3
        E(I+3)=E(I+3)/(2.*SQRT(ABS(S(I+3)*(1.-S(I+3)))))*180./3.14159265359
        S(I+3)=ATAN(SQRT(ABS((1.-S(I+3))/S(I+3))))*180./3.14159265359
        GOTO 4
3       S(I+3)=90.
        E(I+3)=0.0
4       CONTINUE
        IF(FNUM.LT.0.)S(I+3)=180.-S(I+3)
        IF(SM(ID,ID).EQ.0.)E(ID)=0.
1       CONTINUE
      IF(ABS(S(1)-S(2)).LT..00008)E(1)=E(2)
      DO 2 I=1,6
        SM(I,I)=E(I)
2       V(I)=S(I)
      RETURN
      END 
c
      FUNCTION ERROR(A,B,OMEGA)
      DIMENSION A(6,6),B(6)
      SUM=0.
      DO 1 I=1,6
        DO 1 J=I,6
          X=2.
          IF(I.EQ.J)X=1.
1         SUM=SUM+A(I,J)*B(I)*B(J)*X
      IF(SUM.LT.0.)SUM=0.
      ERROR=SQRT(ABS(SUM*OMEGA))
      RETURN
      END 
c
      SUBROUTINE STEEP(X,N,M,CHIS,GRAD)
      DIMENSION Z(16),X(16),T(16),ZNT(16),SIGT(16),SIG(16)
      DIMENSION Y(16,16),XI(16),ZN(16)
      IF(N.EQ.0) RETURN
      CALL GRAD(X,Z)
      CALL CHIS(X,G)
      DO 10 I=1,M
        DO 10 J=1,M 
          Y(I,J)=0.0
          IF(I.EQ.J)Y(I,J)=1.0
10        CONTINUE
      DO 200 K=1,N
        U=0
        DO 20 I=1,M 
          T1=0
          DO 30 J=1,M
30          T1=T1+Z(J)*Y(I,J) 
          SIG(I)=T1 
20        U=U-SIG(I)*Z(I)
        ETA=AMIN1(1.0,ABS(2.*G/U))
        DO 40 I=1,M 
40        T(I)=X(I)-ETA*SIG(I)
        CALL GRAD(T,ZN)
        V=0
        DO 50 I=1,M 
50        V=V-ZN(I)*SIG(I)
        CALL CHIS(T,G1)
        D=3.*ABS(G-G1)/ETA+U+V
        W=SQRT(D*D-U*V)
        ALPHA=ETA*(1.-(V+W-D)/(V-U+2.*W))
        DO 60 I=1,M 
          SIG(I)=-1.0*ALPHA*SIG(I)
          X(I)=X(I)+SIG(I)
60        ZN(I)=Z(I)
        CALL GRAD(X,Z)
        CALL CHIS(X,G)
        T1=0
        DO 70 I=1,M 
          XI(I)=Z(I)-ZN(I)
70        T1=T1+XI(I)*SIG(I)
        DO 80 I=1,M 
80        SIGT(I)=SIG(I)/T1
        T1=0
        DO 90 I=1,M 
          T2=0
          DO 100 J=1,M
100         T2=T2+XI(J)*Y(I,J)
          ZN(I)=T2
90        T1=T1+ZN(I)*XI(I)
        DO 110 I=1,M
          T2=0
          DO 120 J=1,M
120         T2=T2+XI(J)*Y(J,I)
110       ZNT(I)=T2/T1
        DO 131 I=1,M
          DO 130 J=1,M
130         Y(I,J)=Y(I,J)+SIG(I)*SIGT(J)-ZN(I)*ZNT(J)
131       CONTINUE
200     CONTINUE
      RETURN
      END 
C
c	 
      SUBROUTINE COEF(J,K)
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/CNV/N,SINLAM(30),F(30)
      DIMENSION AB(10)
      EXTERNAL CV1,CV2
      DO 10 I=1,K
        SINLAM(I)=POSI(I)*POSI(I)
10      F(I)=SCAT(I)
      N=K 
      NN=MIN0(N,9)
      DO 15 I=1,NN
15      AB(I)=I
      NN1=NN+1
      DO 16 I=NN1,10
16      AB(I)=0
      CALL STEEP(AB,3,10,CV2,CV1)
      IF(AB(3).EQ.0.)AB(3)=-1E-6
      DO 20 I=1,9
20      AC(I,J)=AB(I)
      RETURN
      END
c
      SUBROUTINE CV1(AB,V)
      COMMON/CNV/N,SINLAM(30),F(30)
      DIMENSION AB(10),V(10)
      MAXX=MIN0(9,N)
      DO 30 K=1,MAXX,2
        V(K)=0
        DO 20 I=1,N 
          V(K)=V(K)+F(I)
          DO 20 J=1,MAXX,2
20          V(K)=V(K)-AB(J)*EXP(-AB(J+1)*SINLAM(I))
        V(K)=-2.*V(K)*EXP(-AB(K+1)*SINLAM(K))
30      V(K+1)=-V(K)*SINLAM(K)*AB(K)
      NN=MAXX+1
      DO 10 I=NN,10 
10      V(I)=0
      RETURN
      END 
c
      SUBROUTINE CV2(AB,G)
      COMMON/CNV/N,SINLAM(30),F(30)
      DIMENSION AB(10)
      MAXX=MIN0(9,N)
      G=0 
      DO 30 I=1,N
        T=F(I)
        DO 20 J=1,MAXX,2
20        T=T-AB(J)*EXP(-AB(J+1)*SINLAM(I))
30      G=G+T*T
      RETURN
      END 
 
c 
        INCLUDE 'FTABLE.inc'
c
      SUBROUTINE LOOKUP(K,N,NSCAT,XRAY,JOB)
        INCLUDE 'DDM.inc'
      CHARACTER*4 TABNC(128),TBXC(256)
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(4,8300),TABN(128), tbm(128)
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCATX
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      IOF=0
      NS=0
      IF(K.GT.1) THEN
        DO 4320 IIPHAS=2,K
4320      IOF = IOF + NATOM(IIPHAS-1)
      END IF
      IF(K.GT.1)NS=NSAVE
      IF(JOB.EQ.2.OR.JOB.EQ.4)GOTO 70
      DO 10 I=1,N
       NS=MAX0(NSCAT,NS)
       DO 20 J=1,NS
         IF(NTYP(I+IOF).EQ.NAM(J))GOTO 30
20       CONTINUE
       DO 40 J=1,215 ! N. of scattering sets
         IF(NTYP(I+IOF).EQ.TBXC(J))GOTO 50
40       CONTINUE
       write(iddmout,41)NTYP(I+IOF)
41     FORMAT(' SCATTERING COEFFICIENTS NOT FOUND FOR ',A4)
       STOP ' SCATTERING DATA MISSING' 
30     IPTR(I+IOF)=J
       GOTO 10
50     NS=NS+1
       IPTR(I+IOF)=NS
       DO 60 L=1,9 
60       AC(L,NS)=TBX(J,L)
       NAM(NS)=TBXC(J)
       ITBPTR=nint(TBX(J,10))
       XMAS(NS)=TBM(ITBPTR)
       ATOMN(NS)=ITBPTR
       l = 1
       do j = 1, 8299
        if(l.EQ.ITBPTR) then
         if(TBD(1,j).GE.XRAY.AND.TBD(1,j+1).LE.XRAY) then
          xratio = (XRAY-TBD(1,j+1))/(TBD(1,j)-TBD(1,j+1))
          DFP(NS)=TBD(2,j+1)+(TBD(2,j)-TBD(2,j+1))*xratio - ATOMN(NS)
          DFPP(NS)=TBD(3,j+1)+(TBD(3,j)-TBD(3,j+1))*xratio
          AMAC(NS)=TBD(4,j+1)+(TBD(4,j)-TBD(4,j+1))*xratio
          exit
         end if
        end if
        if(TBD(1,j).LT.TBD(1,j+1)) l = l + 1 ! Next atom counter
       end do
10    CONTINUE
      NSAVE=NS
      RETURN
70    DO 80 I=1,N
        NS=MAX0(NSCAT,NS)
        DO 90 J=1,NS
          IF(NTYP(I+IOF).EQ.NAM(J))GOTO 100
90        CONTINUE
        DO 110 J=1,85
          IF(NTYP(I+IOF).EQ.TABNC(J))GOTO 120
110       CONTINUE
        write(iddmout,111)NTYP(I+IOF)
111     FORMAT(34H SCATTERING LENGTHS NOT FOUND FOR ,A4)
        STOP ' SCATTERING DATA MISSING' 
100     IPTR(I+IOF)=J
        GOTO 80
120     NS=NS+1
        IPTR(I+IOF)=NS
        DFP(NS)=TABN(J)
        NAM(NS)=TABNC(J)
         if (j .ge. 61 .and. j .le. 81) goto 81
         if (j .eq. 82) goto 82
         if (j .ge. 83 .and. j .le. 85) goto 83
           goto 84
81          nsl = j+2
           goto 180
82           nsl = 90
           goto 180
83           nsl = j+9
           goto 180
84          nsl = j
180      XMAS(NS)=TBM(nsl)
80      CONTINUE
      NSAVE=NS
      RETURN
      END
c 
      SUBROUTINE CELL2
        INCLUDE 'DDM.inc'
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3) 
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     * (AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
c
      COS1(A) = COS(A*0.017453292519943295769236907684886)
      SIN1(A) = SIN(A*0.017453292519943295769236907684886)
      COSA = COS1(ALPHA)
      COSB = COS1(BETA) 
      COSC = COS1(GAMMA)
      SINA = SIN1(ALPHA)
      SINB = SIN1(BETA)
      SINC = SIN1(GAMMA)
      COSASR=(COSB*COSC-COSA)/(SINB*SINC)
      COSBSR=(COSA*COSC-COSB)/(SINA*SINC)
      COSCSR=(COSA*COSB-COSC)/(SINA*SINB)
      SINASR=SQRT(1.0-COSASR*COSASR)
      SINBSR=SQRT(1.0-COSBSR*COSBSR)
      ASTAR=1.0/(A*SINC*SINBSR)
      BSTAR=1.0/(B *SINC*SINASR)
      CSTAR=1.0/(C*SINA*SINBSR)
      BCCOSA=BSTAR*CSTAR*COSASR*2.0
      CACOSB=CSTAR*ASTAR*COSBSR*2.0
      BACOSC=BSTAR*ASTAR*COSCSR*2.0
      ASTAR=ASTAR*ASTAR
      BSTAR=BSTAR*BSTAR
      CSTAR=CSTAR*CSTAR
      RETURN
      END
c 
      SUBROUTINE REWRIT
        INCLUDE 'DDM.inc'
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),ICX(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
c
      REWIND iddmin
      write(iddmin,1) TITLE
1     FORMAT(A80)
      write(iddmin,'(A)') datfnm
      JOBTYP=JOBTYP-1
      NPROF=NPROF-1 
      write(iddmin,2)
     * JOBTYP,NPROF,NPHASE,NBCKGD,NEXCRG,NSCAT,INSTRM,IPREF,iSzStr
2     FORMAT(9(1X,I3),3X'<- JOB NPR NPH NBC NEX NSC INS IPR ISZ')
      write(iddmin,14) IWP,IPL,IPC,MAT,NXT,LST1,LST2,LST3,LST4
14    FORMAT(9(1X,I3),3X'<- IWP IPL IPC MAT NXT LS1 LS2 LS3 LS4')
      write(iddmin,23) WLAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,SAMPLE,bkcurv
23    FORMAT(2(1X,F7.5),7(1X,F7.3),1X,F5.1) 
      write(iddmin,30) MCYCLE,EPS,RELAX
30    FORMAT(I4,5(1X,F4.2),20X,'<- MCYCLE EPS RELAX[4]')
      write(iddmin,43) ndec, MAXSi, wddm, cddm, iwght
43    FORMAT(2(1X,I3),2(1X,F7.3),I5, 20X'<- NDEC MAXS WDDM CDDM IWGHT')
      N=0
      DO 4310 IP=1,NPHASE 
       DO 84 I=N+1,N+NATOM(IP)
        DO 84 J=1,11
         if(MAXS.LT.0) A(I,J) = 0
         if((LP(I,J).GT.KNUM.OR.MAXS.LT.0).AND.IABS(ndpar(IP)).NE.LP(I,J) 
     *   .AND.MAXSi.LE.0) LP(I,J) = 0
84       A(I,J)=SIGN(1.,A(I,J))*(FLOAT(10*LP(I,J))+ABS(A(I,J)))
4310  N=N+NATOM(IP)
      DO 87 I=1,NPHASE
        DO 88 J=1,6 
88        PAR(I,J+5)=SAVL(I,J)
        DO 87 J=1,npar
          if(MAXS.LT.0) APAR(I,J) = 0
          if((LPAR(I,J).GT.KNUM.OR.MAXS.LT.0).AND.MAXSi.LE.0) LPAR(I,J) = 0
87        APAR(I,J)=SIGN(1.,APAR(I,J))*(FLOAT(10*LPAR(I,J))+ABS(APAR(I,J
     *     )))
      DO 89 J=1,16
         if(MAXS.LT.0) AGLB(J) = 0
         if(LGLB(J).GT.KNUM.OR.MAXS.LT.0) LGLB(J) = 0
89      AGLB(J)=SIGN(1.,AGLB(J))*(FLOAT(10*LGLB(J))+ABS(AGLB(J)))
      write(iddmin,45)GLB(1),(GLB(J),J=10,14), ' <-DISP[3] ABSORP[3]'
      write(iddmin,46) AGLB(1),(AGLB(J),J=10,14)
45    FORMAT(3(1X,E9.4E1),3(1X,F8.5),A) 
46    FORMAT(3(1X,F9.2),3(1X,F8.2)) 
      write(iddmin,47)(GLB(J),J=2,7),(AGLB(J),J=2,7)
47    FORMAT(6(1X,G11.5),/,6(1X,F11.2)) 
c      IF(NBCKGD.LT.2)GOTO 120 
c      write(iddmin,34) (POS(I),BCK(I),I=1,NBCKGD)
34    FORMAT(2(1X,F7.2)) 
120   IF(NEXCRG.LE.0)GOTO 122 
      write(iddmin,34)(ALOW(I),AHIGH(I),I=1,NEXCRG)
122   IF(NSCAT.LE.0)GOTO 124
      DO 125 I=1,NSCAT
        write(iddmin,38)NAM(I),DFP(I),DFPP(I),XMAS(I),AMAC(I)
38      FORMAT(A4,4(1X,F8.4))
126     IF(JOBTYP.EQ.0)write(iddmin,39)(AC(J,I),J=1,9) 
39      FORMAT(9(1X,F8.5))
125     CONTINUE
124   CONTINUE
      if((NPROF.EQ.7).AND.(iSzStr.EQ.1)) write(iddmin,'(4(1X,F8.5),17X,A)')
     * UZXYS, '<- U Z X Y standard'
c 
      if(IBFILE.EQ.1) write(iddmin,'(7H$BFILE ,A)') bacfnm
      if(IQPA.EQ.1) write(iddmin,'(4H$QPA,F8.3,3(1X,1PG11.6),
     *  21H <- SWT DIFC TPS OMAC)') SWT,DIFC,TPS,OMAC
      if(IGEO.EQ.1) write(iddmin,'(7H$IGEOM ,I2)') IGEO
c
477   DO K=1,NPHASE
       IOF=0
       IF(K.GT.1) THEN
        do IIPHAS=2,K
         IOF = IOF + NATOM (IIPHAS-1)
        end do
       END IF
       write(iddmin,'(A)') PHSNM(K)
       write(iddmin,48)NATOM(K),ifur(K),ndpar(K),(PREF(K,I),I=1,3),PARS(K)
48      FORMAT(3(1X,I3),3(1X,F5.2),1X,F7.2,7X,
     *  '<- NATOM IFUR NDPAR PREF(hkl) PARS')
        N=NATOM(K)
        write(iddmin,'(2A)') HMSYMB(K),
     *   '   x         y         z       Biso      N     Anis Adist'
        do I = 1, N
         write(iddmin,65) ATEXT(I+IOF),NTYP(I+IOF),(XL(I+IOF,J),J=1,5),
     *    IANIS(I+IOF), ADIST(I+IOF), (A(I+IOF,J),J=1,5)
         if(IANIS(I+IOF).EQ.1)
     *    write(iddmin,66) (XL(I+IOF,J),J=6,11),(A(I+IOF,J),J=6,11)
        end do            
65      FORMAT(2(A4,1X),6X,4(1X,F9.6),1X,F10.5,1X,I2,1X,F6.3,/,
     *   16X,4(1X,F9.2),1X,F10.4)
66      FORMAT(6X,6(1X,F9.6),/, 6X,6(1X,F9.2))
C 
c      For Hexagonal lattice
      if(NSG(K).GE.143.AND.NSG(K).LE.194.AND.MAXIS(K).NE.-1) APAR(K,11)=0.
c
      write(iddmin,50) 
     *PAR(K,1), PAR(K,2),
     * APAR(K,1),APAR(K,2),
     *PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,20),PAR(K,15),PAR(K,16),
     *APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,20),APAR(K,15),APAR(K,16),
     *               (PAR(K,I),I=6,11), LAU1(K), (APAR(K,I),I=6,11), 
     *        PAR(K,12),PAR(K,13),PAR(K,14),PAR(K,48),PAR(K,49),
     *          APAR(K,12),APAR(K,13),APAR(K,14),APAR(K,48),APAR(K,49),
     *           PAR(K,17),PAR(K,18),PAR(K,19),
     *            APAR(K,17),APAR(K,18),APAR(K,19),
     *           fwhmlim(K,1),fwhmlim(K,2),ians(K,3) 
50      FORMAT(1X,G9.4,1X,F9.5,39X,'<- Scale, Overall B',/ 
     *     ,2(1X,F9.2),/,
     *        6(1X,E9.4E1),4X,'<- U V W Z X Y',/,6(1X,F9.2),/,
     *           6(1X,F9.5),1X,I2,1X,'<- Lattice LAUE',/,6(1X,F9.2),/,
     *               5(1X,F9.5),1X,'<- Pref.Or[2] Asymm[3]',/,
     *     5(1X,F9.2),/,3(1X,E9.4E1),24X,'<- Peak Shape NA, NB, NC ',/,
     *     3(1X,F9.2)/,2(1X,F8.6),1X,I2,40X,'<- FWHMmin FWHMmax IANS')
c        IF(IPREF.EQ.2)
       write(iddmin,'(6(1X,E9.4E1),'' <- Pref.Or.Ellips'',/,6(1X,F9.2))')
     *   (PAR(K,I),I=21,26), (APAR(K,I),I=21,26)
       write(iddmin,'(6(1X,E9.4E1),'' <- Aniso-Size'',/,6(1X,F9.2))')
     *   (PAR(K,I),I=27,32), (APAR(K,I),I=27,32)
       write(iddmin,'(6(1X,E9.4E1),'' <- Aniso-Strain'',/,6(1X,F9.4))')
     *   (PAR(K,I),I=33,38), (APAR(K,I),I=33,38)
       if(abs(ians(K,3)).EQ.2) then
        write(iddmin,'(6(1X,E9.4E1),/,6(1X,F9.4))')
     *   (PAR(K,I),I=39,44), (APAR(K,I),I=39,44)
        write(iddmin,'(3(1X,E9.4E1),/,3(1X,F9.4))')
     *   (PAR(K,I),I=45,47), (APAR(K,I),I=45,47)
       end if
      END DO
151   RETURN
      END
C
      SUBROUTINE INDDER
c
c Determines derivatives to be calculated
c
       INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
c
      DO IPH = 1, NPHASE
       do i = 1, 6
        IPRFD(IPH,i) = .false.
       end do
       do i=6,11
        if(LPAR(IPH,i).NE.0) IPRFD(IPH,1) = .true.
       end do
       if(LPAR(IPH,3).NE.0.OR.LPAR(IPH,4).NE.0.OR.LPAR(IPH,5).NE.0
     *  .OR.LPAR(IPH,15).NE.0.OR.LPAR(IPH,16).NE.0.OR.LPAR(IPH,20).NE.0)
     *   IPRFD(IPH,2) = .true.
c Anisotropy FWHM
       do M=27,47
        if(LPAR(IPH,M).NE.0) IPRFD(IPH,2) = .true.
       end do
c
       if(LGLB(1).NE.0.OR.LGLB(10).NE.0.OR.LGLB(11).NE.0) IPRFD(IPH,1) = .true.
       if(LPAR(IPH,14).NE.0.OR.LPAR(IPH,48).NE.0) ! Asymmetry 1,2
     *    IPRFD(IPH,3) = .true.
       if(LPAR(IPH,49).NE.0) IPRFD(IPH,4) = .true. ! FCJ ASYMMETRY
c
       if(NPROF.EQ.6.AND.(LPAR(IPH,17).NE.0.OR.LPAR(IPH,18).NE.0))
     *   IPRFD(IPH,6) = .true.
C
       if(NPROF.EQ.7.AND.(LPAR(IPH,17).NE.0.OR.LPAR(IPH,18).NE.0.OR.
     *   LPAR(IPH,19).NE.0)) IPRFD(IPH,5) = .true.
c
       IF(NPROF.EQ.8) THEN
        if(LPAR(IPH,3).NE.0.OR.LPAR(IPH,4).NE.0.OR.LPAR(IPH,5).NE.0.OR.
     *   LPAR(IPH,15).NE.0.OR.LPAR(IPH,16).NE.0.OR.LPAR(IPH,20).NE.0) 
     *  IPRFD(IPH,6) = .true.
c Aniso-FWHM
        do i=27,47
         if(LPAR(IPH,i).NE.0) IPRFD(IPH,6) = .true.
        end do
       END IF
       if(IPRFD(IPH,4)) then ! FCJ Asymmetry starting from zero
        SLDER = 0.
        if(PAR(IPH,49).LE.0) PAR(IPH,49) = 0.005
       end if
      END DO ! NPHASE cycle
      RETURN
      END
C
      SUBROUTINE SUMMAT(IPM,cov,cov1,cov2,sigm1,sigm2,deri,derv,deli,chi2)
       INCLUDE 'DDM.inc'
c
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/G3/COND,IORD1,IORD2,TH,NUM 
      COMMON/G4/TANN(NOV),ANS(NOV,27),DERSTO(NOV,MSZ)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
c
      DIMENSION DERIV(MAXS), DERIV1(MAXS), DERIV2(MAXS)
      DOUBLE PRECISION cov(MAXS,MAXS), sigm1(MAXS,MAXS), sigm2(MAXS,MAXS), chi2
      DOUBLE PRECISION cov1(MAXS,MAXS), cov2(MAXS,MAXS)
      DIMENSION deri(iddm*2+1,MAXS), derv(iddm*2+1,MAXS), deli(iddm*2+1)

c
      LOGICAL VERT
      DO 2 J=1,MAXS
        DERIV(J)=0. 
        DERIV1(J)=0. 
2       DERIV2(J)=0. 
      YCALC=0.
      IL=0
C-----CALCULATE THE CONTRIBUTION OF THE REFLECTIONS ORD1 TO ORD2 TO THE
C-----DERIVATIVES W.R.T. THE PROFILE INTENSITY YOBS
      IF(IORD1.EQ.0)GOTO 12
      DO 33 I=IORD1,IORD2
        IPH=IABS(IND4(IREFS(I),4))
        IF (NPROF.EQ.6) GAM1 = PAR(IPH,17) + PAR(IPH,18) * REFS(I,2)
        IF (NPROF.EQ.7) GAM1 = PAR(IPH,17) + PAR(IPH,18) / REFS(I,2)
     !                              + PAR(IPH,19)/REFS(I,2)/REFS(I,2) 
        IF (NPROF.EQ.7) CALL PRSVII(IPH)
        IL=IL+1
        J=MOD(I,NOV)+1
        VERT=REFS(I,2).LE.RLIM
c        SHIFT = GLB(10) * COS(REFS(I,2)/2./57.2958)
c     *           + GLB(11) * SIN(REFS(I,2)/57.2958)
c        SHIFT = GLB(10) * COS(REFS(I,2)/2./57.2958)
c     *           + GLB(11)*0.001/TAN(REFS(I,2)/2./57.2958)
c        SHIFT = GLB(10) * COS(REFS(I,2)/2./57.2958)
c     *           -GLB(11)*EXP(-REFS(I,2)*0.084)
c
c   Peak shift due to sample displacement and asymmetry
        SHIFT = PSHIFT(GLB(10),GLB(11),REFS(I,2))
        DELTA=TH-REFS(I,2)-GLB(1)-SHIFT 
        DELT=DELTA*DELTA
        TL=REFS(I,1)
c        ASYM = 0.
c        if(VERT) ASYM = PAR(IPH,14)*EXP(-REFS(I,2)*.084) ! Asymmetry correction !! 
        ASYM = PAR(IPH,14)*EXP(-REFS(I,2)*.084) ! Asymmetry correction !! 
C   Apply ASYM2      
        if(PAR(IPH,48).NE.0) ASYM = ASYM + PAR(IPH,48)*REFS(I,4)
     *   *TAN(REFS(I,2)*0.00872664625997)
        IF(NPROF.EQ.8) THEN
          TLL = HALFL(I)
          GAM1 = GAM(I)
          TLR = TLL/TL
        END IF
        BB=TL*TL
5       PRTEMP = PROFIL(NPROF,IPH,TL,REFS(I,2),DELTA,ASYM)
        OMEGA=REFS(I,3)*PRTEMP*PAR(IPH,1)/TL
        YCALC=YCALC+OMEGA*FF(I)
        IF(JOBTYP.GT.2)GOTO 33
        DO 3 K=1,MAXS
         DER=1.
         if(LPAR(IPH,3).EQ.K.OR.LPAR(IPH,4).EQ.K.OR.LPAR(IPH,5).EQ.K
     *   .OR.LPAR(IPH,15).EQ.K.OR.LPAR(IPH,16).EQ.K.OR.LPAR(IPH,20).EQ.K) then
          DER=PRFD(2)
          goto 3
         end if
c Anisotropy FWHM Correction
         do M=27,47
          if((LPAR(IPH,M).EQ.K)) then
           DER=PRFD(2)
           goto 3
          end if
         end do
c
         if(LGLB(1).EQ.K.OR.LGLB(10).EQ.K.OR.LGLB(11).EQ.K) then
          DER=PRFD(1)
          goto 3
         end if
         if(LPAR(IPH,14).EQ.K.OR.LPAR(IPH,48).EQ.K) then !! ASYM1,2
          DER=PRFD(3)
          goto 3
         end if
         if(VERT.AND.LPAR(IPH,49).EQ.K) then ! FCJ ASYMMETRY
          DER = SLDER
          goto 3
         end if
c
         if(NPROF.EQ.8) GO TO 8
c         
         if(NPROF.EQ.6.AND.(K.EQ.LPAR(IPH,17).OR.K.EQ.LPAR(IPH,18))) then
           DER=-PRFD(6)/PRTEMP
           goto 3
          end if
C
         if(NPROF.EQ.7.AND.(K.EQ.LPAR(IPH,17).OR.K.EQ.LPAR(IPH,18).OR.
     *                                           K.EQ.LPAR(IPH,19))) then
          DER=PRFD(5)
          goto 3
         end if
C
c         IF(NPROF.EQ.5) THEN 
c          KRP1=LGLB(8)
c          KRP2=LGLB(9)
c          YZ=2.*2.772588722*DELT/BB
c          YZ1=SIGN(SQRT(YZ),DELTA)
c          IF(K.EQ.KRP1)DER=EXP(-.5*YZ)*((YZ1*(YZ-3.)/6.
c     *         +GAM1/36.*(YZ*(YZ*(YZ-15.)+45.)-15.)))
c          IF(K.EQ.KRP2)DER=EXP(-.5*YZ)/24.*(YZ*(YZ-6.)+3.)
c         END IF
c
8        do M=6,11
          if(LPAR(IPH,M).EQ.K) then
           DER=PRFD(1)
           goto 3                 
          end if
         end do
3       DERIV(K)=DERSTO(J,K)*DER*OMEGA+DERIV(K) 
c
        IF(NPROF.EQ.8) THEN
          OMEGA8 = PAR(IPH,1)*REFS(I,3)/TL
          DO 1000 K=1,MAXS
            DO 1001 M=3,5
              IF (LPAR(IPH,M).NE.K) GO TO 1001
              DERIV(K) = DERIV(K)+0.5*OMEGA8*DERSTO(J,K)*PRFD(6)*
     *         (1.36603*TLR/TL-.95438*TLR*TLR/TL+.33348*TLR**3./TL)
1001        CONTINUE
              IF (LPAR(IPH,20).EQ.K) 
     *        DERIV(K) = DERIV(K)+0.5*OMEGA8*DERSTO(J,K)*PRFD(6)*
     *         (1.36603*TLR/TL-.95438*TLR*TLR/TL+.33348*TLR**3./TL)
            IF (LPAR(IPH,15).NE.K) GO TO 1002
            DERIV(K) = OMEGA8*PRFD(6)*
     *      ( TLR*DERSTO(J,K)/2. - FF(I)*TANN(J) ) *
     *      ( 1.36603 - (.95438 + .33348*TLR)*TLR ) + DERIV(K)
1002        CONTINUE
c Aniso-FWHM derivative
            do M=27,47
             if (LPAR(IPH,M).EQ.K) then
              if((M.GT.32).AND.(ians(IPH,3).LT.0)) then
              DERIV(K) = DERIV(K)+0.5*OMEGA8*DERSTO(J,K)*PRFD(6)*
     *         (1.36603*TLR/TL-.95438*TLR*TLR/TL+.33348*TLR**3./TL)
               cycle
              end if
              if(M.LE.32) TANT=SQRT(1+TANN(J)*TANN(J))
              if(M.GT.32) TANT=TANN(J)
              DERIV(K)=OMEGA8*PRFD(6)*( TLR*DERSTO(J,K)/2.
     *        - FF(I)*TANT*ANS(J,M-20) )*
     *        ( 1.36603 - (.95438 + .33348*TLR)*TLR ) + DERIV(K)
             end if
            end do
            IF (LPAR(IPH,16).NE.K) GO TO 1003
            DERIV(K) = OMEGA8*PRFD(6)*
     *      ( TLR*DERSTO(J,K)/2. - FF(I)*SQRT(1+TANN(J)*TANN(J)) ) *
     *      ( 1.36603 - (.95438 + .33348*TLR)*TLR ) + DERIV(K)
1003        CONTINUE
1000        CONTINUE
        END IF
33      CONTINUE
C-----FORM SUMS
12    IF(NBCKGD.NE.0)GOTO 1111
      DO 10 I=2,7
        IF(LGLB(I).EQ.0.)GOTO 10
        KM=LGLB(I)
        IF(I.EQ.2)DERIV(KM)=DERIV(KM)+1.
        IF(I.EQ.2)GOTO 10
        DERIV(KM)=DERIV(KM)+((THMIN+FLOAT(IPM-1)*STEP)/BKPOS-1.)**(I-2)
10      CONTINUE
c
c      Sample BOUNDARY correction
1111  IF(SAMPLE.GT.TH)
     * YCALC = YCALC/(1.+(.0128+.0106*(SAMPLE-TH))*(SAMPLE-TH))
      YC(IPM)=YCALC 
11    CONTINUE 
      IF (JOBTYP.GT.2) RETURN
c
      if(iddm.EQ.0) then ! Least squares
       DELTA=Y(IPM)-BK(IPM)-YCALC
       wsig = VAR(IPM)
       if(iwght.EQ.1) wsig = SQRT(wsig)
       if(LST2.GT.0.OR.iwght.LT.0) then
        wsig1 = wsig/(wsig+DELTA*DELTA)
        wsig2 = SQRT(wsig)/(YCALC+SQRT(wsig))
       end if
       vsig = 1./VAR(IPM)
       if(iwght.EQ.-1) vsig=vsig*wsig1
       if(iwght.EQ.-2) vsig=vsig*wsig2
       chi2 = chi2 + DELTA*DELTA*vsig
       do J=1,MAXS 
        X=DERIV(J)*vsig
        VX(J)=VX(J)+DELTA*X
c Systematic contribution to e.s.u.
        if(LST2.GT.0) then
         BIAS1(J)=BIAS1(J)+X*DELTA*wsig1
         BIAS2(J)=BIAS2(J)+X*DELTA*wsig2
        end if
        do K=J,MAXS
         SMM(J,K)=SMM(J,K)+X*DERIV(K)
         DEL = DELTA*DELTA
         if(LST2.GE.0) cov(J,K)=cov(J,K)+X*DELTA*DELTA*DERIV(K)*vsig
         if(LST2.EQ.-1) cov(J,K)=cov(J,K)+X*wsig*DERIV(K)*vsig
c Systematic contribution to e.s.u.
         if(LST2.GT.0) then
          sigm1(J,K)=sigm1(J,K)+X*DERIV(K)*wsig1
          sigm2(J,K)=sigm2(J,K)+X*DERIV(K)*wsig2
         end if
        end do
       end do
       RETURN
      end if
c DDM
      nc = iddm*2+1
      do J = 1, MAXS
       do l = 1, nc-1
        deri(l,J) = deri(l+1,J)
       end do
       deri(nc,J) = DERIV(J)
      end do
      if(IPM.LE.iddm+2) RETURN
      icurr = IPM-iddm
      ia = iconv(icurr)
      cn0 = ia*2+1
      cn1 = ia*(ia+1)*cn0
      cn2 = (4*ia*(ia+1)-3)*cn0
      c01 = -15./cn2  ! equals to c20         
      c10 = 3./cn1    
      c21 = 45./(cn2*ia*(ia+1))
      DELTA1 = 0.0
      DELTA2 = 0.0
      YC2 = 0.0
      do l = -ia, ia
       c1 = l*c10
       c2 = c01+c21*l*l
       DEL = Y(icurr+l)-BK(icurr+l)-YC(icurr+l)
       DELTA1=DELTA1+DEL*c1
       DELTA2=DELTA2+DEL*c2
       if(LST2.GT.0) YC2=YC2+YC(icurr+l)*c2
       do j = 1, MAXS
        DERIV1(j)=DERIV1(j)+deri(iddm+1+l,j)*c1
        DERIV2(j)=DERIV2(j)+deri(iddm+1+l,j)*c2
       end do
      end do
c
      wsig = 1.
      if(iwght.EQ.1) wsig = ia
      if(iwght.EQ.2) wsig = ia*ia
      do l = 1, nc-1
       deli(l) = deli(l+1)
      end do
      if(LST2.GE.0.OR.iwght.LT.0) then ! Include residuals to e.s.u.
       deli(nc) = VAR(icurr)*wsig*DELTA2*DELTA2/VAR2(icurr)
      else
       deli(nc) = VAR(icurr)
      end if
      chi2 = chi2 + wsig*DELTA2*DELTA2/VAR2(icurr)
      if(IPM.LT.nc) RETURN
c
      if(LST2.GT.0.OR.iwght.LT.0) then ! Systematic contribution
       wsig1 = VAR1(icurr)/(VAR1(icurr)/wsig + DELTA1*DELTA1)
       wsig2 = VAR2(icurr)/(VAR2(icurr)/wsig + DELTA2*DELTA2)
       wsig = SQRT(VAR2(icurr))/(ABS(YC2)+SQRT(VAR2(icurr)/wsig))
      end if
      vsig1 = 1./VAR1(icurr)
      vsig2 = 1./VAR2(icurr)
      if(iwght.EQ.-1) then
       vsig1=vsig1*wsig1
       vsig2=vsig2*wsig2
      end if
      if(iwght.EQ.-2) then
       vsig1=vsig1*wsig
       vsig2=vsig2*wsig
      end if
      do J=1,MAXS 
       X1 = DERIV1(J)*vsig1
       X2 = DERIV2(J)*vsig2
       VX(J)=VX(J)+DELTA1*X1+DELTA2*X2
C Systematic contribution to e.s.u.
       if(LST2.GT.0) then
        BIAS1(J) = BIAS1(J) + X1*DELTA1*wsig1 + X2*DELTA2*wsig2
        BIAS2(J) = BIAS2(J) + (X1*DELTA1 + X2*DELTA2)*wsig
       end if
       do l = 1, nc-1
        derv(l,J) = derv(l+1,J)
       end do
       derv(nc,J) = 0.
       do l = -ia, ia
        derv(iddm+1+l,J)=derv(iddm+1+l,J) + l*c10*X1 + (c01+c21*l*l)*X2
       end do
       X = DERIV(J)/VAR(icurr)
       do K=J,MAXS
        SMM(J,K)=SMM(J,K)+X1*DERIV1(K)+X2*DERIV2(K)
        cov1(J,K)=cov1(J,K)+X*DERIV(K)
        cov2(J,K)=cov2(J,K)+X*DERIV(K)*deli(nc)/VAR(icurr)
C Systematic contribution to e.s.u.
        if(LST2.GT.0) then
         sigm1(J,K) = sigm1(J,K) + X1*DERIV1(K)*wsig1 + X2*DERIV2(K)*wsig2
         sigm2(J,K) = sigm2(J,K) + (X1*DERIV1(K) + X2*DERIV2(K))*wsig
        end if
       end do
      end do
c
      do J=1,MAXS 
       do K=J,MAXS 
        cov(J,K)=cov(J,K)+derv(1,J)*derv(1,K)*deli(iddm+1)
       end do
      end do
c
      RETURN
      END 
C
      SUBROUTINE CALCUL(NN,FAZA,PRECOR,FDER)
      INCLUDE 'DDM.inc'

      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,SBX,WDT 
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      COMMON/G4/TANN(NOV),ANS(NOV,27),DERSTO(NOV,MSZ)
        character fwhfix(irs)*1
        common/fwcntr/ fwhfix
      DIMENSION HNN(3),H(3),AL(3,3),SM(3,3),T(3),XI(14)
      DIMENSION DERIV(MSZ),SNX(NATS),SINTL(NOV),SA(NATS),SB(NATS)
      DIMENSION TEMP(NATS),SNEX(NATS),SUMAX(NATS,9),SUMBX(NATS,9)
      LOGICAL VERT,PAC
c
      PI=114.591559
      IPH = IABS(IND4(IREFS(NN),4))
      IOF=0
      DO I=2,IPH
       IOF=IOF + NATOM(I-1)
      END DO
      IRL=MLT(IPH)
      N=NATOM(IPH)
      ICENT=ICET(IPH)
C-----ZEROIZE THE DERIVATIVES OF THIS REFLECTION W.R.T. TO PARAMETERS 
      NX=0
      DO I=1,NPHASE 
       NX=NX+NATOM(I)
      END DO
      DO 12 I=1,MSZ 
12      DERIV(I)=0. 
        FDER1 = 0.
      DO 21 I=1,NX
        DO 21 J=1,9 
          SUMBX(I,J)=0.
21        SUMAX(I,J)=0.
      CV=0.
      DV=0.
      AV=0.
      BV=0.
      PAC=(PAR(IPH,12).NE.0.0.OR.LPAR(IPH,12).NE.0 
     * .OR.PAR(IPH,13).NE.0.0.OR.LPAR(IPH,13).NE.0).AND.(PRECOR.NE.0.)
      DO 303 I=1,3
303     AL(I,I)=PAR(IPH,I+5)
      AL(2,3)=PAR(IPH,9)
      AL(1,3)=PAR(IPH,10)
      AL(1,2)=PAR(IPH,11)
      AH=PAR(IPH,3) 
      BH=PAR(IPH,4) 
      CH=PAR(IPH,5) 
      DH=PAR(IPH,20)
      IF (NPROF.EQ.8) THEN
        AH2=PAR(IPH,15)
        BH2=PAR(IPH,16)
      END IF
      B1=PAR(IPH,12)
      B2=PAR(IPH,13)
      NM=MOD(NN,NOV)+1
      ICX = 1
      if(IND4(IREFS(NN),4).LT.0) ICX = 2
      SLABDA=WLAMDA(ICX)*WLAMDA(ICX)/4.
      N=NATOM(IPH)
      if(ndec.EQ.0) FF(NN)=0.
      HNN(1)=IND4(IREFS(NN),1)
      HNN(2)=IND4(IREFS(NN),2)
      HNN(3)=IND4(IREFS(NN),3)
        if(FAZA.NE.0) then
         do i=1,3
          HNN(i)=HNN(i)*PRECOR
         end do
        end if
      DO 1 I=1,3
1       H(I)=HNN(I) 
C-----CALCULATION OF TEMP.FACTOR,POSITION AND FWHM
      TR=0.
      SS=0.
      DO 2 I=1,3
        DO 2 J=I,3
2         SS=AL(I,J)*HNN(I)*HNN(J)+SS
      PREXP  = 1.
      PREXP1 = 1.
      IF ((ians(IPH,1).EQ.1).AND.(PRECOR.NE.0)) THEN
        do i =1,3
         ANS(NM,i) = 0.001*HNN(i)*HNN(i)/SS
        end do
        ANS(NM,4) = 0.002*HNN(1)*HNN(2)/SS
        ANS(NM,5) = 0.002*HNN(1)*HNN(3)/SS
        ANS(NM,6) = 0.002*HNN(2)*HNN(3)/SS
        do i =1,6
        PREXP1 = PREXP1 + ANS(NM,i)*PAR(IPH,20+i)
        end do
        PREXP1=PREXP1**(-1.5)
        PRECOR=PREXP1
C        GO TO 13
      ELSE
        PRECOR=1.
      END IF
C
      IF(.NOT.PAC)GOTO 13
      TT=0.
      PAK=0.
      DO 33 I=1,3
        DO 33 J=I,3 
          TT=TT+AL(I,J)*PREF(IPH,I)*PREF(IPH,J)
33        PAK=PAK+AL(I,J)*(PREF(IPH,I)*HNN(J)+PREF(IPH,J)*HNN(I))/2.
      IF(TT.NE.0) PAK=PAK*PAK/(TT*SS)
c      if(fwhmlim(IPH,1).NE.0) REFS(NN,4) = fwhmlim(IPH,1) - PAK
      IF (IPREF.EQ.0) THEN
       PAKNN=1.57079633268**2
       IF(PAK.NE.0) PAKNN=ATAN(SQRT(ABS((1.-PAK)/PAK)))**2
       PREXP=EXP(B1*PAKNN)
       PRECOR=PREXP1*PREXP*(1.-B2)+B2
      ELSE
       if(B1.GT.0) PREXP = (B1*B1*PAK + (1.-PAK)/B1)**(-1.5)
       PRECOR=PREXP1*PREXP*(1.-B2)+B2
      END IF
13    SINTL(NM)=SQRT(SS)
      SSNN=0.25*SS
      SINTH=SLABDA*SS
      COSTH=1.-SINTH
      TANTH=SQRT(SINTH/COSTH) 
c
      if(PARS(IPH).GT.0) then
       ABSCOR=(1.-OMU/PMU(IPH))*exp(-PARS(IPH)*0.0002*PMU(IPH)/3.)
     * + OMU/PMU(IPH)
      else
       ABSCOR = 1.
      end if
      if(SS.GT.0) then
       sint = SQRT(SINTH)
c
c      Finite sample thickness, roughness and microabsorption correction
       IF(GLB(12).NE.0) ABSCOR=ABSCOR+GLB(12)*
     * exp(-PARS(IPH)*0.0002*(PMU(IPH)-OMU)/3.-GLB(13)/sint)
c
c      ABSORPtion correction for cylindrical sample
       IF(GLB(14).NE.0) 
     *  ABSCOR = ABSCOR*exp(-(1.7133 - 0.0368*sint*sint)*GLB(14)
     *  + (0.0927 + 0.375*sint*sint)*GLB(14)*GLB(14))
      end if
c
      TAV=EXP(-2.*PAR(IPH,2)*SSNN)*PRECOR*ABSCOR
c
      if(FAZA.NE.0) go to 3
      TANN(NM)=TANTH
      REFS(NN,2)=ATAN(TANTH)*PI
c
c       IF CALLED FROM DDMINPUT
      if((ndpar(IPH).EQ.0).AND.(FDER.EQ.1).AND.(NBCKGD.GE.0)) go to 1111
c
C-----CALCULATION OF COS(H.X),SIN(H.X) AND TEMP. FACTOR FOR EACH ATOM 
3     DO 8 I=1,N
        SNXI=0.
        SAI=0.
        SBI=0.
        DO 9 J=1,11
9         XI(J)=XL(I+IOF,J)
        DO 10 IR=1,IRL
          DO 301 J=1,3
            SM(J,1)=IND4(IMS(IPH,j,IR),1)
            SM(J,2)=IND4(IMS(IPH,j,IR),2)
            SM(J,3)=IND4(IMS(IPH,j,IR),3)
301         T(J)=FLOAT(IND4(IMS(IPH,j,IR),4))/12.0
          X=0.
          DO 6 II=1,3
            YY=0.
            X=T(II)*HNN(II)+X 
            DO 7 J=1,3
7             YY=SM(J,II)*HNN(J)+YY
6           H(II)=YY
          TR=X
          ARG=TR
          DO 11 J=1,3
11          ARG=H(J)*XI(J)+ARG
          ARG=6.28318530718*ARG
          if(IANIS(I+IOF).EQ.1) then
           ARG2=H(1)*H(1)*XI(6)+H(2)*H(2)*XI(7)+
     *        H(3)*H(3)*XI(8)+2.*H(1)*H(2)*XI(9)+2.*
     *              H(1)*H(3)*XI(10)+2.*H(2)*H(3)*XI(11)
           EXPARG=EXP(-ARG2)
          else
           EXPARG = 1.
          end if
          COSA=COS(ARG)*EXPARG
          SINA=SIN(ARG)*EXPARG
          SAI=SAI+COSA
          IF(ICENT.EQ.1)SBI=SINA+SBI
          DO 14 JJ=1,3
            SUMAX(I,JJ)=SUMAX(I,JJ)+H(JJ)*SINA
14          IF(ICENT.EQ.1)SUMBX(I,JJ)=SUMBX(I,JJ)+H(JJ)*COSA
          if(IANIS(I+IOF).EQ.1) then
           SUMAX(I,4)=SUMAX(I,4)+H(1)*H(1)*COSA
           SUMAX(I,5)=SUMAX(I,5)+H(2)*H(2)*COSA
           SUMAX(I,6)=SUMAX(I,6)+H(3)*H(3)*COSA
           SUMAX(I,7)=SUMAX(I,7)+H(1)*H(2)*COSA
           SUMAX(I,8)=SUMAX(I,8)+H(1)*H(3)*COSA
           SUMAX(I,9)=SUMAX(I,9)+H(2)*H(3)*COSA
           IF(ICENT.NE.1)GOTO 10
           SUMBX(I,4)=SUMBX(I,4)+H(1)*H(1)*SINA
           SUMBX(I,5)=SUMBX(I,5)+H(2)*H(2)*SINA
           SUMBX(I,6)=SUMBX(I,6)+H(3)*H(3)*SINA
           SUMBX(I,7)=SUMBX(I,7)+H(1)*H(2)*SINA
           SUMBX(I,8)=SUMBX(I,8)+H(1)*H(3)*SINA
           SUMBX(I,9)=SUMBX(I,9)+H(2)*H(3)*SINA
          end if
10        CONTINUE
        TEMP(I)=EXP(-XL(I+IOF,4)*SSNN)
        SA(I)=SAI
        SB(I)=SBI
        NI=IPTR(I+IOF)
        BNI=DFPP(NI)
        FFX=DFP(NI) 
        AC(10,NI)=0.
        DO 302 II=1,9,2
302       FFX=FFX+AC(II,NI)*EXP(-AC(II+1,NI)*SSNN)
        SNEXI=FFX*XL(I+IOF,5)*TEMP(I)
        SNXI=BNI*XL(I+IOF,5)*TEMP(I)
C-----CALCULATE A AND B OF F
        AV=SNEXI*SAI+AV
        BV=SNEXI*SBI+BV
        SNEX(I)=2.*SNEXI*TAV*RATIO(ICX) 
        SNX(I)=2.*SNXI*TAV*RATIO(ICX)
        CV=CV+SNXI*SAI
        DV=DV+SNXI*SBI
8       CONTINUE
        FFCLC=RATIO(ICX)*(CV*CV+AV*AV+DV*DV+BV*BV)*TAV
      if(ndec.EQ.0) FF(NN)= FFCLC
120   FNN=FF(NN)
        if(FAZA.NE.0.) then
         SAI = AV - DV
         SBI = CV + BV
         F1=sqrt(SAI*SAI + SBI*SBI)
         if(SAI.EQ.0.) then
          Fi1 = SIGN(1.5707963,SBI)
         else
          Fi1 = ATAN(SBI/SAI)
          if(SAI.LT.0.) Fi1 = Fi1 + SIGN(3.141596,SBI)
         end if
         SAI = AV + DV
         SBI = CV - BV
         F2=sqrt(SAI*SAI + SBI*SBI)
         if(SAI.EQ.0.) then
          Fi2 = SIGN(1.5707963,SBI)
         else
          Fi2 = ATAN(SBI/SAI)
          if(SAI.LT.0.) Fi2 = Fi2 + SIGN(3.141596,SBI)
         end if
         FF(NN)=FFCLC/ABSCOR
         SAI = F1*cos(Fi1) + F2*cos(Fi2)
         SBI = F1*sin(Fi1) - F2*sin(Fi2) 
         if(SAI.EQ.0.) then
          FAZA = SIGN(1.5707963,SBI)
         else
          FAZA = ATAN(SBI/SAI)
          if(SAI.LT.0.) FAZA = FAZA + SIGN(3.141596,SBI)
         end if
         RETURN
        end if
c      IF((MAXS.EQ.0).AND.(ndpar(IPH).EQ.0)) RETURN
C-----CALCULATE DERIVATIVES
      DO 17 I=1,N
        SNEXI=SNEX(I)
        SNXI=SNX(I) 
        SAI=SA(I)
        SBI=SB(I)
        DO 22 J=1,11
          K=LP(I+IOF,J)
          IF(K.EQ.0) GOTO22
          IF(J.GT.5) GOTO 221 
          IF(J.GT.3)GOTO 29
          SUMA=SUMAX(I,J)
          SUMB=SUMBX(I,J)
          DER=-((AV*SUMA-BV*SUMB)*SNEXI+(CV*SUMA-DV*SUMB)*SNXI)*6.283185
     *     3071
          GOTO 26
29        IF(J.GT.4)GOTO 31
          DER=-((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)*SSNN
          GOTO 26
31        DER=((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)/XL(I+IOF,5)
          GOTO 26
221       SUMA=SUMAX(I,J-2)
          SUMB=SUMBX(I,J-2)
          DER=-((AV*SUMA+BV*SUMB)*SNEXI+(CV*SUMA+DV*SUMB)*SNXI)
          IF(J.GE.9)DER=2.*DER
26        DERIV(K) = SIGN(1.,A(I+IOF,J))*DER+DERIV(K)
          if(K.EQ.IABS(ndpar(IPH))) FDER1 = FDER1+A(I+IOF,J)*DER
22        CONTINUE
17      CONTINUE
c
          ANISO1 = 0.
1111      ANISO2 = 0.
         if(ndpar(IPH).EQ.0.OR.ians(IPH,2).EQ.0) then ! if defects are absent
          if(ians(IPH,2).EQ.1) ANISO1 = 1.
         else
          if((ABS(FDER1).GT.0.01).AND.(FFCLC.GE.10.)) then
           FDER1  = ABS(FDER1/FFCLC) !!! -FDER1/FF(NN)
          else
           FDER1  = 0.
          end if
          ANISO1=FDER1*.5 !!! PAR(1,17)/(1.-PAR(1,17)*FDER1)
         end if
        if(ians(IPH,2).EQ.1) then  ! Anisotropic Size
         do i =1,3
          ANS(NM,i+6) = ANISO1*.001*HNN(i)*HNN(i)/SS
         end do
         ANS(NM,10) = ANISO1*.002*HNN(1)*HNN(2)/SS
         ANS(NM,11) = ANISO1*.002*HNN(1)*HNN(3)/SS
         ANS(NM,12) = ANISO1*.002*HNN(2)*HNN(3)/SS
         ANISO1 = 0.
         do i =7,12
         ANISO1 = ANISO1 + ANS(NM,i)*PAR(IPH,20+i)
         end do
         if(NPROF.EQ.8) then
          if((ndpar(IPH).NE.0).AND.(FDER1.NE.0.)) ANISO1=ANISO1*2./FDER1
          if(ANISO1.GE.0.) ANISO1 = sqrt(ANISO1)
          if(ANISO1.LT.0.) ANISO1 = -sqrt(-ANISO1)
          if(ANISO1.NE.0.) then
           do i = 7, 12
            ANS(NM,i) = ANS(NM,i)*0.5/ANISO1
           end do
          end if
          if(ndpar(IPH).NE.0) ANISO1 = ANISO1*0.5*FDER1
         end if
        end if
        if(abs(ians(IPH,3)).EQ.1) then ! Aniso-Strain (Ellips model)
         do i =1,3
          ANS(NM,i+12) = .001*HNN(i)*HNN(i)/SS
         end do
         ANS(NM,16) = .002*HNN(1)*HNN(2)/SS
         ANS(NM,17) = .002*HNN(1)*HNN(3)/SS
         ANS(NM,18) = .002*HNN(2)*HNN(3)/SS
         do i =13,18
         ANISO2 = ANISO2 + ANS(NM,i)*PAR(IPH,20+i)
         end do
        end if
        if(abs(ians(IPH,3)).EQ.2) then ! Aniso-Strain (Stephens model)
         SS2 = SS*SS*10000.
         do i =1,3
          ANS(NM,i+12) = HNN(i)**4/SS2
         end do
         ANS(NM,16) = 3.*(HNN(1)*HNN(2))**2/SS2
         ANS(NM,17) = 3.*(HNN(1)*HNN(3))**2/SS2
         ANS(NM,18) = 3.*(HNN(2)*HNN(3))**2/SS2
         ANS(NM,19) = 2.*HNN(2)*HNN(1)**3/SS2
         ANS(NM,20) = 2.*HNN(1)*HNN(3)**3/SS2
         ANS(NM,21) = 2.*HNN(3)*HNN(2)**3/SS2
         ANS(NM,22) = 2.*HNN(1)*HNN(2)**3/SS2
         ANS(NM,23) = 2.*HNN(3)*HNN(1)**3/SS2
         ANS(NM,24) = 2.*HNN(2)*HNN(3)**3/SS2
         ANS(NM,25) = 4.*HNN(2)*HNN(3)*HNN(1)**2/SS2
         ANS(NM,26) = 4.*HNN(1)*HNN(3)*HNN(2)**2/SS2
         ANS(NM,27) = 4.*HNN(2)*HNN(1)*HNN(3)**2/SS2
         do i =13,27
         ANISO2 = ANISO2 + ANS(NM,i)*PAR(IPH,20+i)
         end do
        end if
        if((ians(IPH,3).GT.0).AND.(NPROF.EQ.8)) then
         if(ANISO2.GE.0.) ANISO2 = sqrt(ANISO2)
         if(ANISO2.LT.0.) ANISO2 = -sqrt(-ANISO2)
         if(ANISO2.NE.0.) then
          do i = 13, 27
           ANS(NM,i) = ANS(NM,i)*0.5/ANISO2
          end do
         end if
        end if
c
      HALFG(NN) = (AH*TANTH*TANTH+BH*TANTH+CH+DH/COSTH)
      if(NPROF.NE.8) then
       HALFG(NN) = HALFG(NN) + ANISO1/COSTH + ANISO2*TANTH*TANTH
       HALFL(NN) = ANISO1 ! to print later
      else
       if(ians(IPH,3).LT.0) HALFG(NN) = HALFG(NN) + ANISO2*TANTH*TANTH
      end if
      IF(HALFG(NN).GT.0) THEN
        HALFG(NN) = SQRT(HALFG(NN))
      ELSE
        write(iddmout,3456) REFS(NN,2),IPH
c        write(iconout,3456) REFS(NN,2),IPH
        STOP 'SQUARE OF FWHM IS NEGATIVE'
3456    FORMAT (3X,'SQUARE OF FWHM NEGATIVE AT TWO-THETA',F8.3,
     *     'FOR PHASE NO. ',I4)
      END IF
      IF (NPROF.EQ.8) THEN
        if(fwhfix(NN).EQ.'n') then
         HALFL(NN)=AH2*TANTH+(BH2+ANISO1)*SQRT(1.+TANTH*TANTH)
         if(ians(IPH,3).GT.0) HALFL(NN) = HALFL(NN) + ANISO2*TANTH
        end if
        BB = (HALFG(NN)**5.+2.69269*HALFG(NN)**4.*HALFL(NN)+
     *     2.42843*HALFG(NN)**3.*HALFL(NN)**2.+
     *        4.47163*HALFG(NN)**2.*HALFL(NN)**3. +
     *           0.07842*HALFG(NN)*HALFL(NN)**4. + HALFL(NN)**5.)**0.2
        TLR = HALFL(NN)/BB
        GAM(NN) = 1.36603*TLR-0.47719*TLR*TLR+0.11116*TLR**3.
      ELSE
        BB = HALFG(NN)
      END IF
C-----VERT=.TRUE. IF ASYMMETRY CORRECTION IS TO BE CALCULATED
      VERT=REFS(NN,2).LE.RLIM 
C     !!
C Split FWHM asymmetry
      BB=BB + abs(PAR(IPH,14))*EXP(-REFS(NN,2)*.084) 
     * + abs(PAR(IPH,48)*REFS(NN,4))*TANTH
      if(ICX.EQ.2) BB=BB+0.005*TANTH ! Kalpha2 broadening
c /(1.+REFS(NN,2)*REFS(NN,2)*0.1)
      BB = BB*BB
      BH = BB
      if((fwhfix(NN).EQ.'y').AND.(NPROF.NE.8)) then
       BB = REFS(NN,1)*REFS(NN,1)
      else
       REFS(NN,1)=SQRT(BB)
      end if
      TL=REFS(NN,1)
        if(FDER.NE.0.) then
         FDER = ANISO1
         return
        end if
c
      IF((MAXS.EQ.0).AND.(ndpar(IPH).EQ.0)) RETURN
c
C-----CALCULATE DERIVATIVES
c
      K=LPAR(IPH,12)
      IF (IPREF.EQ.0) THEN
        IF(K.NE.0)DERIV(K)=DERIV(K)+ PAKNN*(1.-B2)*PREXP*PREXP1
     *                      *FNN/PRECOR
      ELSE
        IF(K.NE.0)DERIV(K)=DERIV(K)-1.5*(2.*B1*PAK - (1.-PAK)/(B1*B1))
     *                     *(PREXP**1.6666667)*(1.-B2)*PREXP1*FNN/PRECOR
      ENDIF

      K=LPAR(IPH,13)
      IF(K.NE.0) DERIV(K)=DERIV(K)+(1.-PREXP*PREXP1)*FNN/PRECOR
C
      IF (ians(IPH,1).EQ.1) THEN
       do J = 1,6
        K=LPAR(IPH,J+20)
        if(K.NE.0) DERIV(K)=DERIV(K)-1.5*(PREXP1**1.6666667)*ANS(NM,J)
     *                              *(1.-B2)*PREXP*FNN/PRECOR
       end do
      ENDIF
C
      K=LPAR(IPH,2) 
      IF(K.NE.0)DERIV(K)=DERIV(K)-2.*SSNN*FNN
      K=LPAR(IPH,1) 
      IF(K.NE.0)DERIV(K)=DERIV(K)+FNN/PAR(IPH,1)
c
c      Sample thickness, roughness and absorption derivatives
c        
      K=LGLB(12) 
      IF(K.NE.0) DERIV(K)=DERIV(K)+exp(-GLB(13)/sint)*FNN/ABSCOR
      K=LGLB(13) 
      IF(K.NE.0) 
     *  DERIV(K)=DERIV(K)-GLB(12)*exp(-GLB(13)/sint)*FNN/(ABSCOR*sint)
      K=LGLB(14) 
      IF(K.NE.0) DERIV(K)=DERIV(K)+
     *  exp(-(1.7133 - 0.0368*sint*sint)*GLB(14) +
     * (0.0927 + 0.375*sint*sint)*GLB(14)*GLB(14))*
     * (2.*(0.0927 + 0.375*sint*sint)*GLB(14)-
     * (1.7133 - 0.0368*sint*sint))*FNN/ABSCOR
C
      K=LPAR(IPH,49) ! FCJ ASYMMETRY
      IF(K.NE.0.AND.VERT) DERIV(K) = DERIV(K) + FNN
      SINTH=FNN*PI*SLABDA/(SQRT(SINTH*COSTH)*BB)
      SS=FNN/TL
      if(fwhfix(NN).EQ.'y') goto 9211 ! Fixed FWHM
c  Anisotropy FWHM Correction
      if(NPROF.NE.8) then
       if(ians(IPH,2).EQ.1) then  ! size model
        X =SS/COSTH
        do J = 7,12
         K=LPAR(IPH,J+20)
         if(K.NE.0) DERIV(K)=X*ANS(NM,J) + DERIV(K)
        end do
       end if
       if(ians(IPH,3).GT.0) then ! strain model
        X =SS*TANTH*TANTH
        do J = 13, 27
         K=LPAR(IPH,J+20)
         if(K.NE.0) DERIV(K)=X*ANS(NM,J) + DERIV(K)
        end do
       end if
      end if
c
      X=TANTH*TANTH 
      IF (NPROF.EQ.8) GO TO 9211
      DO 78 J=3,5
        K=LPAR(IPH,J)
        IF(K.EQ.0)GOTO 78
        DERIV(K)=X*SS+DERIV(K)
78      X=X/TANTH
      K=LPAR(IPH,20)
      IF(K.NE.0) DERIV(K)=SS/COSTH+DERIV(K)
9211  CONTINUE
      IF (NPROF.EQ.8) THEN
        TL = REFS(NN,1)**(-4)
        TLG = HALFG(NN)
        TLL = HALFL(NN)
        DHDHG = 0.2*TL*(5.*TLG**4.+10.77076*TLG**3.*TLL+
     *        7.28529*TLG*TLG*TLL*TLL+8.94326*TLG*TLL**3.
     *         + 0.07842*TLL**4.)
        DHDHL = TL*(2.69269*TLG**4.+ 4.85686*TLG**3.*TLL
     *      +13.41489*TLG*TLG*TLL*TLL + 0.31368*TLG*TLL**3.+5.*TLL**4.)
        DO 9078 J=3,5
          K=LPAR(IPH,J)
          IF(K.EQ.0)GOTO 9078 
          DERIV(K)=DHDHG*X*SS+DERIV(K)
9078      X=X/TANTH 
        K=LPAR(IPH,20)  
        IF  (K.NE.0) DERIV(K)=DHDHG*SS/COSTH  + DERIV(K)
        if(fwhfix(NN).EQ.'y') goto 9214 ! Fixed FWHM
        K = LPAR(IPH,15)
        IF (K.EQ.0) GO TO 9213
        DERIV(K) = FNN*DHDHL*TANTH + DERIV(K)
9213    CONTINUE
c  Anisotropy FWHM Correction
       do J = 7,27
        K=LPAR(IPH,J+20)
        if(K.NE.0) then
         if(J.LE.12) then  ! size model
          DERIV(K)=FNN*DHDHL*ANS(NM,J)/SQRT(COSTH)+DERIV(K)
         else  ! strain model
          if(ians(IPH,3).GT.0) DERIV(K)=FNN*DHDHL*ANS(NM,J)*TANTH
     *                                +DERIV(K)
          if(ians(IPH,3).LT.0) DERIV(K)=DHDHG*SS*ANS(NM,J)*TANTH
     *                                +DERIV(K)
         end if
        end if
       end do
        K = LPAR(IPH,16)
        IF (K.EQ.0) GO TO 9214
        DERIV(K) = FNN*DHDHL/SQRT(COSTH) + DERIV(K)
9214    CONTINUE
c       X = X/H123
c       X = X*2.
c        K=LPAR(IPH,24)
c        if(K.NE.0) DERIV(K)=X*HNN(1)*HNN(2) + DERIV(K)
c        K=LPAR(IPH,25)
c        if(K.NE.0) DERIV(K)=X*HNN(1)*HNN(3) + DERIV(K)
c        K=LPAR(IPH,26)
c        if(K.NE.0) DERIV(K)=X*HNN(2)*HNN(3) + DERIV(K)
      END IF
9079  K = LPAR(IPH,17)
      IF(K.NE.0.AND.(NPROF.EQ.6.OR.NPROF.EQ.7)) DERIV(K)=DERIV(K)+ FNN
      K = LPAR(IPH,18)
      IF(K.NE.0.AND.NPROF.EQ.6) DERIV(K)=DERIV(K)+ FNN * REFS(NN,2)
      IF(K.NE.0.AND.NPROF.EQ.7) DERIV(K)=DERIV(K)+ FNN / REFS(NN,2)
      K = LPAR(IPH,19)
      IF(K.NE.0.AND.NPROF.EQ.7)DERIV(K)=DERIV(K)+FNN/REFS(NN,2)
     !                                              /REFS(NN,2)
      K=LGLB(1)
      IF(K.NE.0)DERIV(K)=2.*FNN/BB+DERIV(K)
      K=LGLB(10)
      IF (K.NE.0) then
       if(IGEO.EQ.0) then
        DERIV(K)=DERIV(K)+2.*FNN/BB*SQRT(COSTH)
       else
        DERIV(K)=DERIV(K)+2.*FNN/BB*COS(REFS(NN,2)*0.0174532925199432957692369)
       end if
      end if
      K=LGLB(11)
c      IF (K.NE.0) DERIV(K) = DERIV(K)+2.*FNN/BB*SIN(REFS(NN,2)/57.2958)
      IF (K.NE.0) then 
       if(IGEO.EQ.0) then
        DERIV(K) = DERIV(K)-2.*FNN/BB*(1.56-ATAN(REFS(NN,2)))
       else
        DERIV(K) = DERIV(K)-2.*FNN/BB*EXP(-REFS(NN,2)*.084)
       end if
      end if
c
      DO 79 J=1,6
        K=LPAR(IPH,J+5)
        IF(K.EQ.0)GOTO 79
        IF(J.LT.4)X=HNN(J)*HNN(J)
        IF(J.EQ.4)X=HNN(2)*HNN(3)
        IF(J.EQ.5)X=HNN(1)*HNN(3)
        IF(J.EQ.6)X=HNN(1)*HNN(2)
        DERIV(K)=X*SINTH+DERIV(K)
79      CONTINUE
      K=LPAR(IPH,14)
      IF(K.NE.0) DERIV(K) = DERIV(K) + FNN*EXP(-REFS(NN,2)*.084)
C  ASYM2
      K=LPAR(IPH,48)
      IF(K.NE.0) DERIV(K) = DERIV(K) + FNN*TANTH*REFS(NN,4)
C-----STORE DERIVATIVES FOR LIMO REFLECTIONS AT A TIME
      DO 80 I=1,MAXS
80      DERSTO(NM,I)=DERIV(I) 
48    RETURN
      END 
C
      FUNCTION PROFIL(N,NPH,TL,TTHETA,DELTA,ASYM)
        INCLUDE 'DDM.inc'
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
C
      if(TTHETA.LT.RLIM.AND.PAR(NPH,49).GT.0) then
       PROFIL = FCJASYM(N,NPH,TL,DELTA,TTHETA,PAR(NPH,49),ASYM)
      else
       TTLL = TL
       if(ASYM.NE.0) TTLL = TL - SIGN(1.,DELTA)*ASYM
       DELTA2 = DELTA*DELTA
       DELT = DELTA2/(TTLL*TTLL)
       PROFIL = PROF(N,NPH,DELT)
       if(IPRFD(NPH,1)) PRFD(1) = DELTA*PRFDER
       if(IPRFD(NPH,2)) PRFD(2) = (PRFDER*DELT-0.5)/TL
       if(IPRFD(NPH,3)) PRFD(3) = (SIGN(1.,-DELTA)*PRFDER*2.*DELT-1.)/TL
       if(IPRFD(NPH,5).OR.IPRFD(NPH,6)) DELT = DELTA2/(TL*TL)
       if(IPRFD(NPH,5)) PRFD(5) =  TF4(NPH)*DELT/(1.+TF9(NPH)*DELT)+TF8(NPH)-
     *        ALOG(1.+TF9(NPH)*DELT)
       if(IPRFD(NPH,6)) PRFD(6) = 
     * .939437279*EXP(-2.772588722*DELT)-.636619772/(1.+4.*DELT)
      end if
      RETURN
      END 
C
      FUNCTION SIND(A)
       SIND = SIN(A*0.017453292519943295769236907684886)
      RETURN
      END
C
      FUNCTION COSD(A)
       COSD = COS(A*0.017453292519943295769236907684886)
      RETURN
      END
C
      FUNCTION TAND(A)
       TAND = TAN(A*0.017453292519943295769236907684886)
      RETURN
      END
C
      FUNCTION ACOSD(A)
       ACOSD = ACOS(A)*57.295779513082320876798154814105
      RETURN
      END
C
      FUNCTION FCJASYM(NPRF,NPH,TL,DTT,TTHETA,SL,ASYM)
       INCLUDE 'DDM.inc'
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
c
c Finger-Cox-Jephcoat (FCJ94) asymmetry correction 
c   [L.W. Finger, D.E. Cox & A.P. Jephcoat (1994) J. Appl. Cryst.,27,892-900.]

c        
      INTEGER*4     NGT                 !number of terms in Gaussian quadrature
      INTEGER*4     NUMTAB              ! number of pre-computed Gaussian tables
      parameter      (numtab=14)
      INTEGER*4     NTERMS(NUMTAB)      ! number of terms in each table - must be even
      INTEGER*4     FSTTERM(NUMTAB)     ! location of 1st term: N.B. N/2 terms
      LOGICAL*4     CALCLFG(NUMTAB)     ! true if table has previously been calculated
      INTEGER*4     ARRAYNUM            ! number of selected array
      INTEGER*4     ARRAYSIZE           ! size of complete array
      parameter      (arraysize=1883)
      REAL        XP(ARRAYSIZE)       !Gaussian abscissas
      REAL        WP(ARRAYSIZE)       !Gaussian weights
      REAL        XPT(1000)           !temporary Gaussian abscissas
      REAL        WPT(1000)           !temporary Gaussian weights
      save      calclfg,xp,wp          !Values to be saved across calls
c
      DATA      NTERMS                ! number of terms in each table - must be even
     1  /6,10,20,40,60,80,100,150,200,300,400,600,800,1000/
C       note that nterms determines both arraysize and fstterm
      DATA      FSTTERM                ! loc. of 1st term: N.B. N/2 terms are saved
     1  /0,3,8,18,38,68,108,158,233,333,483,683,983,1383/
      DATA      calclfg/numtab*.false./ ! true if table entry has been calculated 

c
      cos2THETA = COSD(TTHETA)
      cos2THETA2 = cos2THETA * cos2THETA
      ApB = 2.*SL
      if(ApB.LT.0.00001) ApB = 0.00001
      ApB2 = ApB*ApB
c
C handle the case where there is asymmetry
c
        Einfl = TTHETA
        tmp2 = 1.0 + ApB2
        tmp = SQRT(tmp2)*cos2THETA
c
        if (abs(tmp) .le. 1.0) then
          Emin = Acosd(tmp)      ! 2phi(min) FCJ eq 4 (degrees)
          tmp1 = tmp2*(1.0 - tmp2*cos2THETA2)
        else
          tmp1 = 0.0
          if (tmp .gt. 0.0) then
            Emin = 0.0
          else
            Emin = 180.0
          endif
        endif
        if (tmp1 .gt. 0 .and. abs(tmp) .le. 1.0) then
          dEmindA = -ApB*cos2THETA/SQRT(tmp1) ! N. B. symm w/r SL,HL
        ELSE
          dEmindA = 0.0
        ENDIF
c       
c Compute Gaussian Quadrature interval 
C Note that the number of points must be large enough so that the
c interval between 2phi(min) and 2theta must be divided into steps no
c larger than 0.005 degrees.  LWF  8/10/95
c       
c Determine which Gauss-Legendre Table to use
c       
        arraynum = 1
c       
c Calculate desired number of intervals
c
        K = INT(abs(TTHETA - emin)*800.)
c
C Find the next largest set
c
        do while (arraynum .lt. numtab .and. k.gt.nterms(arraynum))
          arraynum = arraynum + 1
        enddo
        ngt = nterms(arraynum)
c
C calculate the terms, if they have not been used before
c
        if (.not. calclfg(arraynum)) then
          calclfg(arraynum) = .true.
          call gauleg(-1.,1.,xpt,wpt,ngt)
          it = fstterm(arraynum)-ngt/2
c
C copy the terms from our working array to the stored array
c
          do k=ngt/2+1,ngt
            xp(k+it) = xpt(k)
            wp(k+it) = wpt(k)
          enddo
        endif
        sumWG2 = 0.
        sumWG = 0.
        sumWRG = 0.
        sumWdGdA = 0.
        sumWRdGdA = 0.
        sumWG1 = 0.
        sumWG2 = 0.
        sumWG3 = 0.
        sumWG5 = 0.
        sumWG6 = 0.
        if(IPRFD(NPH,5).OR.IPRFD(NPH,6)) RTL2 = 1./(TL*TL)
        sumWGdRdA = 0.
c      
c Compute Convolution integral for 2phi(min) <= delta <= 2theta
c       
        it = fstterm(arraynum)-ngt/2
        dttheta = DTT+TTHETA
        n = ngt/2+1 + it
        m = ngt + it
c
        do k = n, m
         delta = emin + (TTHETA - emin) * xp(k) ! Delta in degrees
         cosDELTA = cosd(Delta)
         if (abs(cosDELTA) .lt. 1.0e-15)cosDELTA = 1.0e-15
         RcosDELTA = 1. / cosDELTA
         tmp = cosDELTA*cosDELTA - cos2THETA2
         if (tmp .gt. 0) then
          tmp = SQRT(tmp)
          F = abs(cos2THETA)/tmp
          else
           F = 0.0
           dFdA = 0.0
         endif
c       
         ADT = dttheta-delta
         fw2 = TL - SIGN(1.,ADT)*ASYM
         ADT2 = ADT*ADT
         fw2 = ADT2/(fw2*fw2)
         R =  PROF(NPRF,NPH,fw2)
         G = (ApB*F - 1.)*RcosDELTA*wp(k)
         sumWG = sumWG + G
         sumWRG = sumWRG + R*G
         if(IPRFD(NPH,5).OR.IPRFD(NPH,6)) delt = ADT2*RTL2
         if(IPRFD(NPH,5)) sumWG5 = sumWG5 +
     *    G*(TF4(NPH)*delt/(1.+TF9(NPH)*delt)+TF8(NPH)-ALOG(1.+TF9(NPH)*delt))
         if(IPRFD(NPH,6)) sumWG6 = sumWG6 + 
     *    G*(.939437279*EXP(-2.772588722*delt)-.636619772/(1.+4.*delt))
         G = G*PRFDER
         if(IPRFD(NPH,1)) sumWG1 = sumWG1 + G*ADT
         if(IPRFD(NPH,2)) sumWG2 = sumWG2 + G*fw2
         if(IPRFD(NPH,3)) sumWG3 = sumWG3 - G*SIGN(1.,ADT)*fw2
         if(IPRFD(NPH,4)) then
          sinDELTA = sind(Delta)
          dDELTAdA = (1. - xp(k))*dEmindA
          tanDELTA = tand(Delta)
          if(F.gt.0) dFdA = cosDELTA*cos2THETA*sinDELTA*dDELTAdA/(tmp*tmp*tmp)
          dGdA = RcosDELTA*(F + tanDELTA*dDELTAdA*(ApB*F-1.) + ApB*dFdA)
          sumWdGdA = sumWdGdA + wp(k) * dGdA
          sumWRdGdA = sumWRdGdA + wp(k) * R * dGdA
          sumWGdRdA = sumWGdRdA + G*dDELTAdA 
         end if
        enddo
        FCJASYM = sumWRG/sumWG
        if(IPRFD(NPH,1)) PRFD(1) = sumWG1/sumWG
        if(IPRFD(NPH,2)) PRFD(2) = (sumWG2/sumWG-0.5)/TL
        if(IPRFD(NPH,3)) PRFD(3) = (2.*sumWG3/sumWG-1.)/TL
        if(IPRFD(NPH,4)) SLDER =
     *   2.*(sumwdgda/sumwg - 57.295779513*(sumwrdgda + sumwgdrda)/sumwrg)
        if(IPRFD(NPH,5)) PRFD(5) = sumWG5/sumWG
        if(IPRFD(NPH,6)) PRFD(6) = sumWG6/sumWG
c      
      RETURN
      END
      
C
      subroutine gauleg(x1,x2,x,w,n)
c Routine from Numerical Recipes (Press, Flannery, Teukolsky and Vetterling,
c    1986, Cambridge University Press, ISBN 0 521 30811 9)
c
c Given the lower and upper limits of integration (X1, X2) and the number
c  of intervals (N), this routine returns arrays X and W of length N,
c  containing the abscissas and weights of the Gauss-Legendre N-point
c  quadrature formula.
c
      implicit real*4 (a-h,o-z)
      REAL        X1,X2,X(N),W(N)     
      parameter (eps=3.e-7)
C
      m=(n+1)/2
      xm=0.5*(x2+x1)
      xl=0.5*(x2-x1)
      do i=1,m
        z=cos(3.141592654*(i-.25)/(n+.5))
        z1 = 0.0
        do while (abs(z-z1).gt.eps)
          p1=1.0
          p2=0.0
          do j=1,n
            p3=p2
            p2=p1
            p1=((2.0*j-1.0)*z*p2-(j-1.0)*p3)/j
          end do
          pp=n*(z*p1-p2)/(z*z-1.0)
          z1=z
          z=z1-p1/pp
        end do
        x(i)=xm-xl*z
        x(n+1-i)=xm+xl*z
        w(i)=2.0*xl/((1.0-z*z)*pp*pp)
        w(n+1-i)=w(i)
      end do
      return
      end
      
C
      FUNCTION PROF(N,IPH,X)
c      PARAMETER (idsz=70000,irs=4096,NATS=128,msz=200,NOV=512,mddm=100)
        INCLUDE 'DDM.inc'
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
C     PRFDER = -(D(PROFIL)/DX)/PROFIL
      GOTO(10,20,30,40,50,60,70,80),N
      STOP 'ILLEGAL PROFILE FUNCTION REQUEST'
10    PROF=.939437279*EXP(-2.772588722*X)
      PRFDER=2.772588722
      RETURN
20    PROF=.636619772/(1.+4.*X)
      PRFDER=4./(1.+4.*X)
      RETURN
30    PROF=.819449653/(1.+1.656854248*X)**2.
      PRFDER=3.313708496/(1.+1.656854248*X)
      RETURN
40    PROF=.766420937/(1.+2.349604208*X)**1.5
      PRFDER=3.5244063/(1.+2.349604208*X)
      RETURN
c50    Y=2.*2.772588722*X
c      Y1=SIGN(SQRT(Y),DELT)
c      PROF=EXP(-.5*Y)*(1.+GAM1/6.*Y1*(Y-3.)+GAM2/24.*
c     * (Y*(Y-6.)+3.)+(GAM1*GAM1/72.)*(Y*(Y*(Y-15.)+45.)-15.))
c      PRFDER=EXP(-.5*Y)*(.5+GAM1/12.*Y1*(Y-6.+3./Y)+GAM2/48.*
c     * (Y*(Y-8.)+9.)+GAM1*GAM1/144.*(Y*(Y*(Y-18.)+75.)-60.))/PROF
c      PRFDER=2.*2.772588722*PRFDER
50    RETURN
60    PROF=GAM1*.636619772/(1.+4.*X)+ 
     * (1-GAM1)*.939437279*EXP(-2.772588722*X)
      PRFDER=(GAM1*2.546479088/(1.+4.*X)**2+(1-GAM1)*2.6046732048*
     * EXP(-2.772588722*X))/PROF
      RETURN
70    PROF=C4(IPH)/(1.+4.*(2**(1./GAM1)-1)*X)**GAM1
      PRFDER=TF6(IPH)*GAM1/(1.+4.*(2**(1./GAM1)-1)*X)
      RETURN
80    PROF=GAM1*.636619772/(1.+4.*X)+ 
     * (1-GAM1)*.939437279*EXP(-2.772588722*X)
      PRFDER=(GAM1*2.546479088/(1.+4.*X)**2+(1-GAM1)*2.6046732048*
     * EXP(-2.772588722*X))/PROF
      RETURN
      END 
C
      SUBROUTINE  PRSVII(IPH)
       INCLUDE 'DDM.inc'
C     CALCULATES THE COEFFICIENT C4 AND ITS DERIVATIVE WRT T FOR PHASE K
C     THIS SUBROUTINE OBTAINED FROM IMMIRZI'S CODE
C     RGD = GAMMA(T)/GAMMA(T-0.5)
C     DGD = D(RGD)/D(T)
      LOGICAL  IPRFD
      COMMON/PRFX/T,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
      DIMENSION  RGD(52),DGD(52)
      DATA  RGD/   .156535,  .183771,  .209926,  .235089,  .259339,
     1   .282749,  .305380,  .327289,  .348527,  .369141,  .389170,
     2   .408654,  .427625,  .446115,  .464153,  .481764,  .498972,
     3   .515799,  .532265,  .548390,  .564190,  .579680,  .594877,
     4   .609794,  .624443,  .638837,  .652986,  .666902,  .680594,
     5   .694071,  .707342,  .720415,  .733297,  .754996,  .758519,
     6   .770871,  .783059,  .795089,  .806966,  .818696,  .830282,
     7   .841731,  .853045,  .864230,  .875290,  .886227,  .897046,
     8   .907750,  .918344,  .928828,  .939207,  .949484/
      DATA  DGD/  1.390576, 1.334036, 1.282282, 1.234747, 1.190975,
     1  1.150537, 1.113079, 1.078304, 1.045950, 1.015831,  .987556,
     2   .961144,  .936314,  .913013,  .891052,  .870228,  .850726,
     3   .832193,  .814684,  .798032,  .782274,  .767112,  .752807,
     4   .739098,  .726022,  .713542,  .701621,  .690110,  .679232,
     5   .668690,  .658669,  .648871,  .639521,  .630580,  .621825,
     6   .613555,  .605434,  .597760,  .590086,  .582896,  .575967,
     7   .569075,  .562482,  .555962,  .549890,  .543743,  .538044,
     8   .532381,  .526905,  .521578,  .516400,  .511296/
      DATA  PIG/3.1415926/, AL2/0.6931472/
      IF (T.LT.0.6) THEN
      write(iddmout,2)  nphase
      WRITE(0,2)  nphase
2     FORMAT (//,'Error: Unacceptable Peak Shape Parameters (NA,NB,NC)
     * for PHASE ',I4//)
      STOP
      END IF
      IT=IFIX(T-0.6)
      FT=T-FLOAT(IT)
      N1=(FT-0.6)/0.02+1.0001 
      DG=DGD(N1)+(DGD(N1+1)-DGD(N1))*(FT-0.58-0.02*FLOAT(N1))/0.02
      RG=RGD(N1)+(RGD(N1+1)-RGD(N1))*(FT-0.58-0.02*FLOAT(N1))/0.02
      IF(IT.GT.0) THEN
      DO 4 I=1,IT
      FL1=FT+FLOAT(I-1)
      DG=DG*(FL1)/(FL1-0.5)-0.5*RG/(FL1-0.5)**2
4     RG=RG*FL1/(FL1-0.5)
      ENDIF
      TF1(IPH)=SQRT(2.0**(1.0/T)-1.0)
      C4(IPH)=2.0*RG*TF1(IPH)/SQRT(PIG) 
      TF2(IPH)=AL2*2.0**(1.0/T)/(2.0*TF1(IPH)**2) 
C     DC4DT(IPH)= 2./SQRT(PIG)*(TF1(IPH)*DG - RG*TF2(IPH)/T**2)
      TF4(IPH)=4.0*AL2*2.0**(1.0/T)/T
      TF6(IPH)=4.0*T*TF1(IPH)**2
      TF8(IPH)=DG/RG-TF2(IPH)/T**2
      TF9(IPH)=4.0*TF1(IPH)**2
C     TF3=360.0*TF6/PIG
      RETURN
      END 
C
      SUBROUTINE outscr(I,R)
       INCLUDE 'DDM.inc'
c
C Outputs cycle No and R-factors to screen and ddm_sum.txt
c
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER M1*15, M2*8, M3*10
      DATA M1,M2,M3/' Cycle number: ',';  Rwp: ',';  R-DDM: '/
c
      if(iddm.EQ.0) then
       write(0,1) M1,I,M2,R
       write(iconout,1) M1,I,M2,R
      else
       write(0,1) M1,I,M3,R
       write(iconout,1) M1,I,M3,R
      end if
1     FORMAT(A,I2,A,F6.3)
      RETURN
      END 
C
      FUNCTION ESDVOL(IP)
        INCLUDE 'DDM.inc'
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      DIMENSION DCSM(6,6),DCV(6)
      
      CALL DIRECT(DCSM,DCV,IP)
      DO I = 4, 6
       DCV(I) = DCV(I)*0.01745329252 ! To radians
       DCSM(I,I) = DCSM(I,I)*0.01745329252
      END DO
        V0 = DCV(1) * DCV(2) * DCV(3)
        VOSQ = V0**2/(2*VOL(IP))
        ARG1 = VOSQ*(2 * COS(DCV(4)) * SIN(DCV(4)) -
     1   2*SIN(DCV(4)) *COS(DCV(5)) *COS(DCV(6))) *DCSM(4,4)
        ARG2 = VOSQ*(2 * COS(DCV(5)) * SIN(DCV(5)) -
     1   2*SIN(DCV(5)) *COS(DCV(4)) *COS(DCV(6))) *DCSM(5,5)
        ARG3 = VOSQ*(2 * COS(DCV(6)) * SIN(DCV(6)) -
     1   2*SIN(DCV(6)) *COS(DCV(4)) *COS(DCV(5))) *DCSM(6,6)
       c1 = 1.
       c2 = 1.
       if(LPAR(IP,6).EQ.LPAR(IP,7).AND.LPAR(IP,6).NE.LPAR(IP,8))  c1 = 2.
       if(LPAR(IP,6).EQ.LPAR(IP,7).AND.LPAR(IP,6).EQ.LPAR(IP,8)) then
        c1 = 3.
        c2 = 3.
       end if
       ESDVOL = SQRT(c1*((VOL(IP) * DCSM(1,1) / DCV(1))**2 
     1  + (VOL(IP) * DCSM(2,2) / DCV(2))**2 + ARG1**2 + ARG2**2) +
     1  c2*((VOL(IP) * DCSM(3,3) / DCV(3))**2  + ARG3**2))
      RETURN
      END
c
      SUBROUTINE OUTPTR(ICYCLE)
        INCLUDE 'DDM.inc'
c
      COMMON/G1/THMIN,STEP,THMAX,UU,VV,WW,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,
     * WDT,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/G3/COND,IORD1,IORD2,TH,NUM 
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/G2/S0,S1,S2,S2e,S3,S4,D0,D1,D2,D3,D4,R1,R2,R3,DC1,DS1,DS2,SYZ(MPH)
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      DIMENSION SY(npar),SZ(npar),DCSM(6,6),DCV(6)
      DIMENSION DVOL(MPH)
      CHARACTER*10 ID(5)
      DIMENSION rcell(6), apref(6), prefmat(4,3)
c
      ID(1)='SKEWNESS='
      ID(2)='  ETA   ='
      ID(3)='PEARSON-M='
C
      write(iddmout,1)ICYCLE
1     FORMAT(80(1H+)/14H CYCLE NUMBER=,I4,/80(1H+))
      if(iddm.EQ.0) then
       write(iddmout,57)R2,R3
57     FORMAT(/' R-P        = ',F8.2,/,' R-WP       = ',F8.2)
       X=100.*SQRT((FLOAT(NUM-MAXS))*D4/(D2*NPTS))
       write(iddmout,58)X
58     FORMAT(' R-EXPECTED = ',F8.2)
       write(iddmout,66) SQRT(S2*NPTS/(FLOAT(NUM-MAXS)*D4)), S4/S2
66     FORMAT (
     *' S          = ',F8.2,5X,'SQRT(RESIDUAL/N-P) GOODNESS OF FIT',/,
     *  ' D - W D    = ',F8.2,5X,'WEIGHTED DURBIN-WATSON STATISTIC D'/)
      else
c       RDDMe = 50.*SQRT(S2e/D2+S0/D0)
       RDDMe = 50.*SQRT(D3/D2+S0/D0)
       write(iddmout,577) R3, RDDMe, R3/RDDMe
c       CALL RCURV
      end if
577   FORMAT(/,
     * ' R-DDM    = ',F8.2,/,
     * ' R-DDMexp = ',F8.2,/,
     * ' S        = ',F8.2/)
      I=NUM-MAXS
c
      CALL outscr(ICYCLE,R3)
c
      DO 19 J=1,16
        KM=LGLB(J)
        IF(KM.NE.0)GOTO 20
        SY(J)=0.
        SZ(J)=0.
        GOTO 19
20      SZ(J)=SQRT(SMM(KM,KM))*ABS(AGLB(J))
        SY(J)=VX(KM)*AGLB(J)*RELAX(4)
        if(MCYCLE.GT.0) GLB(J)=GLB(J)+SY(J)
19      CONTINUE
      if(MCYCLE-ICYCLE.LE.LST1) then
       write(iddmout,109)GLB(1),SY(1),SZ(1)
109    FORMAT(' NEW PARAMETERS, SHIFTS, AND STANDARD UNCERTAINTIES'//,
     * ' GLOBAL PARAMETERS',/,' Zero-point:',3F8.4)
c       IF(NBCKGD.GT.1)GOTO 80
       write(iddmout,84)(GLB(J),SY(J),SZ(J),J=2,7)
84     FORMAT(' Background parameters',/,(1X,3G12.6))
       write(iddmout,181) (GLB(J),SY(J),SZ(J),J=10,14)
181    FORMAT (/' Sample displacement shift (DISP) ',3F10.4,/,
     *         ' Asymmetry related shift (SHASM)  ',3F10.4,/,
     *         ' Absorption parameter (ABSORP1)   ',3F10.4,/,
     *         ' Absorption parameter (ABSORP2)   ',3F10.4,/,
     *         ' Absorption parameter (ABSORP3)   ',3F10.4)
      end if
      DO 10 IP=1,NPHASE
       SYZ(IP) = 0.
       IOF=0
       IF(IP.GT.1) THEN
        DO 4340 IIPHAS=2,IP 
4340     IOF = IOF + NATOM(IIPHAS-1) 
       END IF
       if(MCYCLE-ICYCLE.LE.LST1) then
        write(iddmout,3)IP,PHSNM(IP)
3     FORMAT(/,'======================================================='
     *         ,/,7H PHASE ,I2,2H: ,A70,/,
     *         '=======================================================')
        write(iddmout,'(/,5H Atom,5X,1HX,6X,2HDX,5X,2HSX,6X,1HY
     *   ,6X, 2HDY,5X,2HSY,6X,1HZ,6X,2HDZ,5X,2HSZ,6X,1HB,6X,2HDB,5X,2HSB
     *   ,       6X,1HN,6X,2HDN,5X,2HSN)')
       end if
       N=NATOM(IP) 
       nsyz = 0
       DO  4 I=1,N 
        DO  5 J=1,5
         KM=LP(I+IOF,J)
         IF(KM.NE.0.AND.KM.NE.-ndpar(IP)) GOTO 6
         SY(J)=0.
         SZ(J)=0.
         GOTO  5 
6        SZ(J)=SQRT(SMM(KM,KM))*ABS(A(I+IOF,J))
         SY(J)=VX(KM)*A(I+IOF,J)*RELAX(1)
         if(SZ(J).GT.0.AND.(SY(J)/SZ(J).GT.SYZ(IP))) then
          SYZ(IP)=SY(J)/SZ(J)
          nsyz = KM
         end if
         if(MCYCLE.GT.0) XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
5        CONTINUE
4       if(MCYCLE-ICYCLE.LE.LST1)
     *   write(iddmout,100)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=1,5)
100     FORMAT(1X,A4,2X,5(3F7.4,1X))
       iprint = 1
       if(MCYCLE-ICYCLE.LE.LST1) iprint = 0
       DO  7 I=1,N
        if(IANIS(I+IOF).EQ.0) cycle
         if(iprint.eq.0) then
          write(iddmout,101)
101       FORMAT(5H Atom,7X,3HB11,6X,4HDB11,6X,4HSB11,7X,3HB22,6X,4HDB22,
     *    6X,4HSB22,7X,3HB33,6X,4HDB33,6X,4HSB33,/,12X,3HB12,6X,4HDB12,
     *    6X,  4HSB12,7X,3HB13,6X,4HDB13,6X,4HSB13,7X,3HB23,6X,4HDB23,6X,
     *    4HSB23)
          iprint = 1
        end if
        DO  8 J=6,11
         KM=LP(I+IOF,J)
         IF(KM.NE.0.AND.KM.NE.-ndpar(IP)) GOTO 9
         SY(J)=0.
         SZ(J)=0.
         GOTO  8 
9        SZ(J)=SQRT(SMM(KM,KM))*ABS(A(I+IOF,J))
         SY(J)=VX(KM)*A(I+IOF,J)*RELAX(2)
         if(SZ(J).GT.0.AND.(SY(J)/SZ(J).GT.SYZ(IP))) then
          SYZ(IP)=SY(J)/SZ(J)
          nsyz = KM
         end if
         if(MCYCLE.GT.0) XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
8       CONTINUE
7       if(MCYCLE-ICYCLE.LE.LST1)
     *   write(iddmout,102)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=6,11)
102    FORMAT(1X,A4,9F10.6,/,5X,9F10.6)
       lchng = 0 ! Lattice change index
       DO 17 J=1,npar
         KM=LPAR(IP,J)
         IF(KM.NE.0)GOTO 18
         SY(J)=0.
         SZ(J)=0.
         GOTO 17
18       SZ(J)=SQRT(SMM(KM,KM))*ABS(APAR(IP,J))
         SY(J)=VX(KM)*APAR(IP,J)*RELAX(3)
         if(SZ(J).GT.0.AND.(SY(J)/SZ(J).GT.SYZ(IP))) then
          SYZ(IP)=SY(J)/SZ(J)
          nsyz = KM
         end if
         if(MCYCLE.GT.0) PAR(IP,J)=PAR(IP,J)+SY(J)
         if(J.GE.6.AND.J.LE.11) lchng = 1 ! Lattice changed
17     CONTINUE
       if(lchng.EQ.1) then
        CALL DIRECT(DCSM,DCV,IP)
        do i = 1, 6
         SY(i+5)=DCV(i)-SAVL(IP,i)
         SAVL(IP,i)=DCV(i)
        end do
       else
        do i = 1, 6
         SY(i+5)=0.
         DCSM(i,i)=0.
        end do
       end if
c
       if(MCYCLE-ICYCLE.GT.LST1) CYCLE ! Skip further output 
c
       write(iddmout,103) PAR(IP,1),SY(1),SZ(1),
     *       (PAR(IP,I),SY(I),SZ(I),I=2,5),PAR(IP,20),SY(20),SZ(20),
     *          (SAVL(IP,I),SY(I+5),DCSM(I,I),I=1,6),(PAR(IP,I),SY(I),SZ(I)
     *  ,          I=12,14),PAR(IP,48),SY(48),SZ(48),PAR(IP,49),SY(49),SZ(49),
     *              (PAR(IP,I),SY(I),SZ(I),I=15,19) 
103    FORMAT(/,' Overall scale factor:',3G12.4,/,
     *       ' Overall B: ',3F11.4,/,
     *          ' FWHM terms (U, V, W, Z)',/,4(3E11.4E1,/), 
     *             ' Lattice constants',/,6(3F11.6,/),
     *                ' Preferred orientation parameters',/,2(3F11.5,1X/),
     *                  ' Asymmetry parameters',/,3(3F11.5,1X/),
     *                    ' Lorentzian FWHM terms (X and Y) ',/2(3E11.4E1/),
     *        ' Peak shape parameters (NA, NB, NC)',/,3(3F11.4,1X/)) 
       if(ians(IP,1).NE.0) 
     *  write(iddmout,'('' Pref-Orient. Anisotropy:'',/,6(1X,3E12.4,/))')
     *  (PAR(IP,I),SY(I),SZ(I), I=21,26)
       if(ians(IP,2).NE.0) 
     *  write(iddmout,'('' Crystal Size Anisotropy:'',/,6(1X,3E12.4,/))')
     *  (PAR(IP,I),SY(I),SZ(I), I=27,32)
       if(ians(IP,3).NE.0) 
     *  write(iddmout,'('' Microstrain  Anisotropy:'',/,6(1X,3E12.4,/))')
     *  (PAR(IP,I),SY(I),SZ(I), I=33,38)
       if(abs(ians(IP,3)).EQ.2) 
     *  write(iddmout,'(9(1X,3E12.4,/))') (PAR(IP,I),SY(I),SZ(I), I=39,47)
c
       write(iddmout,'(/'' Maximum Shift/ESU = '',F9.5,
     * '' for parameter No. '',I4/)') SYZ(IP), nsyz
       CALL ACCUR(IP)
       write(iddmout,*)
c
       if(PAR(IP,12).GT.0.AND.IPREF.EQ.1)
     *  write(iddmout,'('' March-Dollase PO degree =''F7.2,1H%/)') 
     *   100*SQRT((1-PAR(IP,12))**3/(1-PAR(IP,12)**3))
       prefsum = 1.0
       IF (ians(IP,1).EQ.1) THEN
        do i = 1, 6
         rcell(i) = PAR(IP,i+5)
         apref(i) = PAR(IP,20+i)
        end do
        CALL ELLIPS(prefmat,apref,rcell)
        prefsum = SQRT((prefmat(4,1)*0.001+1.)*(prefmat(4,2)*0.001+1.)*
     *                 (prefmat(4,3)*0.001+1.))
        write(iddmout,'(/,''***** Preferred Orientation Directions *****'')')
        write(iddmout,'(''          h       k       l     PRECOR'')')
        write(iddmout,'('' min:'',4F8.3)') (prefmat(3,i), i=1,3),
     *                               (1. + prefmat(4,3)*0.001)**(-1.5)
        write(iddmout,'('' mid:'',4F8.3)') (prefmat(2,i), i=1,3),
     *                               (1. + prefmat(4,2)*0.001)**(-1.5)
        write(iddmout,'('' max:'',4F8.3)') (prefmat(1,i), i=1,3),
     *                               (1. + prefmat(4,1)*0.001)**(-1.5)
        write(iddmout,'(/,'' Normalization coefficient: '',G10.4)') 1./prefsum
        write(iddmout,'(/''********************************************''/)')
       END IF
c
       TMAS(IP) = 0.
       do I=1,N 
        TMAS(IP) = TMAS(IP) + XL(I+IOF,5)*XMAS(IPTR(I+IOF))
       end do
       write(iddmout,2705) VOL(IP), ESDVOL(IP), 1.66113*TMAS(IP)/VOL(IP)
2705   FORMAT(' Cell Volume: ',F10.3,'(+-',F8.3,')',/
     * ' U.C.Density: 'F7.3,' g/cm^3',/)
C
c****** Size-Strain calculations **************
       if(NPROF.EQ.8) then
c
        bg =  PAR(IP,20) - UZXYS(2)
        bl =  PAR(IP,16) - UZXYS(4)
        DIv = 0.
        DIa = 0.
        DIs = 0.
        if((bg.GE.0).AND.(bl.GE.0).AND.(bg+bl.GT.0)) then
         DIv = 109.427*WLAMDA(1)/(2.*bl+SQRT(bl*bl+4.133*bg))
         write(iddmout,'('' Volume Weighted Domain Size Lv: '',F7.0,''A'')')
     *   DIv
         if(bl.GT.0) DIa = 18.237813*WLAMDA(1)/bl
         write(iddmout,'('' Area  Weighted Domain Size La: '',F7.0,''A'')')
     *   DIa
c         DIm = DIa+DIa*DIa*0.5/(DIa+DIv)
         DIm = DIa + sqrt(DIa*DIv)*0.25
         write(iddmout,'('' Average Crystal Diameter <D>: '',F7.0,''A'')')
     *   DIm
c         if(DIa.LE.DIv) DIs = DIm*sqrt(1.-DIa/DIv)
         DIs = DIm*(0.5*DIv/DIa-0.25)
         write(iddmout,'('' Size Dispersion Sigma<D>: '',F7.0,''A'',/)')
     *   DIs
        else
         write(iddmout,'('' Invalid Isotropic Crystal Size'',/)')
        end if
       end if
       bg =  PAR(IP,3) -  UZXYS(1)
       bl =  PAR(IP,15) - UZXYS(3)
       if((bg.GE.0).AND.(bl.GE.0).AND.(bg+bl.GT.0)) 
     *  write(iddmout,'('' Max. Strain <e>: '',E12.4,/)')
     *   0.00228463*(2.*bl+SQRT(bl*bl+4.133*bg))
c
10    CONTINUE ! End of NPHASE loop
      if(MCYCLE-ICYCLE.GT.LST1) RETURN ! Skip further output 
c
      CALL QPA(1)
c
      RETURN
99990 STOP 'ERROR WRITING IN OUTPTR'
      END 
C
******* QUANTITATIVE PHASE ANALYSIS ***************
c
      SUBROUTINE QPA(MODE)
        INCLUDE 'DDM.inc'
c
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
c      DATA (brind(i),i=1,41)
c     */0.285,0.300,0.317,0.334,0.353,0.373,0.395,0.419,0.444,0.472,0.502,
c     * 0.535,0.571,0.610,0.652,0.698,0.748,0.803,0.863,0.928,1.000,1.079,
c     * 1.165,1.259,1.363,1.477,1.602,1.741,1.893,2.061,2.246,2.450,2.676,
c     * 2.925,3.202,3.507,3.846,4.222,4.638,5.100,5.614/
C
c
      DIMENSION W(MPH), rcell(6), apref(6), prefmat(4,3)
      DIMENSION sscale(MPH), smas(MPH), pmas(MPH), dmas(MPH), amu(MPH)
c
      OMU = 1.
      iatm = 0
      DO IP=1,NPHASE
       PMU(IP) = 1.
       iatm = iatm + NATOM(IP)
       IOF=0
       IF(IP.GT.1) THEN
        do IIPHAS=2,IP 
         IOF = IOF + NATOM(IIPHAS-1)
        end do
       END IF
       smas(IP)=0.
       prefsum = 1.0
       sscale(IP) = 0.
       IF (ians(IP,1).EQ.1) THEN
        do i = 1, 6
         rcell(i) = PAR(IP,i+5)
         apref(i) = PAR(IP,20+i)
        end do
        CALL ELLIPS(prefmat,apref,rcell)
        prefsum = ((prefmat(4,1)*0.001+1.)*(prefmat(4,2)*0.001+1.)*
     *            (prefmat(4,3)*0.001+1.))**(-0.5)*(1.-PAR(IP,13))+PAR(IP,13)

        do i = 1, 6
         apref(i) = PAR(IP,20+i)
         KM=LPAR(IP,i+20)
	   if(KM.GT.0) apref(i) = apref(i)+SQRT(SMM(KM,KM))*ABS(APAR(IP,20+i))
        end do
        spref = 1.
        do i = 1, 3
         e1=prefmat(i,1)
         e2=prefmat(i,2)
         e3=prefmat(i,3)
         spref = spref*(0.001*(e1*e1*apref(1)+e2*e2*apref(2)+e3*e3*apref(3)+
     *          2.*e1*e2*apref(4)+2.*e1*e3*apref(5)+2.*e2*e3*apref(6))/
     *             (e1*e1*rcell(1)+e2*e2*rcell(2)+e3*e3*rcell(3)+
     *              e1*e2*rcell(6)+e1*e3*rcell(5)+e2*e3*rcell(4)) + 1.)
        end do
        sscale(IP) = prefsum-spref**(-0.5)*(1.-PAR(IP,13))-PAR(IP,13)
        KM=LPAR(IP,13)
	  if(KM.GT.0) then
         sp13 = (1 - prefsum)/(1.-PAR(IP,13))
         sscale(IP) = SQRT(sscale(IP)*sscale(IP) + sp13*sp13*ABS(SMM(KM,KM)))
     *               *PAR(IP,1)
	  else
	   sscale(IP) = ABS(sscale(IP)*PAR(IP,1))
	  end if  
       END IF
c      
c****  QPA constants *******************
       TMAS(IP) = 0.
       W(IP) = 0.
       amu(IP) = 0.
       if(NATOM(IP).EQ.0) cycle
       KM=LPAR(IP,1)
       if(KM.NE.0) sscale(IP) = SQRT(ABS(SMM(KM,KM)))*prefsum
       do I=1,NATOM(IP) 
        TMAS(IP) = TMAS(IP) + XL(I+IOF,5)*XMAS(IPTR(I+IOF))
       end do
       if(JOBTYP.NE.2) then
        do I=1,NATOM(IP) 
         amu(IP) = amu(IP) + XL(I+IOF,5)*XMAS(IPTR(I+IOF))*AMAC(IPTR(I+IOF))
        end do
        amu(IP) = amu(IP)/TMAS(IP) ! Mass absorption coefficient
       end if
C
C  Phase weight fraction
       W(IP)=PAR(IP,1)*TMAS(IP)*VOL(IP)*MLT(IP)*MLT(IP)*prefsum
       if(GLB(12).GT.0) W(IP) = W(IP)*(1+GLB(12)*exp(-GLB(13)))
c
      END DO
c
      if(iatm.EQ.0) RETURN
      if(JOBTYP.NE.2) then
       OMU = 0.
       om = 0.
       s = 0.
       do i = 1, NPHASE
        if(NATOM(i).EQ.0) cycle
        OMU = OMU + 0.602*VOL(i)*W(i)/TMAS(i)
        om = om + amu(i)*W(i)
        s = s + W(i)
       end do
       if(OMU.LE.0) OMU = 1
       if(om.LE.0)  om = 1
       if(s.LE.0)   s = 1
       OMU = om/OMU ! Overall linear absorption coef.
       om = om/s    ! Overall mass absorption coef. (MAC)
! Correct OMU if overall MAC is given 
! (to allow for MAC of amorphous phase)
       if(OMAC.GT.0) OMU = OMU*OMAC/om 
      end if
       WTOTAL = 0.
       do i = 1, NPHASE
c       bi=(1.66113*amu(i)*TMAS(i)/VOL(i)-OMU)*0.00005*PARS(i)
c       do j = 0, 39
c        bj = 0.05*(20-j)
c        if(bi.GE.bj) then
c         tbri = (bi-bj)/(0.5*(19-j)-bj)
c         tbri = brind(j+1)+(brind(j+2)-brind(j+1))*tbri
c         write(0,*) bi, tbri
c         exit
c        end if
c       end do
       WTOTAL = WTOTAL + W(i)
! Microabsorption correction
       if(NATOM(i).EQ.0.OR.JOBTYP.EQ.2) cycle
       PMU(i) = 1.66113*amu(i)*TMAS(i)/VOL(i)
c       tbri = (1.-OMU/PMU(i))*exp(-PARS(i)*0.0002*PMU(i)/3.)+OMU/PMU(i)
c       W(i) = W(i)/tbri
      end do
c
      if(MODE.EQ.0) RETURN
c
       write(iddmout,'(/,''*********** Phase Content ***********'')')
      do i = 1, NPHASE
       pmas(i) = 100. * W(i) / WTOTAL
       dmas(i) = 100.*sscale(i)*TMAS(i)*VOL(i)*MLT(i)*MLT(i)/WTOTAL
c     * + (DVOL(i)*PAR(i,1)*TMAS(i))**2 
c     * + (smas(i)*VOL(i)*PAR(i,1))**2
      end do
C 
      if(JOBTYP.NE.2) then
       om = OMAC
       if(OMAC.EQ.0) then
        do i = 1, NPHASE
         om = om + amu(i)*pmas(i)
        end do
        om = om/100. ! Overall mass absorption coef.
       end if
      end if
      j = 1
      if(IQPA.EQ.1) then
       if(SWT.GT.0) then ! Internal standard is used
	am = 100. - SWT
        s = am
        do i = 2, NPHASE
         pmas(i) = SWT*pmas(i)/pmas(1)
	 am = am - pmas(i)
        end do
! Calculate diffractometer constant if DIFC=0
        if(DIFC.LE.0.AND.TPS.GT.0) DIFC=100.*om*W(1)/(SWT*TPS)
        om = 0.
        do i = 2, NPHASE
 	 pmas(i) = pmas(i)*100./s
	 dmas(i) = dmas(i)*100./s
         om = om + amu(i)*pmas(i)
        end do
        am = am*100./s
        if(JOBTYP.NE.2) om = om/(100.-am)
        j = 2
       end if
       if(TPS.GT.0.AND.JOBTYP.NE.2) then ! Overall MAC based QPA
        if(SWT.LE.0) then
! Calculate diffractometer constant if DIFC=0
         if(DIFC.LE.0) DIFC=100.*om*W(1)/(pmas(1)*TPS)
         am = 100.
         do i = 1, NPHASE
          pmas(i) = 100.*om*W(i)/(DIFC*TPS)
          am = am - pmas(i)
          dmas(i) = dmas(i)*om*WTOTAL/(DIFC*TPS)
         end do
        else
! Overall MAC excluding internal standard
         om = SWT*(DIFC*TPS/W(1) - amu(1))/(100.-SWT)
         j = 2
        end if
       end if
      end if
      rmac = 0.
      do i = j, NPHASE
       if(am.GT.0) rmac = rmac + pmas(i)*amu(i)
       write(iddmout,'('' PHASE '',I2,2X,A)') i, PHSNM(i)
       if(JOBTYP.NE.2) write(iddmout,2711) pmas(i), dmas(i), amu(i), PMU(i)
       if(JOBTYP.EQ.2) write(iddmout,2711) pmas(i), dmas(i)
      end do
      if(IQPA.EQ.1) then
       if(am.GT.0) rmac = (om*100. - rmac)/am
       write(iddmout,'(A)') ' RESIDUE'
       if(JOBTYP.NE.2)  write(iddmout,'('' wt % = '',F8.2,''%'',
     * ''  MAC = '', 1PG12.6E1, ''cm^2/g'')') am, rmac
       if(JOBTYP.EQ.2)  write(iddmout,'('' wt % = '',F8.2,''%'')') am
      end if
c
2711   FORMAT(' wt % = ',F6.2,'%,  e.s.u. = ',F6.2,'%',
     *   '  MAC = ', 1PG10.6E1, 'cm^2/g', '  mu = ', 1PG10.6E1, '1/cm'/)
      write(iddmout,'(''*************************************'')')
      if(JOBTYP.NE.2) then
       write(iddmout,'('' Overall MAC = '',1PG10.6E1,''cm^2/g'',/)') om
       write(iddmout,'('' Overall mu = '',1PG10.6E1,''1/cm'',/)') OMU
      end if
c
      RETURN
      END 
C
       SUBROUTINE ELLIPS(prefmat,apref,rcell)
C****** Finds principal axes and values of an ellipsoid
       DIMENSION  apref(6), prefmat(4,3), rcell(6) !, sp(3), sd(3), cs(6) 
C
       i0 = 1
       i1 = 10./sqrt(rcell(1))
       i2 = 10./sqrt(rcell(2))
       i3 = 10./sqrt(rcell(3))
       do i = 0, i1
        do j = -i2, i2
         do k = -i3, i3
         if(i.EQ.0.AND.j.EQ.0.AND.k.EQ.0) cycle
         val = (i*i*apref(1)+j*j*apref(2)+k*k*apref(3)+
     *          2.*i*j*apref(4)+2.*i*k*apref(5)+2.*j*k*apref(6))/
     *             (i*i*rcell(1)+j*j*rcell(2)+k*k*rcell(3)+
     *              i*j*rcell(6)+i*k*rcell(5)+j*k*rcell(4))
         if(i0.EQ.1) then
          prefmat(4,1) = val
          prefmat(4,3) = val
          i0 = 0
         end if
         if(val.LE.prefmat(4,1)) then 
           prefmat(4,1) = val
           prefmat(1,1) = i
           prefmat(1,2) = j
           prefmat(1,3) = k
         end if
         if(val.GE.prefmat(4,3)) then 
           prefmat(4,3) = val
           prefmat(3,1) = i
           prefmat(3,2) = j
           prefmat(3,3) = k
         end if
         end do
        end do
       end do
       c1 = rcell(1)*prefmat(1,1) + 
     *      0.5*(rcell(6)*prefmat(1,2)+rcell(5)*prefmat(1,3))
       c2 = rcell(2)*prefmat(1,2) + 
     *      0.5*(rcell(6)*prefmat(1,1)+rcell(4)*prefmat(1,3))
       c3 = rcell(3)*prefmat(1,3) + 
     *      0.5*(rcell(5)*prefmat(1,1)+rcell(4)*prefmat(1,2))
       d1 = rcell(1)*prefmat(3,1) + 
     *      0.5*(rcell(6)*prefmat(3,2)+rcell(5)*prefmat(3,3))
       d2 = rcell(2)*prefmat(3,2) + 
     *      0.5*(rcell(6)*prefmat(3,1)+rcell(4)*prefmat(3,3))
       d3 = rcell(3)*prefmat(3,3) + 
     *      0.5*(rcell(5)*prefmat(3,1)+rcell(4)*prefmat(3,2))
       e1 = c3*d2 - c2*d3
       e2 = c1*d3 - c3*d1
       e3 = c1*d2 - c2*d1
       d = e1*e1 + e2*e2 + e3*e3
       if((abs(e1).GE.abs(e2)).AND.(abs(e1).GE.abs(e3))) then
        prefmat(2,1) = e1*e1/d
        prefmat(2,2) = prefmat(2,1)*e2/e1
        prefmat(2,3) = -prefmat(2,1)*e3/e1
       else if((abs(e2).GE.abs(e1)).AND.(abs(e2).GE.abs(e3))) then
        prefmat(2,2) = e2*e2/d
        prefmat(2,1) = prefmat(2,2)*e1/e2
        prefmat(2,3) = -prefmat(2,2)*e3/e2
       else if((abs(e3).GE.abs(e2)).AND.(abs(e3).GE.abs(e1))) then
        prefmat(2,3) = e3*e3/d
        prefmat(2,1) = -prefmat(2,3)*e1/e3
        prefmat(2,2) = -prefmat(2,3)*e2/e3
       end if
       do i = 1,3
        vm=AMAX1(abs(prefmat(i,1)),abs(prefmat(i,2)),abs(prefmat(i,3)))
        do j = 1,3
         if(vm.GT.0) prefmat(i,j)=prefmat(i,j)/vm
        end do
       end do
       e1=prefmat(2,1)
       e2=prefmat(2,2)
       e3=prefmat(2,3)
       prefmat(4,2) = (e1*e1*apref(1)+e2*e2*apref(2)+e3*e3*apref(3)+
     *          2.*e1*e2*apref(4)+2.*e1*e3*apref(5)+2.*e2*e3*apref(6))/
     *             (e1*e1*rcell(1)+e2*e2*rcell(2)+e3*e3*rcell(3)+
     *              e1*e2*rcell(6)+e1*e3*rcell(5)+e2*e3*rcell(4))
c       do i = 1,3
c       e1=prefmat(i,1)
c       e2=prefmat(i,2)
c       e3=prefmat(i,3)
c       sd(i) = e1*e1*rcell(1)+e2*e2*rcell(2)+e3*e3*rcell(3)+
c     *         e1*e2*rcell(6)+e1*e3*rcell(5)+e2*e3*rcell(4)
c       sp(i) = 1.+0.001*(e1*e1*apref(1)+e2*e2*apref(2)+e3*e3*apref(3)+
c     *          2.*e1*e2*apref(4)+2.*e1*e3*apref(5)+2.*e2*e3*apref(6))/sd(i)
c       end do
c       spref = 0.
c       do i = 1, 3
c        s = prefmat(1,i)*prefmat(1,i)*sp(2)*sp(3)/sd(1)
c     *    + prefmat(2,i)*prefmat(2,i)*sp(1)*sp(3)/sd(2)
c     *    + prefmat(3,i)*prefmat(3,i)*sp(1)*sp(2)/sd(3)
c        spref =  spref + s*s
c       end do
c       s = 2.*prefmat(1,1)*prefmat(1,2)*sp(2)*sp(3)/sd(1)
c     *   + 2.*prefmat(2,1)*prefmat(2,2)*sp(1)*sp(3)/sd(2)
c     *   + 2.*prefmat(3,1)*prefmat(3,2)*sp(1)*sp(2)/sd(3)
c        spref =  spref + s*s
c       s = 2.*prefmat(1,1)*prefmat(1,3)*sp(2)*sp(3)/sd(1)
c     *   + 2.*prefmat(2,1)*prefmat(2,3)*sp(1)*sp(3)/sd(2)
c     *   + 2.*prefmat(3,1)*prefmat(3,3)*sp(1)*sp(2)/sd(3)
c        spref =  spref + s*s
c       s = 2.*prefmat(1,2)*prefmat(1,3)*sp(2)*sp(3)/sd(1)
c     *   + 2.*prefmat(2,2)*prefmat(2,3)*sp(1)*sp(3)/sd(2)
c     *   + 2.*prefmat(3,2)*prefmat(3,3)*sp(1)*sp(2)/sd(3)
c        spref =  spref + s*s
c       end do
c       
      RETURN
      END
C
      FUNCTION NKREF(KREF, NATOMS)
c
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
C
10    KREF = KREF + 1
      do I=1,16
       if(LGLB(I).EQ.KREF) go to 10
      end do
      do I=1,NATOMS
       do J=1,11
        if(LP(I,J).EQ.KREF) go to 10
       end do
      end do
      do K=1,NPHASE
        do I=1,npar
         if(LPAR(K,I).EQ.KREF) go to 10
        end do
      end do
C
      NKREF = KREF
      RETURN
      END
C
      SUBROUTINE READFF
        INCLUDE 'DDM.inc'
c
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 ihkl
      integer*1 ihkl4(4)
      equivalence (ihkl,ihkl4)
c
      open(iauxfil, file='ddm_ffobs')
      do 2 I = 1, ICZ
       if(IND4(IREFS(I),4).LT.0) goto 2
       read(iauxfil,*,END=1,ERR=1) FF(I)
       if(WLAMDA(2).GT.WLAMDA(1)) then
        ihkl = IREFS(I)
        ihkl4(4) = -IND4(IREFS(I),4)
        do 3 J = I+1, ICZ           ! Find Kalpha2 equivalent
         if(ihkl.NE.IREFS(J)) goto 3
         FF(J) = FF(I)*RATIO(2)
         goto 2
 3      continue         
       end if
       goto 2
 1     FF(I) = 0.01
 2    continue
      close(iauxfil)
      RETURN
      END
c
      SUBROUTINE READFW
        INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
        character fwhfix(irs)*1
        common/fwcntr/ fwhfix

c
      open(iauxfil,FILE='ddm_fwobs',STATUS='OLD',FORM='FORMATTED',ERR=1000)
c     
 10    read(iauxfil,*,ERR=300) IH, IK, IL, FWHM, IPH
       if(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) goto 300
       do J=1,ICZ
        if(IND4(IREFS(J),1).EQ.IH.AND.
     *     IND4(IREFS(J),2).EQ.IK.AND.
     *     IND4(IREFS(J),3).EQ.IL.AND.
     *     IABS(IND4(IREFS(J),4)).EQ.IPH) then
         if(NPROF.NE.8) then
          REFS(J,1) = FWHM
         else
          HALFL(J) = FWHM
          REFS(J,1) = (HALFG(J)**5.+2.69269*HALFG(J)**4.*HALFL(J)+
     *         2.42843*HALFG(J)**3.*HALFL(J)**2.+
     *              4.47163*HALFG(J)**2.*HALFL(J)**3. +
     *                   0.07842*HALFG(J)*HALFL(J)**4. + HALFL(J)**5.
     *     )**0.2
          if(REFS(J,2).LE.RLIM) REFS(J,1)=REFS(J,1)+
     *     PAR(IPH,14)*EXP(-.084*REFS(J,2))
          TLR = HALFL(J)/REFS(J,1)
          GAM(J) = 1.36603*TLR-0.47719*TLR*TLR+0.11116*TLR**3.
         end if
         fwhfix(j) = 'y'
        end if
       end do
      goto 10
 300  close(iauxfil)
1000  RETURN
      END
c
      SUBROUTINE EXPUT
        INCLUDE 'DDM.inc'
c
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
        character fwhfix(irs)*1
        common/fwcntr/ fwhfix
      DIMENSION FFOLD(IRS), bkt(IDSZ)
      DIMENSION HNN(3),ANS(15),AL(3,3),ngeom(NPHASE)
      LOGICAL VERT
c
      NoBCKG = 0
      ZER=GLB(1)
      RAD = 45./ATAN(1.)
      DO I=1,NPTS
        YC(I)=YC(I)+BK(I)
        bkt(I) = BK(I)
      END DO
c
c      if(iddm.GT.0) then 
c       if(IWP.EQ.3) then
c        open(iauxfil,FILE='ddm_int.xdg')
c        write(iauxfil,8477) RATIO(2), WLAMDA
c        write(iauxfil,8478) THMIN, THMAX, STEP, 0., NPTS
c        write(iauxfil,8479) (iconv(I), I=1,NPTS)
c        close(iauxfil)
c       end if
c      if((IWP.EQ.3).AND.(IPL.EQ.0)) then
c       open(iauxfil,FILE='refs.xdg')
c       write(iauxfil,8477) RATIO(2), WLAMDA
c       write(iauxfil,8478) THMIN, THMAX, STEP, 0., NPTS
c       write(iauxfil,8479) (NINT(BK(I)), I=1,NPTS)
c      end if
c
      do i = 1, NPHASE
       ngeom(i) = 0
       CALL GEOM(i,0,ngeom(i),0,0)
      end do
c
      if(IPL.GE.1) then
       open(iauxfil,FILE='ddm_ref.txt')
       write(iauxfil,*)
     * '2Theta        Iobs      Icalc         h    k    l   NPhase'
      end if                                                 
C
      IPL21 = ndec
      IPLCYC = IPL21  ! Number of cycles for Fobs estimation
c      
      open(iddmcif,FILE='ddm_cif.cif')
c      
      if(NEXCRG.GT.0) call CALCY(-1, YC)
      if(TMV.LE.0) GO TO 401
c
1400  DO 400 K=1,NPHASE
        T2OBS=0.
        TDOBS=0.
        RFNMR=0.
        RFDNR=0.
        IXX=0
c
       do i=1,ICZ
        if(FF(i).LT.1.) FF(i) = 1.
        FFOLD(i) = FF(i)
       end do
c
       if(IPLCYC.LE.1) then 
        CALL CIF(K)
        if(ngeom(K).GT.0) CALL GEOM(K,iddmcif,ngeom(K),ngeom(K),0)
         if(ifur(K).EQ.1)
     *    write(iddmcif,'(/''loop_'',/'' _refln_index_h'',
     *    /'' _refln_index_k'',/'' _refln_index_l'',
     *    /'' _refln_F_meas'',/'' _refln_F_calc'',
     *    /'' _refln_phase_calc'')')
         if(ifur(K).EQ.2)
     *    write(iddmcif,'(/''loop_'',/'' _refln_index_h'',
     *    /'' _refln_index_k'',/'' _refln_index_l'',
     *    /'' _refln_F_squared_meas'',/'' _refln_F_squared_sigma'')')
        write(iddmout,'(/,''PHASE '',I3,5X,A70/)') K,PHSNM(K)
       end if
c      if((IWP.EQ.3).AND.(IPL.EQ.0)) then
c         write(iauxfil,'(/,''0 0 0 0 0'')')
c        write(iauxfil,'(8(F8.5,2X))') PAR(K,3),PAR(K,4),PAR(K,5),WDT,
c     *  PAR(K,17),PAR(K,18),PAR(K,14),RLIM
c         write(iauxfil,'(8(F8.5,2X))') 0., 0., 0.015, 10., 1.5, 0., 0., 0.
c        write(iauxfil,8730) ICZ
c        end if
c
        DO 481 IX=1,ICZ
          IF(K.NE.IABS(IND4(IREFS(IX),4)))GOTO 481
c
c   Peak shift due to sample displacement and asymmetry
          SHIFT = PSHIFT(GLB(10),GLB(11),REFS(IX,2))
          IXX=IXX+1 
          DO J=1,NEXCRG
           IF((REFS(IX,2)+SHIFT+ZER).GE.(ALOW(J)-WDT*REFS(IX,1)).AND.
     *        (REFS(IX,2)+SHIFT+ZER).LE.(AHIGH(J)+WDT*REFS(IX,1))) GOTO 481
          END DO 
          IRH=IND4(IREFS(IX),1)
          IRK=IND4(IREFS(IX),2)
          IRL=IND4(IREFS(IX),3)
          IRC = 1
          if(IND4(IREFS(IX),4).LT.0) IRC = 2
C
          if(IRC.NE.1) goto 481 ! Avoid Alpha2 printing
C
          RMIN=REFS(IX,2)+ZER+SHIFT-TMV*REFS(IX,1)
          RMAX=REFS(IX,2)+ZER+SHIFT+TMV*REFS(IX,1)
          MIN=(RMIN-THMIN)/STEP+1.5
          MAX=(RMAX-THMIN)/STEP+1.5
          MIN=MAX0(MIN,1)
          MIN=MIN0(MIN,NPTS)
          MAX=MIN0(MAX,NPTS)
C     PATCH TO CALCULATE R-BRAGG
          VERT=REFS(IX,2).LE.RLIM
        TL=REFS(IX,1)
        IF (NPROF.EQ.6) GAM1 = PAR(K,17) + PAR(K,18) * REFS(IX,2)
        IF (NPROF.EQ.7) GAM1 = PAR(K,17) + PAR(K,18) / REFS(IX,2)
     !                           + PAR(K,19)/REFS(IX,2)/REFS(IX,2)
      IF (NPROF.EQ.7) CALL PRSVII(K)
       do I=1,3
        AL(I,I)=PAR(K,I+5)
       end do
       AL(2,3)=PAR(K,9)
       AL(1,3)=PAR(K,10)
       AL(1,2)=PAR(K,11)
       HNN(1)=IRH
       HNN(2)=IRK
       HNN(3)=IRL
       SS=0.
       do  I=1,3
        do  J=I,3
          SS=AL(I,J)*HNN(I)*HNN(J)+SS
        end do
       end do
          ANISO1 = 0.
          ANISO2 = 0.
        if(ians(K,2).EQ.1) then  ! Anisotropic Size
         ANISO1 = 1.
         do i =1,3
          ANS(i) = .001*HNN(i)*HNN(i)/SS
         end do
         ANS(4) = ANISO1*.002*HNN(1)*HNN(2)/SS
         ANS(5) = ANISO1*.002*HNN(1)*HNN(3)/SS
         ANS(6) = ANISO1*.002*HNN(2)*HNN(3)/SS
         ANISO1 = 0.
         do i =1,6
         ANISO1 = ANISO1 + ANS(i)*PAR(K,26+i)
         end do
        end if
        if(abs(ians(K,3)).EQ.1) then ! Anisotropic Strain
         do i =1,3
          ANS(i) = .001*HNN(i)*HNN(i)/SS
         end do
         ANS(4) = .002*HNN(1)*HNN(2)/SS
         ANS(5) = .002*HNN(1)*HNN(3)/SS
         ANS(6) = .002*HNN(2)*HNN(3)/SS
         do i =1,6
         ANISO2 = ANISO2 + ANS(i)*PAR(K,32+i)
         end do
        end if
        if(abs(ians(K,3)).EQ.2) then ! Aniso-Strain (Stephens model)
         SS2 = SS*SS*10000.
         do i =1,3
          ANS(i) = HNN(i)**4/SS2
         end do
        ANS(4) = 3.*(HNN(1)*HNN(2))**2/SS2
        ANS(5) = 3.*(HNN(1)*HNN(3))**2/SS2
        ANS(6) = 3.*(HNN(2)*HNN(3))**2/SS2
        ANS(7) = 2.*HNN(2)*HNN(1)**3/SS2
        ANS(8) = 2.*HNN(1)*HNN(3)**3/SS2
        ANS(9) = 2.*HNN(3)*HNN(2)**3/SS2
        ANS(10) = 2.*HNN(1)*HNN(2)**3/SS2
        ANS(11) = 2.*HNN(3)*HNN(1)**3/SS2
        ANS(12) = 2.*HNN(2)*HNN(3)**3/SS2
        ANS(13) = 4.*HNN(2)*HNN(3)*HNN(1)**2/SS2
        ANS(14) = 4.*HNN(1)*HNN(3)*HNN(2)**2/SS2
        ANS(15) = 4.*HNN(2)*HNN(1)*HNN(3)**2/SS2
         do i =1,15
         ANISO2 = ANISO2 + ANS(i)*PAR(K,32+i)
         end do
        end if
C
      IF(NPROF.EQ.8) THEN 
       if(ians(K,2).GT.0) then
        if(ANISO1.GE.0.) ANISO1 = sqrt(ANISO1)
        if(ANISO1.LT.0.) ANISO1 = -sqrt(-ANISO1)
       end if
       if(ians(K,3).GT.0) then
        if(ANISO2.GE.0.) ANISO2 = sqrt(ANISO2)
        if(ANISO2.LT.0.) ANISO2 = -sqrt(-ANISO2)
       end if
       GAM1 = GAM(IX)
       bg =  PAR(K,20) - UZXYS(2)
       bl =  PAR(K,16) - UZXYS(4) + ANISO1
       DIv = 0.
       DIa = 0.
       DIs = 0.
       TLG = -1.
       if((bg.GE.0).AND.(bl.GE.0).AND.(bg+bl.GT.0)) then
        DIv = 109.427*WLAMDA(1)/(2.*bl+SQRT(bl*bl+4.133*bg))
        if(bl.GT.0) DIa = 18.237813*WLAMDA(1)/bl
c        TLG = DIa+DIa*DIa*0.5/(DIa+DIv)
         TLG = DIa + sqrt(DIa*DIv)*0.25
       end if
       bg =  PAR(K,3) -  UZXYS(1)
       bl =  PAR(K,15) - UZXYS(3)
       if(ians(K,3).GT.0) bl =  bl + ANISO2
       if(ians(K,3).LT.0) bg =  bg + ANISO2
       TLL = -1.
       if((bg.GE.0).AND.(bl.GE.0).AND.(bg+bl.GT.0)) 
     *   TLL = 0.00228463*(2.*bl+SQRT(bl*bl+4.133*bg))
      END IF
          BB=TL*TL
          TIOBS =0. 
          TICAL =0. 
          TIC=0.
          TTIC=0.
          TFOBS=0.
          TFCAL=0.
          ovrlp = 1.
          FFIX=FF(IX)*REFS(IX,3)*PAR(K,1) !*
c
          DO 410 IS=MIN,MAX
           TH=THMIN+FLOAT(IS-1)*STEP
           IF(NEXCRG.GT.0) THEN
            DO IEXC=1,NEXCRG
             IF (TH.GE.ALOW(IEXC).AND.TH.LE.AHIGH(IEXC)) GO TO 410 
            END DO
           END IF
           DELTA=TH-REFS(IX,2)-ZER-SHIFT
           DELT=DELTA*DELTA
C     NEXT LINE IS NECESSEARY FOR 2 PHASES WITH VERY DIFFERENT FWHM.
           IF (DELT/BB.GT.WDT*WDT) GO TO 410
c
c       Asymmetry correction !!
           ASYM = PAR(K,14)*EXP(-REFS(IX,2)*.084)
c  Apply ASYM2
           if(PAR(K,48).NE.0) ASYM = ASYM + PAR(K,48)*REFS(IX,4)*
     *     TAN(REFS(IX,2)*0.00872664625997)
           OMEGA= PROFIL(NPROF,K,TL,REFS(IX,2),DELTA,ASYM)
           TIC  = TIC + OMEGA
c
           if(iddm.EQ.0) then ! least squares
            TIOBS=TIOBS+OMEGA*(Y(IS)-BK(IS))/AMAX1(YC(IS)-BK(IS),1.)
            if((IFWE.EQ.1).AND.(2.*DELTA.LE.TMV*TL)) then
            TFOBS=TFOBS+OMEGA*(Y(IS)-BK(IS))/AMAX1(YC(IS)-BK(IS),1.)
            TFCAL = TFCAL + OMEGA
            end if
           else ! DDM
            if(DELTA.LT.STEP) ovrlp = OMEGA/AMAX1(YC(IS)-BK(IS),1.)
            if((IS.LT.3).OR.(IS.GT.NPTS-2)) go to 410
            ia = iconv(IS)
            cn0 = ia*2+1
            cn1 = ia*(ia+1)*cn0
            cn2 = (4*ia*(ia+1)-3)*cn0
            c01 = -15./cn2  ! equals to c20         
            c10 = 3./cn1    
            c21 = 45./(cn2*ia*(ia+1))
            D1 = 0.0
            D2 = 0.0
            O1 = 0.0
            O2 = 0.0
            do l = -ia, ia
             c1 = l*c10
             c2 = c01+c21*l*l
             D1=D1+(Y(IS+l)-YC(IS+l))*c1
             D2=D2+(Y(IS+l)-YC(IS+l))*c2
             DD=DELTA+float(l)*Step
             DD=PROFIL(NPROF,K,TL,REFS(IX,2),DD,ASYM)
             O1=O1+DD*c1
             O2=O2+DD*c2
            end do
            TIOBS=TIOBS+D1*O1/VAR1(IS)+D2*O2/VAR2(IS)
            TICAL=TICAL+O1*O1/VAR1(IS)+O2*O2/VAR2(IS)
           end if
410       CONTINUE ! End of MIN,MAX loop
c
          if(iddm.EQ.0) then ! least squares
           FF(IX) = FF(IX)*TIOBS/TIC
          else
           FF(IX)=FF(IX)*(1 + TIOBS*ovrlp/TICAL)
           TFOBS=TIOBS
           TFCAL=TICAL
          end if
          if(FF(IX).LE.0.) FF(IX) = 0.
          if(IPLCYC.GT.1) then
           do J = IX+1, ICZ ! Find Kalpha2 equivalent
            if(IND4(IREFS(J),1).NE.IRH.OR.
     *         IND4(IREFS(J),2).NE.IRK.OR.
     *         IND4(IREFS(J),3).NE.IRL.OR.
     *         IABS(IND4(IREFS(J),4)).NE.K) cycle
            FF(J) = FF(IX)*RATIO(2)
            goto 481
           end do
           goto 481
          end if
c
          if(ifur(K).GE.1) CALL FURPUT(IX,K,IRH,IRK,IRL)
c
          if((IFWE.EQ.1).AND.(fwhfix(IX).EQ.'y')) then
          BB=(TIOBS/TIC)/(TFOBS/TFCAL)
           if(NPROF.NE.8) then
            BB = REFS(IX,1)*BB
           else
            BB = HALFL(IX)*BB
           end if
           if(BB.LT.fwhmlim(K,1)) BB=fwhmlim(K,1)
           if(BB.GT.fwhmlim(K,2)) BB=fwhmlim(K,2)
           if(NPROF.NE.8) then
            REFS(IX,1)=BB
           else
            HALFL(IX)=BB
           end if
          end if
c
          if(iddm.EQ.0) then ! least squares
           TIOBS = TIOBS*FFIX/TL
C
         else
          TIOBS = TIC*FF(IX)*REFS(IX,3)*PAR(K,1)/TL
         end if
         TIC = TIC*FFIX/TL 
c
c         IF (IPC.EQ.2) THEN
          TFCAL = SQRT(ABS(TIC/REFS(IX,3)/PAR(K,1)))
          TFOBS = SQRT(ABS(TIOBS/REFS(IX,3)/PAR(K,1)))
          RFNMR = RFNMR + ABS(TFOBS-TFCAL)
          RFDNR = RFDNR + ABS(TFOBS)
c         END IF
c
         T2OBS = T2OBS+TIOBS 
         TDOBS = TDOBS + ABS(TIOBS-TIC)
C
         IF(IXX.EQ.1.AND.IPC.GT.0) THEN
          if(IPC.EQ.1) write(iddmout,'(A\)')
     * ' No.     h   k   l   FWHM   2Theta     Icalc        Iobs'
          if(IPC.EQ.2) write(iddmout,'(A\)')
     * ' No.     h   k   l   FWHM   2Theta     Fcalc        Fobs'
          if(NPROF.NE.8) write(iddmout,*) '  Aniso-Size  Aniso-Str'
          if(NPROF.EQ.8) write(iddmout,*) '    <D>hkl     <e>hkl'
         END IF
         if(IPC.GT.0)
     *    write(iddmout,470) IXX,IRH,IRK,IRL,REFS(IX,1),REFS(IX,2)
c
         if(IPL.GE.1) then
          robs = FF(IX)*REFS(IX,3)*PAR(K,1)*
     *     PROFIL(NPROF,K,TL,REFS(IX,2),0.,0.)/TL
          rclc = FFIX*PROFIL(NPROF,K,TL,REFS(IX,2),0.,0.)/TL
          if(IPL.EQ.2) then
           if(IXX.EQ.1.AND.IBFILE.EQ.0.AND.NBCKGD.EQ.0.AND.
     *     (GLB(2)+GLB(3)+GLB(4)+GLB(5)+GLB(6)+GLB(7)).EQ.0) then
            CALL CALCBK(bkt)
            NoBCKG = 1
           end if
           ip = NINT((REFS(IX,2)+ZER+SHIFT - THMIN)/STEP)
           if(bkt(ip).LT.0) bkt(ip) = 0.
           if(NoBCKG.EQ.1) then
            if(YC(ip).GT.0) then
             corr = (sqrt(YC(ip)+bkt(ip)) - sqrt(bkt(ip)))/YC(ip)
            else
             corr = 0.
            end if
           else
            if(YC(ip).GT.bkt(ip)) then
             corr = (sqrt(YC(ip)) - sqrt(bkt(ip)))/(YC(ip)-bkt(ip))
            else
             corr = 0.
            end if
           end if
           robs = robs*corr
           rclc = rclc*corr
          end if
          write(iauxfil,'(F10.5,2G13.5,3I5,I4)')
     *     REFS(IX,2)+ZER+SHIFT, robs, rclc, IRH, IRK, IRL, K
         end if
c
470      FORMAT(1X,I4,1X,3I4,2F8.3\) 
471      FORMAT(2(1X,F11.1),2E11.4E1) 
472      FORMAT(2(1X,F11.1)\) 
         if(NPROF.NE.8) then
          if(IPC.EQ.1) write(iddmout,471) TIC,TIOBS,ANISO1,ANISO2
          if(IPC.EQ.2) write(iddmout,471) TFCAL,TFOBS,ANISO1,ANISO2
         else
          if(IPC.EQ.1) write(iddmout,472) TIC,TIOBS
          if(IPC.EQ.2) write(iddmout,472) TFCAL,TFOBS
          if(TLG.GT.0.) then
           write(iddmout,'(F10.2\)') TLG
          else
           write(iddmout,'(10H   Invalid\)')
          end if
          if(TLL.GT.0.) then
           write(iddmout,'(E12.4)') TLL
          else
           write(iddmout,'(10H   Invalid)')
          end if
         end if
c
481     CONTINUE ! End of ICZ loop
c
        if(IPLCYC.GT.1) goto 400
        write(iddmout,'('' Derived Bragg R-factor: '',F6.2)') 100.*TDOBS/T2OBS
c        if(IPC.EQ.2) then
         write(iddmout,'('' Derived R-F: '',F6.2)') 100.*RFNMR/RFDNR
c        end if
        if(ifur(K).GE.1) then
         CALL FURPUT(1,K,0,0,0)
         ndec = IPL21
        end if
        CALL CIFEXP(K,TDOBS/T2OBS,RFNMR/RFDNR)
c
400   CONTINUE ! End of NPHASE loop
c
      if(IPLCYC.GT.1) then
       call CALCY(0, YC)
c
       if(NBCKGD.EQ.-1) then
        DO I=1,NPTS
         YC(I)=YC(I)-BK(I)
        END DO
        CALL CALCBK(BK)
        DO I=1,NPTS
         YC(I)=YC(I)+BK(I)
        END DO
       else
       end if
c
       IPLCYC = IPLCYC - 1
c
       goto 1400 ! Next decomposition cycle
c
      end if
c
401   if(IPLCYC.GT.0) call CALCY(-1, YC)
c
      if(IWP.GT.2) then
       irtv = iddmcif
       if(IWP.EQ.3) then
        open(iauxfil,FILE='ddm_cif.rtv')
        irtv = iauxfil
       end if
       write(irtv, '(''data_profile ''//
     * 			''_pd_block_id profile''/
     * 			''_pd_meas_2theta_range_min '',F15.8,/
     * 			''_pd_meas_2theta_range_max '',F15.8,/
     * 			''_pd_meas_2theta_range_inc '',F15.8,//
     * 			''loop_''/
     * 			'' _pd_meas_intensity_total''/
     * 			'' _pd_calc_intensity_total''/
     * 			'' _pd_proc_ls_weight'' )') THMIN,THMAX,STEP
       do i = 1, NPTS
        write(irtv,'(3G14.8E1)') Y(i), YC(i), 1/VAR(i)
       end do
       if(IWP.EQ.3) close(irtv)
      end if
c
      close(iddmcif)
      if(IPL.GE.1.AND.IPC.GE.1) CLOSE(iauxfil)
c
      if(ndec.GE.0) then
       open(iauxfil,FILE='ddm_ffobs')
       do IX=1,ICZ
        if(IND4(IREFS(IX),4).GT.0) write(iauxfil,*) FF(IX)
       end do
       close(iauxfil)
      end if
c
      if(IFWE.EQ.1) then
       open(iauxfil,FILE='ddm_fwobs')
       do IX=1,ICZ
        if(NPROF.NE.8) then
         BB = REFS(IX,1)
        else
         BB = HALFL(IX)
        end if
        if(IND4(IREFS(IX),4).GT.0.AND.(fwhfix(IX).EQ.'y'))
     *  write(iauxfil,*) IND4(IREFS(IX),1),IND4(IREFS(IX),2),
     *                  IND4(IREFS(IX),3),BB,IABS(IND4(IREFS(IX),4))
       end do
       close(iauxfil)
      end if
c
c      if(IWP.EQ.3) then
c       open(iauxfil,FILE='calc.xdg')
c       write(iauxfil,8477) RATIO(2), WLAMDA
c       write(iauxfil,8478) THMIN, THMAX, STEP, 0., NPTS
c       write(iauxfil,8479) (NINT(YC(I)), I=1,NPTS)
c       CLOSE(iauxfil)
c      end if
      NoBCKG = 0
      if(IBFILE.EQ.0.AND.NBCKGD.EQ.0.AND.
     *  (GLB(2)+GLB(3)+GLB(4)+GLB(5)+GLB(6)+GLB(7)).EQ.0) then
C  Estimate background
      NoBCKG = 1
      CALL CALCBK(BK)
      end if
      if(IPL.GE.1) then
       open(iauxfil,FILE='ddm_prf.txt')
        write(iauxfil,'(A\)')          
     *  ' 2Theta     Yobs         Ycalc        Ydiff         Backgr'
       if(iddm.NE.0) then
        write(iauxfil,*) '   Conv.W'
       else
        write(iauxfil,*)          
       end if
        S0 = 0.
        S1 = 0.
        S2 = 0.
        do i = 1, NPTS
         yi = Y(i)
         yci = YC(i)
         bki = BK(i)
         if(bki.LT.0) bki = 0.
         if(IPL.EQ.2) then
          if(NoBCKG.EQ.1) then
           yci = sqrt(yci+bki) - sqrt(bki)
          else
           yci = sqrt(yci)
          end if
          yi = sqrt(yi)
          bki = sqrt(bki)
         end if
         if((IPL.EQ.3).AND.(iddm.GT.0)) then
          if((i.LT.3).or.(i.GT.NPTS-2)) go to 15
          ia = iconv(I)
          cn0 = ia*2+1
          cn1 = ia*(ia+1)*cn0
          c10 = 3./cn1    
          Y0  = 0.0
          Y1  = 0.0
          Y2  = 0.0
          do l = -ia, ia
           c1 = l*c10
           Y0=Y0+Y(i+l)*c1
           Y1=Y1+YC(i+l)*c1
           Y2=Y2+BK(i+l)*c1
          end do
          wi = SQRT(VAR1(i))
          S0 = S0 + Y0/wi
          S1 = S1 + Y1/wi
          S2 = S2 + Y2/wi
15        yi = S0
          yci = S1
          bki = S2
         end if
        write(iauxfil,'(F10.5,4G13.5\)')
     *   THMIN+float(i-1)*STEP,yi,yci,yi-yci,bki
        if(iddm.NE.0) then
         write(iauxfil,'(F10.5)') float(iconv(i)*2+1)*STEP
        else
         write(iauxfil,*)          
        end if
       end do
       CLOSE(iauxfil)
       end if
8477   FORMAT (3F8.5)
8478   FORMAT (4F10.5,I6)
8479   FORMAT (10I7)
      if(IWP.EQ.1.OR.IWP.EQ.2) then
       open(iauxfil,FILE='ddm_prf.prf')
       write(iauxfil,'(1X,A)') TITLE
       write(iauxfil,'(I4,2F9.4)') 3111, 1.0, ZER
       write(iauxfil,'(2F8.3,F8.6,2I8)') THMAX,THMIN,STEP, 8, 0
       NNPHAS = NPHASE
       if(NNPHAS.GT.6) NNPHAS = 6
       write(iauxfil,'(I3,I7,5F10.5)') NNPHAS,NPTS,WLAMDA,ZER, 0., 0.
       write(iauxfil,'(12I5)') (IC(I), I=1,NNPHAS), (0, I=1,NNPHAS)
       if(IWP.EQ.1) then
        write(iauxfil,'(8F8.1)') (Y(I), I=1,NPTS)
        write(iauxfil,'(8F8.1)') (YC(I), I=1,NPTS)
       end if
       if(IWP.EQ.2) then
        write(iauxfil,'(8F8.1)') (sqrt(Y(I))*100., I=1,NPTS)
        if(NoBCKG.EQ.1) then
         write(iauxfil,'(8F8.1)') 
     *    ((sqrt(YC(I)+BK(I))-sqrt(BK(I)))*100., I=1,NPTS)
        else
         write(iauxfil,'(8F8.1)') (sqrt(YC(I))*100., I=1,NPTS)
        end if
       end if
       j = 0
       do i=1,ICZ
        np = IABS(IND4(IREFS(i),4))
        if(np.LE.6) then
         n2 = 1
         if(IND4(IREFS(i),4).LT.0) n2 = 2
         h1 = IND4(IREFS(i),1)
         h2 = IND4(IREFS(i),2)
         h3 = IND4(IREFS(i),3)
         ir = 256*(256*(256*(8*np+n2)+128+h1)+128+h2)+128+h3
         write(iauxfil,'(I10\)') ir
         j = j+1
        end if
        if(j.eq.8) then
         j = 0
         write(iauxfil,*)
        end if
       end do
       if(j.ne.0) write(iauxfil,*)
       j = 0
       do i=1,ICZ
        if(IABS(IND4(IREFS(i),4)).LE.6) then
       write(iauxfil,'(F8.3\)') REFS(i,2)+PSHIFT(GLB(10),GLB(11),REFS(i,2))
         j = j+1
        end if
        if(j.eq.10) then
         j = 0
         write(iauxfil,*)
        end if
       end do
       if(j.ne.0) write(iauxfil,*)
       write(iauxfil,'(I8)') NEXCRG
       do i=1,NEXCRG
        write(iauxfil,'(2F8.2)') ALOW(i),AHIGH(i)
       end do
       CLOSE(iauxfil)
      end if
c
      if(NBCKGD.EQ.-1) then
       open(iauxfil,FILE='ddm_bckgr')
       write(iauxfil,'(F15.10, G13.5)') (THMIN+(I-1)*STEP, BK(I), I=1,NPTS)
       close(iauxfil)
      end if
c
      IF(NXT.NE.0.AND.JOBTYP.LT.3) CALL REWRIT
      RETURN
99990 STOP 'ERROR IN WRITING TO FILE 6 IN SUBROUTINE EXPUT'
99991 STOP 'ERROR WRITING PARAMS,ST.DEV. IN SUBROUTINE EXPUT'
99992 STOP 'ERROR IN READING FROM UNIT 8 IN SUBROUTINE EXPUT'
      END 
c
      SUBROUTINE CIFEXP(IP,RI,RF)
        INCLUDE 'DDM.inc'
c
      COMMON/G3/COND,IORD1,IORD2,TH,NUM 
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/G2/S0,S1,S2,S2e,S3,S4,D0,D1,D2,D3,D4,R1,R2,R3,DC1,DS1,DS2,SYZ(MPH)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
c
      write(iddmcif,'(/2A)') '_diffrn_ambient_temperature  ', '?'
      write(iddmcif,'(A\)') '_diffrn_radiation_probe  '
      if(JOBTYP.NE.2) write(iddmcif,'(A)') 'x-ray'
      if(JOBTYP.EQ.2) write(iddmcif,'(A)') 'neutron'
100   format(A,2X,F10.4)
      write(iddmcif,'(''loop_''/,'' _diffrn_radiation_wavelength''/,
     * '' _diffrn_radiation_wavelength_wt'')')
      write(iddmcif,'(2F10.4)') WLAMDA(1), RATIO(1)
      if(RATIO(2).GT.0) write(iddmcif,'(2F10.4)') WLAMDA(2), RATIO(2)
      write(iddmcif,'(/A)') '_pd_char_colour  ?'
      write(iddmcif,100) '_pd_meas_2theta_range_min', THMIN
      write(iddmcif,100) '_pd_meas_2theta_range_max', THMAX
      write(iddmcif,100) '_pd_meas_2theta_range_inc', STEP
      if(iddm.EQ.0) RWe = SQRT((FLOAT(NUM-MAXS))*D4/(D2*NPTS))
      if(iddm.NE.0) RWe = 0.5*SQRT(D3/D2+S0/D0)
      IOF=1
      IF(IP.GT.1) THEN
        do  I=2,IP 
         IOF = IOF + NATOM(I-1)
        end do
      END IF
      iatm = IOF + NATOM(IP)
      ipar = 0
      DO 7200 I=1,MAXS
        DO 7203 K=IOF,iatm
          DO 7203 J=1,11
            IF(I.EQ.LP(K,J)) then
             ipar = ipar + 1
             GO TO 7200 
            end if
7203      CONTINUE
7200    CONTINUE
      write(iddmcif, '(/''_computing_structure_refinement DDM''/
     *                  ''_refine_ls_number_parameters '',I5,/
     *                  ''_refine_ls_number_restraints '',I5,/
     *                  ''_refine_ls_hydrogen_treatment  ?'',/
     *                  ''_refine_ls_matrix_type      full'',/
     *                  ''_refine_ls_shift/su_max        '',F10.5,/
     *                  ''_refine_ls_R_I_factor          '',F10.5,/
     *                  ''_refine_ls_R_factor_all        '',F10.5,/ 
     *                  ''_pd_proc_ls_prof_wR_factor     '',F10.5,/
     *                  ''_pd_proc_ls_prof_wR_expected   '',F10.5,/
     *                  ''_refine_ls_goodness_of_fit_all '',F10.5)')
     * ipar, 0, SYZ(IP), RI, RF, 0.01*R3, RWe, 0.01*R3/RWe
      write(iddmcif, '(/''_pd_block_id  profile''/)')
      RETURN
      END
C
      SUBROUTINE CALCBK(sbk)
        INCLUDE 'DDM.inc'
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      dimension sdif(IDSZ), sbk(IDSZ)
c
      if(bkcurv.GT.0) then
       fwhs = 0.0
       do j = 1, ICZ  ! Calculate average FWHM
        fwhs = fwhs + REFS(j,1)
       end do
       nconv = NINT(fwhs*bkcurv*0.5/(STEP*ICZ))
      else
       nc = 0
       do j = 1, NPTS  ! Calculate average iconv
        nc = nc + iconv(j)
       end do
       if(bkcurv.EQ.0) nconv = 10*nc/NPTS
       if(bkcurv.LT.0) nconv = -bkcurv*nc/NPTS
      end if
      if(nconv.LT.2) nconv = 2
      do n = 1, 2
       do i = 1, NPTS
        if((i-nconv).LE.0) nc = i - 1
        if((i+nc).GE.NPTS) nc = NPTS - i
        s11 = 0.
        s21 = 0.
        s22 = 0.
        s32 = 0.
        s33 = 0.
        s01 = 0.
        s02 = 0.
        s03 = 0.
        do j = -nc, nc 
         wj = 1./(Y(i+j)*Y(i+j)+YC(i+j)*YC(i+j))
         if(n.EQ.1) then
          diff = Y(i+j)-YC(i+j)
         else
          diff = sdif(i+j)
         end if
         sj = float(j)*STEP
         s11 = s11 + wj
         s21 = s21 + wj*sj
         s22 = s22 + wj*sj*sj
         s32 = s32 + wj*sj*sj*sj
         s33 = s33 + wj*sj*sj*sj*sj
         s01 = s01 + wj*diff
         s02 = s02 + wj*diff*sj 
         s03 = s03 + wj*diff*sj*sj
        end do
        if(nc.GT.0) then
         B = (s01*(s22*s33-s32*s32)-s21*(s02*s33-s32*s03)+s22*
     *       (s02*s32-s22*s03))/(s11*(s22*s33-s32*s32)-s21*
     *       (s21*s33-s32*s22)+s22*(s21*s32-s22*s22))
        else
         B = Y(i)
        end if
        if(B.LT.1.) B = 1.
        if(n.EQ.1) then
         sdif(i) = B
        else
         sbk(i) = B
        end if
       end do
      end do
      RETURN
      END 
c
      SUBROUTINE FURPUT(IX,K,IRH,IRK,IRL)
        INCLUDE 'DDM.inc'
c
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IREFS
       COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
C
      if(ifur(K).EQ.1.AND.IRH.EQ.0.AND.IRK.EQ.0.AND.IRL.EQ.0) then
       if(JOBTYP.EQ.2) return
       IOF = 0
       if(K.GT.1) then
        do  I = 2 , K
          IOF = IOF + NATOM(I-1)
        end do
       end if
       N=NATOM(K) 
       FF0 = 0.
       do I=1,N
        FF0 = FF0 + XL(I+IOF,5)*ATOMN(IPTR(I+IOF))
       end do
       write(iddmcif,'(3I4,2G12.5,F8.4)') IRH, IRK, IRL, FF0, FF0, 0.
       return
      end if
C
      FFTMP=FF(IX)
      FAZA = 1.
      FF0 = FFTMP
      sint = SIN(REFS(IX,2)*0.00872664626)
      
c
c     Finite sample thickness, roughness correction and microabsorption
      if(PARS(K).GT.0) then
       ABSCOR=(1.-OMU/PMU(K))*exp(-PARS(K)*0.0002*PMU(K)/3.)
     * + OMU/PMU(K)
      else
       ABSCOR = 1.
      end if
      IF(GLB(12).NE.0) FF0=FF0/(ABSCOR+GLB(12)*
     * exp(-PARS(K)*0.0002*(PMU(K)-OMU)/3.-GLB(13)/sint))
c
c     ABSORPtion correction for cylindrical sample
      IF(GLB(14).NE.0) 
     * FF0=FF0*exp((1.7133 - 0.0368*sint*sint)*GLB(14)
     *  - (0.0927 + 0.375*sint*sint)*GLB(14)*GLB(14))
c
      PRECOR = 1.
      FDER = 0.
      CALL CALCUL(IX,FAZA,PRECOR,FDER)
      FF1 = FF(IX)
      if(ifur(K).EQ.1) write(iddmcif,'(3I4,2G12.5,F8.4)') IRH, IRK, IRL,
     *  SQRT(FF0/PRECOR)/MLT(K), SQRT(FF1/PRECOR)/MLT(K), FAZA
      if(ifur(K).EQ.2) then
       FFF = FF0*100000./(MLT(K)*MLT(K)*PRECOR*TMAS(K)*TMAS(K))
       write(iddmcif,'((3I4,2F12.4))') IRH, IRK, IRL, FFF, SQRT(FFF)
      end if
        FF(IX)=FFTMP
1111  FORMAT(3I4,F8.4,2F20.8)
      RETURN
        END
C
      SUBROUTINE GEOM(IPH,ICIF,NGEOM,NDIST,IAT)
        INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
c
      DIMENSION G(3,3), dl(2,3), sym1(3,3), sym2(3,3)
      DIMENSION xyz(5,97), nxyz(3,97), nsym(97,4), ang(97), iang(2,97)
      DIMENSION dist(2,NDIST), xyzn(3,NDIST), nat(3,NDIST), isym(NDIST,4)
c
      RAD = 3.141593/180.
c
c Metric tensor calculation
      do i=1,3 
       G(i,i) = SAVL(IPH,i)*SAVL(IPH,i)
      end do
      G(1,2) = SAVL(IPH,1)*SAVL(IPH,2)*COS(SAVL(IPH,6)*RAD)
      G(2,1) = G(1,2)
      G(1,3) = SAVL(IPH,1)*SAVL(IPH,3)*COS(SAVL(IPH,5)*RAD)
      G(3,1) = G(1,3)
      G(2,3) = SAVL(IPH,2)*SAVL(IPH,3)*COS(SAVL(IPH,4)*RAD)
      G(3,2) = G(2,3)
c
      IOF=0
      IF(IPH.GT.1)THEN
       do i=2,IPH
        IOF=IOF + NATOM(i-1)
       end do
      ENDIF
      IRL=MLT(IPH)
      N=NATOM(IPH)
c
      iprint = 0
      idist = 0
      N0 = 1
      if(IAT.NE.0) then ! For environment of 1 atom
       ncoord = 0
       CALL SYMATOMS(IAT,1,N,IPH,IRL,IOF,G,ncoord,xyz,nxyz,nsym)
       dmin = 10000.
       ndmin = 0
       do i = 1, ncoord
        d = SQRT(ABS(xyz(4,i)))
        if(d.LT.dmin) then 
         dmin = d
         ndmin = nxyz(2,i)
        end if
       end do
       IAT = ndmin
       RETURN
      end if
      DO 100 IA=1,N
      if(ADIST(IA+IOF).EQ.0) go to 100
      if(iprint.EQ.0.AND.ICIF.EQ.0) then
       write(iddmout,'(/A//A,I3,1X,A)') ' *****  GEOMETRY CALCULATION *****',
     * ' Phase', IPH, PHSNM(IPH)
       write(iddmout,'(/A/A)')
     * 'Atom1 Atom2  Distance  ESU   Mult  Symmetry',
     * '============================'
       iprint = 1
      end if
      ncoord = 0
      CALL SYMATOMS(IA,1,N,IPH,IRL,IOF,G,ncoord,xyz,nxyz,nsym)
      if(ICIF.EQ.0) then
       nmean = 0
       nprnt = 0
       dmean = 0.
       emean = 0.
       do i = 1, ncoord
        if(nxyz(3,i).GT.0) then
         if(i.GT.1) then
          if(NTYP(nxyz(2,i-1)).NE.NTYP(nxyz(2,i))) then
           if(nprnt.GT.1) write(iddmout,'(11H  Mean     ,2F8.4)')
     *      dmean/nmean, SQRT(emean)/nmean
            nmean = 0
            nprnt = 0
            dmean = 0.
            emean = 0.
           write(iddmout,'(A)') '============================'
          end if
         end if
          d = SQRT(ABS(xyz(4,i)))
          write(iddmout,'(A5,1H-,A5,2F8.4,1X,I3,3X,I3,1H_,3I1)')
     *    ATEXT(nxyz(1,i)),ATEXT(nxyz(2,i)),d,SQRT(ABS(xyz(5,i))), nxyz(3,i),
     *    (nsym(i,j), j = 1,4)
           NGEOM = NGEOM + 1
           nprnt = nprnt + 1
           nmean = nmean + nxyz(3,i)
           dmean = dmean + nxyz(3,i)*d
           emean = emean + xyz(5,i)*nxyz(3,i)*nxyz(3,i)
        end if
       end do
       if(nprnt.GT.1) write(iddmout,'(11H  Mean     ,2F8.4)')
     *  dmean/nmean, SQRT(emean)/nmean
       write(iddmout,'(A)') '============================'
      else
       if(iprint.eq.0) then
        write(ICIF,'(A)')
     * 'loop_',
     * ' _geom_bond_atom_site_label_1',
     * ' _geom_bond_atom_site_label_2',
     * ' _geom_bond_distance',
     * ' _geom_bond_site_symmetry_2',
     * ' _geom_bond_publ_flag'
        iprint = 1
       end if
       do i = 1, ncoord
        if(nxyz(3,i).GT.0) then
         do j = 1, idist
          if(nxyz(1,i).EQ.nat(2,j).AND.nxyz(2,i).EQ.nat(1,j).AND.
     *     ABS(xyz(4,i)-dist(1,j)).LT.xyz(5,i)) goto 90
         end do
         write(ICIF,'(2A5,1X\)') ATEXT(nxyz(1,i)),ATEXT(nxyz(2,i))
         CALL WESD(ICIF,8,4,SQRT(ABS(xyz(4,i))),SQRT(ABS(xyz(5,i))))
         if(nsym(i,1).NE.1.OR.
     *   nsym(i,2).NE.5.OR.nsym(i,3).NE.5.OR.nsym(i,4).NE.5) then
          write(ICIF,'(1X,I3,1H_,3I1,2H ?)') (nsym(i,j), j = 1,4)
         else
          write(ICIF,'(4H . ?)')
         end if
90       idist = idist + 1
         dist(1,idist) = xyz(4,i)
         dist(2,idist) = xyz(5,i)
         do j = 1, 3
          nat(j,idist) = nxyz(j,i)
          xyzn(j,idist) = xyz(j,i)
          isym(idist,j) = nsym(i,j)
         end do
         isym(idist,4) = nsym(i,4)
        end if
       end do
      end if
100   CONTINUE
      if(ICIF.NE.0.AND.NDIST.GT.0) then
       nang = 0
       iprint = 0
       do i = 1, NDIST
        if(ADIST(nat(1,i)).LE.0) cycle
        if(i.GT.1) then
         if(nat(1,i).NE.nat(1,i-1)) nang = 0
        end if
        do j = i, NDIST
         if(nat(1,i).NE.nat(1,j)) exit
         if(i.EQ.j.AND.nat(3,j).LE.1) cycle
         ncoord = 0
         if(nang.GE.97) cycle
         CALL SYMATOMS
     *   (nat(1,i),nat(2,j),nat(2,j),IPH,IRL,0,G,ncoord,xyz,nxyz,nsym)
         do k = 1, ncoord
          dl(1,2) = DISTA(xyzn(1:3,i),xyz(1:3,k),G) ! l2^2
          d = dist(1,i)*xyz(4,k)
          if(d.GT.0) d = 0.5*(dist(1,i) + xyz(4,k) - dl(1,2))/SQRT(d)
          if(ABS(d).LT.0.999999999999.AND.nang.LT.97) then
           d1 = ACOS(d)/RAD
           idif = 0
           do l = 1,nang
            if(nat(2,i).EQ.iang(1,l).AND.nat(2,j).EQ.iang(2,l).AND.
     *      ABS(ang(l)-d1).LT.0.01) then
             idif = 1
             exit
            end if
           end do
           if(idif.EQ.0) then
            dl(1,1) = dist(1,i) ! l1^2
            dl(1,3) = xyz(4,k)  ! l3^2
            dl(2,1) = dist(2,i) ! sigma_l1^2
            dl(2,3) = xyz(5,k)  ! sigma_l3^2
            ESD = 0.
            CALL AESD
     *      (IPH,nat(1,i),nat(2,i),nat(2,j),isym(i,1:4),nsym(k,1:4),G,dl,d,ESD)
	    if(iprint.EQ.0) then
             write(ICIF,'(A)') ' ',
     *       'loop_',
     *       ' _geom_angle_atom_site_label_1',
     *       ' _geom_angle_atom_site_label_2',
     *       ' _geom_angle_atom_site_label_3',
     *       ' _geom_angle',
     *       ' _geom_angle_site_symmetry_1',
     *       ' _geom_angle_site_symmetry_3',
     *       ' _geom_angle_publ_flag'
	     iprint = 1
	    end if
            write(ICIF,'(3A5\)')ATEXT(nat(2,i)),ATEXT(nat(1,i)),ATEXT(nat(2,j))
            CALL WESD(ICIF,8,4,d1,ESD/RAD)
            if(isym(i,1).NE.1.OR.
     *      isym(i,2).NE.5.OR.isym(i,3).NE.5.OR.isym(i,4).NE.5) then
             write(ICIF,'(1X,I3,1H_,3I1\)') (isym(i,n), n = 1,4)
            else
             write(ICIF,'(3H . \)')
            end if
            if(nsym(k,1).NE.1.OR.
     *      nsym(k,2).NE.5.OR.nsym(k,3).NE.5.OR.nsym(k,4).NE.5) then
             write(ICIF,'(1X,I3,1H_,3I1,2H ?)') (nsym(k,n), n = 1,4)
            else
             write(ICIF,'(4H . ?)')
            end if
            nang = nang + 1
            ang(nang) = d1
            iang(1,nang) = nat(2,i)
            iang(2,nang) = nat(2,j)
           end if
          end if
         end do
        end do
       end do
      end if
c
      RETURN
      END
c
      SUBROUTINE AESD(IPH,IA,IB,IC,NSB,NSC,G,DL,CA1,ESD)
        INCLUDE 'DDM.inc'
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
c
      DIMENSION NSB(4), NSC(4), G(3,3), DL(2,3)
      DIMENSION symb(3,3), symc(3,3), xa(3), xb(3), xc(3), s(3,3), n(3)
      DIMENSION c11(3,3),c12(3,3),c13(3,3)
      DIMENSION c21(3,3),c22(3,3),c23(3,3)
      DIMENSION c31(3,3),c32(3,3),c33(3,3)
      DIMENSION cl12(3,3),cl13(3,3),cl23(3,3)
c
      ESD = 0.
      if(DL(1,1).LE.0.OR.DL(1,2).LE.0.OR.DL(1,3).LE.0.OR.ABS(CA1).GE.1) RETURN
      do i=1,3
       xa(i)=XL(IA,i)
       xb(i)=FLOAT(IND4(IMS(IPH,i,NSB(1)),4))/12.0 + NSB(i+1) - 5
       xc(i)=FLOAT(IND4(IMS(IPH,i,NSC(1)),4))/12.0 + NSC(i+1) - 5
       do j=1,3
        symb(i,j) = IND4(IMS(IPH,i,NSB(1)),j)
        symc(i,j) = IND4(IMS(IPH,i,NSC(1)),j)
        xb(i)=xb(i)+symb(i,j)*XL(IB,j)
        xc(i)=xc(i)+symc(i,j)*XL(IC,j)
       end do
      end do
c
      DL(2,2) = 0.
      CALL DESD(xb,xc,IB,IC,G,NSB(1),symb,NSC(1),symc,DL(2,2))
      if(DL(1,2).GT.0) DL(2,2) = DL(2,2)/DL(1,2) ! sigma_l2^2
      ca2 = DL(1,1)*DL(1,2)
      if(ca2.GT.0) ca2 = 0.5*(DL(1,1) + DL(1,2) - DL(1,3))/SQRT(ca2)
      ca3 = DL(1,2)*DL(1,3)
      if(ca3.GT.0) ca3 = 0.5*(DL(1,2) + DL(1,3) - DL(1,1))/SQRT(ca3)
c
      s = 0.
      n(1) = IA
      n(2) = IB
      n(3) = IC
      do i = 1, 3
      do j = 1, 3
       if(LP(n(j),i).GT.0) s(j,i) = SQRT(SMM(LP(n(j),i),LP(n(j),i)))*A(n(j),i)
      end do
      end do
c
      do i= 1, 3
       do j = 1, 3
        c11(i,j) = 0.
        if(LP(n(1),i).EQ.LP(n(1),j)) c11(i,j) = s(1,i)*s(1,j)
        c12(i,j) = 0.                                      
        if(LP(n(1),i).EQ.LP(n(2),j)) c12(i,j) = s(1,i)*s(2,j)
        c13(i,j) = 0.                                      
        if(LP(n(1),i).EQ.LP(n(3),j)) c13(i,j) = s(1,i)*s(3,j)
        c21(i,j) = 0.                                      
        if(LP(n(2),i).EQ.LP(n(1),j)) c21(i,j) = s(2,i)*s(1,j)
        c22(i,j) = 0.                                      
        if(LP(n(2),i).EQ.LP(n(2),j)) c22(i,j) = s(2,i)*s(2,j)
        c23(i,j) = 0.                                      
        if(LP(n(2),i).EQ.LP(n(3),j)) c23(i,j) = s(2,i)*s(3,j)
        c31(i,j) = 0.                                      
        if(LP(n(3),i).EQ.LP(n(1),j)) c31(i,j) = s(3,i)*s(1,j)
        c32(i,j) = 0.                                      
        if(LP(n(3),i).EQ.LP(n(2),j)) c32(i,j) = s(3,i)*s(2,j)
        c33(i,j) = 0.                                      
        if(LP(n(3),i).EQ.LP(n(3),j)) c33(i,j) = s(3,i)*s(3,j)
       end do
      end do
c
      if(NSB(1).NE.1) then
       CALL MULMAT3(symb, c22)
       CALL MULMATT(c22, symb)
       CALL MULMAT3(symb, c21)
       CALL MULMATT(c12, symb)
       CALL MULMAT3(symb, c23)
       CALL MULMATT(c32, symb)
      end if
      if(NSC(1).NE.1) then
       CALL MULMAT3(symc, c33)
       CALL MULMATT(c33, symc)
       CALL MULMAT3(symc, c31)
       CALL MULMATT(c13, symc)
       CALL MULMAT3(symc, c32)
       CALL MULMATT(c23, symc)
      end if
      do i= 1, 3
       do j = 1, 3
        cl12(i,j) = c12(i,j) + c23(i,j) - c13(i,j) - c22(i,j)
        cl13(i,j) = c13(i,j) + c21(i,j) - c23(i,j) - c11(i,j)
        cl23(i,j) = c23(i,j) + c31(i,j) - c21(i,j) - c33(i,j)
       end do
      end do
      CALL MULMAT3(G, cl12)
      CALL MULMATT(cl12, G)
      CALL MULMAT3(G, cl13)
      CALL MULMATT(cl13, G)
      CALL MULMAT3(G, cl23)
      CALL MULMATT(cl23, G)
      cov12 = 0.
      cov13 = 0.
      cov23 = 0.
      do i= 1, 3
       d12 = 0.
       d13 = 0.
       d23 = 0.
       do j = 1, 3
        d12 = d12 + (xb(j) - xa(j))*cl12(j,i)
        d13 = d13 + (xb(j) - xa(j))*cl13(j,i)
        d23 = d23 + (xc(j) - xb(j))*cl23(j,i)
       end do
       cov12 = cov12 + d12*(xc(i) - xb(i))
       cov13 = cov13 + d13*(xa(i) - xc(i))
       cov23 = cov23 + d23*(xa(i) - xc(i))
      end do
      cov12 = cov12/SQRT( ABS( DL(1,1)*DL(1,2) ) )
      cov13 = cov13/SQRT( ABS( DL(1,1)*DL(1,3) ) )
      cov23 = cov23/SQRT( ABS( DL(1,2)*DL(1,3) ) )
c
      ESD = SQRT(ABS((ca2*ca2*DL(2,1) - 2*ca2*cov12 + 2*ca2*ca3*cov13 + DL(2,2)
     *- 2*ca3*cov23 + ca3*ca3*DL(2,3))*DL(1,2)/(DL(1,1)*DL(1,3)*(1.-CA1*CA1))))
c
      RETURN
      END
c
      SUBROUTINE SYMATOMS(IA,IB,N,IPH,IRL,IOF,G,ncoord,xyz,nxyz,nsym)
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
c
      DIMENSION XN(3),XI(3),XJ(3),XD(3),NT(3),G(3,3),SYM(3,3)
      DIMENSION xyz(5,97), nxyz(3,97), nsym(97,4)
c
       DO J=1,3
        XN(J)=XL(IA+IOF,J)
       END DO
      DO 10 I=IB,N
c       if(I.EQ.IA) go to 10
       if(ATEXT(I)(1:1).EQ.'-'.OR.ATEXT(I)(1:1).EQ.'+') cycle
        DO 9 J=1,3
9         XI(J)=XL(I+IOF,J)
        DO 1 IR=1,IRL
         DO II=1,3
          XJ(II)=FLOAT(IND4(IMS(IPH,II,IR),4))/12.0
          DO J=1,3
           SYM(II,J) = IND4(IMS(IPH,II,IR),J)
           XJ(II)=XJ(II)+SYM(II,J)*XI(J)
          END DO
         END DO
         DO 1 NT1=-1,1
         DO 1 NT2=-1,1
         DO 1 NT3=-1,1
          NT(1) = NT1
          NT(2) = NT2
          NT(3) = NT3
          DO J=1,3
           if(XJ(J).LT.0.) NT(J) = NT(J) + 1
           if(XJ(J).GT.1.) NT(J) = NT(J) - 1
           XD(J) = XJ(J)+NT(J)
           xyz(J,ncoord+1) = XD(J)
          END DO
          D = DISTA(XN,XD,G)
          sd = SQRT(ABS(D))
c
          if((sd.GT.0.0001).AND.(sd.LE.ABS(ADIST(IA+IOF)))) then
           if(ncoord.GT.0) then ! Omit identical atoms
            do j = 1, ncoord
             idif = 0
             do k = 1, 3
              if(ABS(xyz(k,ncoord+1)-xyz(k,j)).GT.0.000003) idif = 1
             end do
             if(idif.eq.0) go to 1
            end do
           end if
           if(ncoord.LT.96) ncoord = ncoord + 1
           nxyz(1,ncoord) = IA+IOF
           nxyz(2,ncoord) = I+IOF
           nxyz(3,ncoord) = 1
           nsym(ncoord,1) = IR
           nsym(ncoord,2) = 5+NT(1)
           nsym(ncoord,3) = 5+NT(2)
           nsym(ncoord,4) = 5+NT(3)
           ESD = 0.
           CALL DESD(XN, XD, IA+IOF, I+IOF, G, 1, SYM, IR, SYM, ESD)
           xyz(4,ncoord) = D
           xyz(5,ncoord) = ESD/D
           do j = 1, ncoord-1
            if(nxyz(2,j).NE.nxyz(2,ncoord)) cycle
            if(ABS(sd-SQRT(xyz(4,j))).LT.0.00001) then
             nxyz(3,ncoord) = 0 ! To omit further output
             nxyz(3,j) = nxyz(3,j) + 1
             exit
            end if
           end do
          end if
1     CONTINUE
10    CONTINUE
      RETURN
      END
c
      FUNCTION DISTA(XN,XD,G)
      DIMENSION XN(3),XD(3),G(3,3)
c
      D = 0.
      do j= 1, 3
       dx = 0.
       do k = 1, 3
        dx = dx + (XN(k) - XD(k))*G(k,j)
       end do
       D = D + dx*(XN(j) - XD(j))
      end do
      DISTA = D
      RETURN
      END
c
      SUBROUTINE DESD(X1, X2, I1, I2, G, IS1, SYM1, IS2, SYM2, ESD)
        INCLUDE 'DDM.inc'
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
c
      DIMENSION X1(3), X2(3), G(3,3), SYM1(3,3), SYM2(3,3)
      DIMENSION c11(3,3),c12(3,3),c21(3,3),c22(3,3),s1(3),s2(3)
c
      do i= 1, 3
       s1(i) = 0.
       if(LP(I1,i).GT.0) s1(i) = SQRT(SMM(LP(I1,i),LP(I1,i)))*A(I1,i)
       s2(i) = 0.
       if(LP(I2,i).GT.0) s2(i) = SQRT(SMM(LP(I2,i),LP(I2,i)))*A(I2,i)
      end do
c
      do i= 1, 3
       do j = 1, 3
        c11(i,j) = 0.
        if(LP(I1,i).EQ.LP(I1,j)) c11(i,j) = s1(i)*s1(j)
        c22(i,j) = 0.
        if(LP(I2,i).EQ.LP(I2,j)) c22(i,j) = s2(i)*s2(j)
        c12(i,j) = 0.
        if(LP(I1,i).EQ.LP(I2,j)) c12(i,j) = s1(i)*s2(j)
        c21(i,j) = 0.
        if(LP(I2,i).EQ.LP(I1,j)) c21(i,j) = s2(i)*s1(j)
       end do
      end do
c
      if(IS1.NE.1) then
       CALL MULMAT3(SYM1, c11)
       CALL MULMATT(c11, SYM1)
       CALL MULMAT3(SYM1, c12)
       CALL MULMATT(c21, SYM1)
      end if
      if(IS2.NE.1) then
       CALL MULMAT3(SYM2, c22)
       CALL MULMATT(c22, SYM2)
       CALL MULMAT3(SYM2, c21)
       CALL MULMATT(c12, SYM2)
      end if
      do i= 1, 3
       do j = 1, 3
        c11(i,j) = c22(i,j)+c11(i,j)-c12(i,j)-c21(i,j)
       end do
      end do
      CALL MULMAT3(G, c11)
      CALL MULMATT(c11, G)
      do i= 1, 3
       dx = 0.
       do j = 1, 3
        dx = dx + (X1(j) - X2(j))*c11(j,i)
       end do
       ESD = ESD + dx*(X1(i) - X2(i))
      end do
c
      RETURN
      END
C
      SUBROUTINE CALCY(kphase, yck)
      INCLUDE 'DDM.inc'
      REAL WLAMDA, yck(NPTS)
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      integer*4 IREFS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS) ,LAU1(MPH), ICZ
      LOGICAL  IPRFD
      COMMON/PRFX/GAM1,GAM2,PRFDER,SLDER,PRFD(6),IPRFD(MPH,6)
      COMMON /PVII/ TF1(MPH),TF2(MPH),TF4(MPH),TF6(MPH),TF8(MPH),
     * TF9(MPH),C4(MPH)
        character fwhfix(irs)*1
        common/fwcntr/ fwhfix
      LOGICAL VERT
C
      do i=1,NPTS
       if(kphase.LE.0) then
        YC(i) = 0.
       else
        yck(i) = 0.
       end if
      end do
C
      ZER=GLB(1)
C
      DO 481 IX=1,ICZ
       K = IABS(IND4(IREFS(IX),4))  ! N.of phase
       if((kphase.GT.0).AND.(K.NE.kphase)) cycle
c   Peak shift due to sample displacement and asymmetry
       SHIFT = PSHIFT(GLB(10),GLB(11),REFS(IX,2))
c       if(kphase.NE.-2) then
c        DO 485 J=1,NEXCRG
c         IF((REFS(IX,2)+SHIFT+ZER).GE.(ALOW(J)-WDT*REFS(IX,1))
c     *                                   .AND.
c     *     (REFS(IX,2)+SHIFT+ZER).LE.(AHIGH(J)+WDT*REFS(IX,1))) GOTO 481
c485     CONTINUE
c       end if
       RMIN=REFS(IX,2)+ZER+SHIFT-WDT*REFS(IX,1)
       RMAX=REFS(IX,2)+ZER+SHIFT+WDT*REFS(IX,1)
       MIN=(RMIN-THMIN)/STEP+1.5
       MAX=(RMAX-THMIN)/STEP+1.5
       MIN=MAX0(MIN,1)
       MIN=MIN0(MIN,NPTS)
       MAX=MIN0(MAX,NPTS)
       VERT=REFS(IX,2).LE.RLIM
       TL=REFS(IX,1)
       IF (NPROF.EQ.6) GAM1 = PAR(K,17) + PAR(K,18) * REFS(IX,2)
       IF (NPROF.EQ.7) GAM1 = PAR(K,17) + PAR(K,18) / REFS(IX,2)
     !                         + PAR(K,19)/REFS(IX,2)/REFS(IX,2)
       IF (NPROF.EQ.7) CALL PRSVII(K)
       IF(NPROF.EQ.8) THEN 
        GAM1 = GAM(IX)
        TLG = HALFG(IX)
        TLL = HALFL(IX)
       END IF
       BB=TL*TL
       DO 410 IS=MIN,MAX
        TH=THMIN+FLOAT(IS-1)*STEP
c        IF(NEXCRG.GT.0.AND.kphase.NE.-2) THEN
c         DO 1450 IEXC=1,NEXCRG
c          IF (TH.GE.ALOW(IEXC).AND.TH.LE.AHIGH(IEXC)) GO TO 410 
c1450     CONTINUE
c        END IF
        DELTA=TH-REFS(IX,2)-ZER-SHIFT
        DELT=DELTA*DELTA
C     NEXT LINE IS NECESSEARY FOR 2 PHASES WITH VERY DIFFERENT FWHM.
        IF (DELT/BB.GT.WDT*WDT) GO TO 410
c
c       Asymmetry correction !!
        ASYM = PAR(K,14)*EXP(-REFS(IX,2)*.084)
C    Apply ASYM2
        if(PAR(K,48).NE.0) ASYM = ASYM + PAR(K,48)*REFS(IX,4)*
     *      TAN(REFS(IX,2)*0.00872664625997)
c
        yc0 = PROFIL(NPROF,K,TL,REFS(IX,2),DELTA,ASYM)*REFS(IX,3)*FF(IX)/TL
        IF(SAMPLE.GT.TH)    ! Sample edge correction
     *   yc0 = yc0/(1.+(.0128+.0106*(SAMPLE-TH))*(SAMPLE-TH))
        if(kphase.LE.0) then
         YC(IS) = YC(IS) + yc0*PAR(K,1)
        else
         yck(IS) = yck(IS) + yc0
        end if
C
410    CONTINUE
481   CONTINUE
c
      if(NBCKGD.NE.0.OR.IBFILE.NE.0.OR.
     *  (GLB(2)+GLB(3)+GLB(4)+GLB(5)+GLB(6)+GLB(7)).NE.0) then
       do I=1,NPTS
        YC(I) = YC(I) + BK(I)
       end do
      end if
c
      if(kphase.NE.0) RETURN
c
       S0 = 0.
       D0 = 0.
       S2 = 0.
       D2 = 0.
       do I=1,NPTS
        if(iddm.EQ.0) then ! least squares
         DEL = Y(I)-YC(I)
         S2=S2+DEL*DEL/VAR(I)
         D2=D2+Y(I)*Y(I)/VAR(I)
        else ! DDM
         if((I.LT.3).or.(I.GT.NPTS-2)) go to 15
         ia = iconv(I)
         cn0 = ia*2+1
         cn1 = ia*(ia+1)*cn0
         cn2 = (4*ia*(ia+1)-3)*cn0
         c00 = (9*ia*(ia+1)-3)/cn2
         c01 = -15./cn2  ! equals to c20         
         c10 = 3./cn1    
         c21 = 45./(cn2*ia*(ia+1))
         Y1  = 0.0
         Y2  = 0.0
         DEL1 = 0.0
         DEL2 = 0.0
         p0 = 0.
         do l = -ia, ia
          c1 = l*c10
          c2 = c01+c21*l*l
          p0=p0+Y(I+l)*(c00+c01*l*l)
          Y1=Y1+Y(I+l)*c1
          Y2=Y2+Y(I+l)*c2
          DEL1=DEL1+(Y(I+l)-YC(I+l))*c1
          DEL2=DEL2+(Y(I+l)-YC(I+l))*c2
         end do
         var0 = VAR(I)
         if(iwght.EQ.1) var0 = var0*ia
         if(iwght.EQ.2) var0 = var0*ia*ia
         S0=S0+(Y(I)-p0)*(Y(I)-p0)/var0
         D0=D0+Y(I)*Y(I)/var0
         S2=S2+DEL1*DEL1/VAR1(I)+DEL2*DEL2/VAR2(I)
         D2=D2+Y1*Y1/VAR1(I)+Y2*Y2/VAR2(I)
        end if
15      CONTINUE
       end do
        if(iddm.EQ.0) then
         RWP=100.*SQRT(S2/D2)
        else
         RWP=50.*SQRT(S2/D2+S0/D0)
        end if
        call outscr(MCYCLE,RWP)
        RETURN
        END

      SUBROUTINE CIF(IP)
        INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      CHARACTER*4 NAM(32)
      COMMON/COEFC/NAM
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      CHARACTER HMSYMB(MPH)*20, HALLSYM(MPH)*20
      CHARACTER TITLE*80,PHSNM(MPH)*70,datfnm*128,bacfnm*128
      COMMON/CHARS/HALLSYM,HMSYMB,TITLE,PHSNM,datfnm,bacfnm
C
      DIMENSION DCSM(6,6),DCV(6),SZ(npar)
      DIMENSION uanis(6),asum(32),npatm(32),nsatm(32),X(3),ntemp(32)
      character datanm*70
      character atsymb*64, atquan*12, syint*64
      integer*2 intsy(32)
      equivalence (syint, intsy)
      
      character cellc(6)*17, cellv*12
      data cellc(1),cellc(2),cellc(3),cellc(4),cellc(5),cellc(6)
     * /'_cell_length_a   ',
     *  '_cell_length_b   ',
     *  '_cell_length_c   ',
     *  '_cell_angle_alpha',
     *  '_cell_angle_beta ',
     *  '_cell_angle_gamma'/

      RAD = 3.141593/180.
      IOF=0
      IF(IP.GT.1) THEN
        do  IIPHAS=2,IP 
         IOF = IOF + NATOM(IIPHAS-1)
        end do
      END IF
      j = 1
      k = 0
      do i = 1, 70
       datanm(i:i) = ' '
       if(PHSNM(IP)(i:i).NE.' ') k = 1
       if(k.EQ.1) then
        datanm(j:j) = PHSNM(IP)(i:i)
        j = j + 1
       end if
      end do
      if(k.EQ.0) write(datanm,'(A,I2)') 'Phase', IP
      k = 0
      do i = 70, 1, -1
       if(datanm(i:i).NE.' ') k = 1
       if(k.EQ.1.AND.datanm(i:i).EQ.' ') datanm(i:i) = '_'
      end do
      write(iddmcif,'(/,''data_'',A/)') datanm
c
      if(HMSYMB(IP)(1:4).NE.'HALL') write(iddmcif,104) HMSYMB(IP)
      write(iddmcif,105) HALLSYM(IP)
104   FORMAT('_symmetry_space_group_name_H-M  ',1H',A,1H')
105   FORMAT('_symmetry_space_group_name_Hall ',1H',A,1H')
      write(iddmcif,'(A)') 'loop_'
      write(iddmcif,'(A)') '_symmetry_equiv_pos_site_id'
      write(iddmcif,'(A)') '_symmetry_equiv_pos_as_xyz'
      k = iddmcif
      do i = 1, MLT(IP)
       CALL OUTXYZ(IP, i, k)
      end do
      write(iddmcif,*)
      CALL DIRECT(DCSM,DCV,IP)
c  For Hex-lattice
      if(NSG(IP).GE.143.AND.NSG(IP).LE.194.AND.MAXIS(IP).NE.-1) DCSM(6,6)=0.
      do k=1,6
       write(iddmcif,'(/A,1H ,\)') cellc(k)
       CALL WESD(iddmcif,10,6,DCV(k),DCSM(k,k))
      end do
      write(iddmcif,'(/A,1H ,\)') '_cell_volume'
      CALL WESD(iddmcif,16,4,VOL(IP),ESDVOL(IP))
      write(iddmcif,'(/2A)') '_cell_measurement_temperature  ', '?'
c
      N=NATOM(IP)
      if(N.LE.0) RETURN
      TMAS(IP) = 0.
      do I=1,N 
       TMAS(IP) = TMAS(IP) + XL(I+IOF,5)*XMAS(IPTR(I+IOF))
       isymb = ichar(NTYP(I+IOF)(2:2))
       if((isymb.GE.65).AND.(isymb.LE.90)) NTYP(I+IOF)(2:2) = char(isymb + 32)
      end do
C  Find the number of unique atoms and put their symbols to atsymb
      nuatm = 1
      npatm(1) = 1
      npatm(2) = 2
      atsymb(1:2) = NTYP(1+IOF)(1:2)
      isymb = ichar(atsymb(npatm(2):npatm(2)))
      if((isymb.GE.97).AND.(isymb.LE.122)) npatm(2) = npatm(2) + 1
      asum(1) = XL(1+IOF,5)
      nsatm(1) = IPTR(1+IOF)
      do i = 2, N
       do j = 1, nuatm
        k = 1
        isymb = ichar(NTYP(i+IOF)(2:2))
        if((isymb.GE.97).AND.(isymb.LE.122)) k = 2
        if((NTYP(i+IOF)(1:k).EQ.atsymb(npatm(j):npatm(j)+k-1)).AND.
     *      (npatm(j+1)-npatm(j).EQ.k)) then
         asum(j) = asum(j) + XL(i+IOF,5)
         nsatm(j) = IPTR(i+IOF)
         k = 0
         exit
        end if
       end do
       if(k.EQ.0) cycle
       nuatm = nuatm + 1
       npatm(nuatm+1) = npatm(nuatm)+1
       atsymb(npatm(nuatm):npatm(nuatm)+1) = NTYP(i+IOF)(1:2)
       npatm(nuatm+1) = npatm(nuatm+1) + k - 1
       asum(nuatm) = XL(i+IOF,5)
       nsatm(nuatm) = IPTR(i+IOF)
      end do
c
c Calculate Z
c
      nz = 1
      nmin = 1
      j = 0
      do i = 1, nuatm
       ntemp(i) = NINT(asum(i))
       if(ABS(ntemp(i)-asum(i)).GE.0.001) go to 90
       if(ntemp(i).LE.0) ntemp(i) = 1
       if(ntemp(i).LT.nmin.OR.i.EQ.1) nmin = ntemp(i)
      end do
      do k = nmin, 1, -1
       do i = 1, nuatm
        if(MOD(ntemp(i),k).NE.0) exit
       end do
       if(i.GT.nuatm) exit
      end do
      nz = k
90    write(iddmcif,'(/A,I6)') '_cell_formula_units_Z ', nz
c
c Atom symbol ordering for _chemical_formula_sum
c
      do i = 1, nuatm ! Convert atom symbols to comparable integers
       j = i*2 - 1
       syint(j+1:j+1) = atsymb(npatm(i):npatm(i))
       syint(j:j) = '@'
       if(npatm(i).NE.npatm(i+1)-1) then
        syint(j:j)=atsymb(npatm(i)+1:npatm(i)+1)
        intsy(i) = intsy(i) - 32
       end if
      end do
      nmin = 1
      do i = 1, nuatm ! Find carbon
       ntemp(i) = 0
       if(atsymb(npatm(i):npatm(i)).EQ.'C'.AND.npatm(i).EQ.npatm(i+1)-1)
     *  ntemp(1) = i
      end do
      if(ntemp(1).GT.0) then ! Find hydrogen
       nmin = 2
       do i = 1, nuatm
        if(atsymb(npatm(i):npatm(i)).EQ.'H'.AND.npatm(i).EQ.npatm(i+1)-1) then
         ntemp(2) = i
         nmin = 3
        end if
       end do
      end if
      l = 0
      do i = nmin, nuatm
       k = 65000
       do j = 1, nuatm
        if(nmin.GT.1.AND.j.EQ.ntemp(1)) cycle
        if(nmin.GT.2.AND.j.EQ.ntemp(2)) cycle
        m = intsy(j) - l
        if(m.GT.0.AND.m.LT.k) then
         k = m
         ntemp(i) = j
        end if
       end do
       j = ntemp(i)
       l = intsy(j)
      end do
c
      write(iddmcif,102)
102   FORMAT('_chemical_formula_sum   ',2H '\)
      do k = 1, nuatm
       i = ntemp(k)
       if(ABS(asum(i)-NINT(asum(i))).LT.0.001) then
        WRITE (atquan,'(I10)') NINT(asum(i)/nz)
       else
        WRITE (atquan,'(F10.3)') asum(i)/nz
       end if
       do j = 1, 12
        if(atquan(j:j).NE.' ') exit
       end do
       if(asum(i).EQ.nz) then
        write(iddmcif,'(2A\)') atsymb(npatm(i):npatm(i+1)-1), ' '
       else
        write(iddmcif,'(2A\)') atsymb(npatm(i):npatm(i+1)-1), atquan(j:11)
       end if
      end do
      write(iddmcif,'(A)') "'"
c
      write(iddmcif,'(A,2X,F12.2)') '_chemical_formula_weight', TMAS(IP)/nz
      write(iddmcif,'(A,F10.4)') '_exptl_crystal_density_diffrn',
     *  1.66113*TMAS(IP)/VOL(IP)
c
      write(iddmcif,'(/"loop_",/"_atom_type_symbol")')
      if(JOBTYP.NE.2) then
       write(iddmcif,'("_atom_type_scat_dispersion_real",/
     * "_atom_type_scat_dispersion_imag")')
       do i = 1, nuatm
        write(iddmcif,'(3A,2F10.5)') " '",atsymb(npatm(i):npatm(i+1)-1),"'",
     *  DFP(nsatm(i)), DFPP(nsatm(i))
       end do
      else
       write(iddmcif,'("_atom_type_scat_length_neutron")')
       do i = 1, nuatm
        write(iddmcif,'(3A,F10.5)') " '",atsymb(npatm(i):npatm(i+1)-1),"'",
     *  DFP(nsatm(i))
       end do
      end if
      write(iddmcif,'("_atom_type_scat_source"/";")')
      write(iddmcif,'(A/A/";")')
     * 'X-Ray Form Factor, C Attenuation and Scattering Tables (version 2.1).',
     * 'NIST, Gaithersburg, MD.'
c
      write(iddmcif,106)
106   FORMAT(//'loop_',/,
     *' _atom_site_label',/,
     *' _atom_site_type_symbol',/,
     *' _atom_site_fract_x',/,
     *' _atom_site_fract_y',/,
     *' _atom_site_fract_z',/,
     *' _atom_site_U_iso_or_equiv',/,
     *' _atom_site_occupancy',/,
     *' _atom_site_adp_type')
      NANIS=0
      DO 4 I=1,N 
        if(ATEXT(I+IOF)(1:1).EQ.'-') cycle
        DO  5 J=1,5
          KM=LP(I+IOF,J)
          IF(KM.NE.0)GOTO  6
          SZ(J)=0.
          GOTO  5 
6         SZ(J)=SQRT(SMM(KM,KM))*ABS(A(I+IOF,J))
5         CONTINUE
        k = 1
        isymb = ichar(NTYP(I+IOF)(2:2))
        if((isymb.GE.97).AND.(isymb.LE.122)) k = 2
        if(ATEXT(I+IOF)(1:1).NE.'+') then
         write(iddmcif,'(A4,1X,A2,1X\)') ATEXT(I+IOF), NTYP(I+IOF)(1:k)
        else
         write(iddmcif,'(A4,1X,A2,1X\)') ATEXT(I+IOF)(2:4), NTYP(I+IOF)(1:k)
        end if
        do k = 1, 3
         X(k) = XL(I+IOF,k)
        end do
        posmul = MULPOS(IP,X)
        do k=1,5
         id=0
         np=0
         pd = XL(I+IOF,k)
         d = SZ(k)
         if(k.EQ.4) then
          d = d*0.012665148 ! Biso to Uiso
          pd = pd*0.012665148 ! Biso to Uiso
c    U(equiv) = (1/3) sum~i~[sum~j~(U^ij^ a*~i~ a*~j~ A~i~.A~j~)]
c               A     = the real-space cell lengths
c             a*    = the reciprocal-space cell lengths
          if(IANIS(I+IOF).EQ.1) then
           pd = pd + 0.01688686*(
     *               XL(I+IOF,6)*SAVL(IP,1)*SAVL(IP,1) +
     *               XL(I+IOF,7)*SAVL(IP,2)*SAVL(IP,2) +
     *               XL(I+IOF,8)*SAVL(IP,3)*SAVL(IP,3) +
     *     2*XL(I+IOF,9)*SAVL(IP,1)*SAVL(IP,2)*COS(SAVL(IP,6)*RAD) +
     *     2*XL(I+IOF,10)*SAVL(IP,1)*SAVL(IP,3)*COS(SAVL(IP,5)*RAD) +
     *     2*XL(I+IOF,11)*SAVL(IP,2)*SAVL(IP,3)*COS(SAVL(IP,4)*RAD))
          end if
         end if
         if(k.EQ.5) then
          d = d/posmul
          pd = pd/posmul
         end if
         if(k.LT.4) then
           if(ATEXT(I+IOF)(1:1).NE.'+') then
            CALL WESD(iddmcif,10,5,pd,d)
           else
            CALL WESD(iddmcif,10,5,pd,0.)
           end if
         end if
         if(k.GE.4) CALL WESD(iddmcif,8,4,pd,d)
        end do
        if(IANIS(I+IOF).EQ.1) then
         NANIS=1
         write(iddmcif,'('' Uani'')')
        else 
         write(iddmcif,'('' Uiso'')')
        end if
4     continue
      if(NANIS.EQ.0) go to 10
      write(iddmcif,108)
108   FORMAT(/'loop_',/,
     *' _atom_site_aniso_label',/,
     *' _atom_site_aniso_U_11',/,
     *' _atom_site_aniso_U_22',/,
     *' _atom_site_aniso_U_33',/,
     *' _atom_site_aniso_U_12',/,
     *' _atom_site_aniso_U_13',/,
     *' _atom_site_aniso_U_23')
      uanis(1) = 0.05066/PAR(IP,6)
      uanis(2) = 0.05066/PAR(IP,7)
      uanis(3) = 0.05066/PAR(IP,8)
      uanis(4) = 0.05066/sqrt(PAR(IP,6)*PAR(IP,7))
      uanis(5) = 0.05066/sqrt(PAR(IP,6)*PAR(IP,8))
      uanis(6) = 0.05066/sqrt(PAR(IP,7)*PAR(IP,8))
      DO  44 I=1,N 
       if(IANIS(I+IOF).EQ.1) then
        DO  55 J=6,11
          KM=LP(I+IOF,J)
          IF(KM.NE.0)GOTO  66
          SZ(J)=0.
          GOTO  55 
66        SZ(J)=SQRT(SMM(KM,KM))*ABS(A(I+IOF,J))
55        CONTINUE
        write(iddmcif,'(A4)') ATEXT(I+IOF)
        do k=6,11
         CALL WESD(iddmcif,9,4,XL(I+IOF,k)*uanis(k-5),SZ(k)*uanis(k-5))
        end do
        write(iddmcif,*)
       end if
44    continue
C
10    write(iddmcif,*)
C
1000  RETURN
      END
C
      SUBROUTINE WESD(IUOT,LEN,NPRES,VAL,ESD)
      character dform*8, esdform*9
      data dform /'(F09.5\)'/
      data esdform /'(A,I1,A\)'/
c
      id=0
      np=0
      if(LEN.LT.0) esdform(8:8)=' '
      le = IABS(LEN)
      l = (le+1)/10
      dform(3:3)=char(l+48)
      dform(4:4)=char(le-l*10+49)
      d = ESD
      if(d.GE.9.5) esdform(5:5)='2'
      do i = 1,NPRES+2
       if(d.GE.0.95) then
        id=NINT(d)
        exit
       end if
       d=d*10
       np=np+1
      end do
      if(id.GT.0) then
       if(d.GE.4.95) then
        dform(6:6)=char(np+48)
       else
        l = le/10
        dform(3:3)=char(l+48)
        dform(4:4)=char(le-l*10+48)
        dform(6:6)=char(np+49)
        esdform(5:5)='2'
        id=NINT(d*10)
       end if
       if(dform(6:6).EQ.'0') then 
        dform(2:2)='I'
        write(IUOT,dform) NINT(VAL)
       else
        write(IUOT,dform) VAL
       end if
       write(IUOT,esdform) '(', id, ')'
      else
       dform(6:6)=char(NPRES+48)
       write(IUOT,'(3H   \)')
       write(IUOT,dform) VAL
      end if
c
      esdform(8:8)='\'
      esdform(5:5)='1'
      dform(2:2)='F'
      RETURN
      END
c
      FUNCTION MULPOS(IPH,X)
        INCLUDE 'DDM.inc'
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      DIMENSION X(3), XI(3), XJ(3)
c
      MULPOS = 1
      IRL=MLT(IPH)
      DO 1 IR=2,IRL
       do i = 1, 3
        XI(i) = X(i) - INT(X(i))
        if(XI(i).LT.0.) XI(i) = XI(i) + 1.
       end do
       k = 0
       do i=1,3
        XJ(i)=FLOAT(IND4(IMS(IPH,I,IR),4))/12.0
        do j=1,3
         XJ(i)=XJ(i)+IND4(IMS(IPH,I,IR),J)*XI(j)
        end do
        if(XJ(i).LT.0.) XJ(i) = XJ(i) + 1.
        if(XJ(i).GE.1.) XJ(i) = XJ(i) - 1.
        if(ABS(XJ(i)-XI(i)).GT.0.00002) k = 1
       end do
       if(k.EQ.0) MULPOS = MULPOS + 1
1     CONTINUE
      MULPOS = IRL/MULPOS
      RETURN
      END
c
      SUBROUTINE OUTXYZ(IPH,N,NFILE)
        INCLUDE 'DDM.inc'
      integer*4 IMS
      COMMON/SYMG/IMS(MPH,3,192),MLT(MPH),ICET(MPH),NSG(MPH),MAXIS(MPH)
      INTEGER*4 ism(3), it
      CHARACTER*33 opr
      CHARACTER*3  xyz
      DATA xyz/'xyz'/
c
      opr(1:33) = ' '
      do i = 1, 3
       it=IND4(IMS(IPH,i,N),4)
       lp = i*11 - 8
       if(it.NE.0) then
        do j = 1, 5
         if(MOD(12*j,it).EQ.0) exit ! Find the numerator (j)
        end do
        k = 12*j/it ! The denominator
        opr(lp:lp) = CHAR(j+48)
        opr(lp+1:lp+1) = '/'
        opr(lp+2:lp+2) = CHAR(k+48)
       end if
       ism(1)=IND4(IMS(IPH,i,N),1)
       ism(2)=IND4(IMS(IPH,i,N),2)
       ism(3)=IND4(IMS(IPH,i,N),3)
       do j = 1, 3
        k = lp + 1 + j*2
        if(ism(j).GT.0) opr(k:k) = '+'
        if(ism(j).LT.0) opr(k:k) = '-'
        if(ism(j).NE.0) opr(k+1:k+1) = xyz(j:j)
       end do
       if(i.LT.3) opr(lp+9:lp+9) = ','
       do j = lp, lp + 7
        if(opr(j:j).NE.' ') exit
       end do
       if(opr(j:j).EQ.'+'.AND.opr(j-1:j-1).EQ.' ') opr(j:j) = ' '
      end do
      j = 0
      do i = 1, 33
       if(opr(i:i).NE.' ') then
        j = j + 1
        opr(j:j) = opr(i:i)
        if(opr(j:j).EQ.',') then
         j = j + 1
         opr(j:j) = ' '
        end if
       end if
      end do
      write(NFILE,10) N, opr(1:j)
10    format(I4,1X,1H',A,1H')
      RETURN
      END
C
C
      SUBROUTINE CALCS0(ns0)
      INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      dimension yck(NPTS)
C
      DO  K=1,NPHASE
       if(PAR(K,1).NE.0) cycle
       PAR(K,1) = 0.0000000001
       if(NATOM(K).EQ.0) cycle
       ns0 = 1
       CALL CALCY(K, yck)
       ycmax = 0.
       i = 3
       do j = 1, NPTS
        if(yck(j).GT.ycmax) then
         ycmax = yck(j)
         i = j
        end if
       end do
	 j = i - iconv(i)
	 if(j.LT.2) j = 2
	 m = i + iconv(i)
	 if(m.GT.NPTS-1) m = NPTS - 1
	 ys2 = 0.
	 ycs2 = 0.
	 do i = j, m
          ia = iconv(i)
          cn0 = ia*2+1
          cn2 = (4*ia*(ia+1)-3)*cn0
          c01 = -15./cn2  ! equals to c20         
          c21 = 45./(cn2*ia*(ia+1))
          y2  = 0.0
          yc2 = 0.0
          do l = -ia, ia
           c2 = c01+c21*l*l
           y2=y2+(Y(i+l)-YC(i+l))*c2
           yc2=yc2+yck(i+l)*c2
          end do
	  ys2 = ys2 + abs(y2)
	  ycs2 = ycs2 + abs(yc2)
	 end do
       if(ycs2.GT.0.) then
	  PAR(K,1) = ys2/ycs2
	 else
	  PAR(K,1) = 0.
       end if
      END DO

      RETURN
      END

c
      FUNCTION IND4(IR,N)
      integer*4 IR
c
c Returns N-th byte of 4-byte integer
c
      integer*4 i
      integer*1 i4(4)
      equivalence (i, i4)
c
      i = IR
      IND4 = i4(N)
c
      RETURN
      END
c
      SUBROUTINE RCURV
      INCLUDE 'DDM.inc'
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     * BKM(IDSZ),NPTS,iconv(IDSZ),VAR1(IDSZ),VAR2(IDSZ)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,WLAMDA(2),TMV,CTHM,RLIM,BKPOS,WDT
     * ,ULOR,VLOR,ZZZ,SAMPLE,cddm,iwght,bkcurv
      COMMON/REFLS/IREFS(IRS),REFS(IRS,4),FF(IRS),IC(MPH)
     *  ,HALFL(IRS),HALFG(IRS),GAM(IRS),LAU1(MPH), ICZ
      dimension sbk(IDSZ)
C
      fwhs = 0.
      do j = 1, ICZ  ! Calculate average FWHM
       fwhs = fwhs + REFS(j,1)
      end do
      nconv = NINT(fwhs/(STEP*ICZ))
      if(nconv.LT.1) nconv = 1
      CALL CALCBK(sbk)
      S0 = 0.
      S1 = 0.
      S2 = 0.
      S3 = 0.
      DO 10 I=1,NPTS
       if((I-nconv).LE.0) nc = I - 1
       if((I+nc).GE.NPTS) nc = NPTS - I
       if((I.LT.3).or.(I.GT.NPTS-2)) go to 10
       IF(NEXCRG.GT.0) THEN
        DO IEXC=1,NEXCRG
          NPTLOW = (ALOW(IEXC)-THMIN)/STEP + 1.5
          NPTHI  = (AHIGH(IEXC)-THMIN)/STEP + 1.5
          IF (I.GE.NPTLOW.AND.I.LE.NPTHI) GO TO 10
        END DO
       END IF
       cn0 = nc*2+1
       ys = 0.
       ds = 0.
       ws = 0.
       do l = -nc, nc
        ys = ys + Y(I+l)
        ds = ds + Y(I+l)-YC(I+l)-sbk(I+l)
        ws = ws + VAR(I+l)
       end do
       ws = ws/(cn0*cn0)
       yi = 0.
       di = 0.
       do l = -nc, nc
        c = Y(I+l) - ys/cn0
        yi = yi + c*c/(ws+VAR(I+l))
        c = Y(I+l)-YC(I+l)-sbk(I+l) - ds/cn0
        di = di + c*c/(ws+VAR(I+l))
       end do
       S0 = S0 + yi
       S1 = S1 + di
       S2 = S2 + (Y(I)-sbk(I))*(Y(I)-sbk(I))/VAR(I)
       S3 = S3 + (Y(I)-YC(I)-sbk(I))*(Y(I)-YC(I)-sbk(I))/VAR(I)
10    CONTINUE
c      write(0,*) 100*SQRT(S1/S0), 100*SQRT(S3/S2)
      write(iddmout,20) 100*SQRT(S1/S0), 100*SQRT(S3/S2)
20    FORMAT(
     * ' Rcurv       = ',F8.2,/,
     * ' Rwp         = ',F8.2,/)
      RETURN
      END
C
      SUBROUTINE ACCUR(IPH)
        INCLUDE 'DDM.inc'
      COMMON/DC/SAVL(MPH,6),NSAVE,VOL(MPH),TMAS(MPH),IQPA,SWT,DIFC,TPS,OMAC
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      integer*4 IMS
      COMMON/JNK/ALOW(30),AHIGH(30),POS(30),BCK(30),
     * NATOM(MPH),ifur(MPH),ndpar(MPH),PREF(MPH,3),PARS(MPH),PMU(MPH),OMU,
     * NBCKGD,IBFILE,NEXCRG,NSCAT
      COMMON/COEFF/AC(10,32),POSI(30),SCAT(30),DFP(32),DFPP(32),XMAS(32)
     * ,ATOMN(32),AMAC(32)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP,ADIST(NATS),IANIS(NATS) 
      DOUBLE PRECISION SMM, VX, BIAS1, BIAS2
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ),BIAS1(MSZ),BIAS2(MSZ)
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
      dimension uanis(6)
c
      N=NATOM(IPH)
      IOF=0
      if(IPH.GT.1) then
       do i=2,IPH
        IOF = IOF + NATOM(i-1)
       end do
      end if
c
      uanis(1) = 0.05066/PAR(1,6)
      uanis(2) = 0.05066/PAR(1,7)
      uanis(3) = 0.05066/PAR(1,8)
      uanis(4) = 0.05066/sqrt(PAR(1,6)*PAR(1,7))
      uanis(5) = 0.05066/sqrt(PAR(1,6)*PAR(1,8))
      uanis(6) = 0.05066/sqrt(PAR(1,7)*PAR(1,8))
      sm = 0.
      smu = 0.
      s = 0.
      su = 0.
      p = 0.
      pu = 0.
c      sl = 0.
      DO I=IOF+1,N+IOF
       if(LST3.GT.0) write(iconout,'(/A4\)') ATEXT(I)
       atmn = ATOMN(IPTR(I))
       if(JOBTYP.EQ.2) atmn = ABS(DFP(IPTR(I)))
       DO J=1,3
        if(LP(I,J).GT.0) then
         do k = I-1, 1, -1
          if(LP(I,J).EQ.LP(k,J)) go to 10
         end do
         if(LST3.GT.0) then 
          d = (XL(I,J)-XL(I+N,J))*SAVL(1,J)*atmn*XL(I,5)
          write(iconout,'(F12.6\)') d
          s = s + d*d
         end if
         d = SQRT(SMM(LP(I,J),LP(I,J)))*SAVL(1,J)*atmn*ABS(A(I,J))
     *       *XL(I,5)
         p = p + d*d
         sm = sm + XL(I,5)*XL(I,5)
        else
         if(LST3.GT.0) write(iconout,'(F12.6\)') 0.
        end if
10     END DO
c
       if(LP(I,4).GT.0) then
         do k = I-1, 1, -1
          if(LP(I,4).EQ.LP(k,4)) go to 20
         end do
         if(LST3.GT.0) then 
          d = (XL(I,4)-XL(I+N,4))*atmn*0.012665148*XL(I,5)
          write(iconout,'(F12.6\)') d
          su = su + d*d
         end if
         d = SQRT(SMM(LP(I,4),LP(I,4)))*atmn*0.012665148*ABS(A(I,4))
     *       *XL(I,5)
         pu = pu + d*d
         smu = smu + XL(I,5)*XL(I,5)
       else
        if(LST3.GT.0) write(iconout,'(F12.6\)') 0.
       end if
c
20     DO J=6,11
        if(LP(I,J).GT.0) then
         do k = I-1, 1, -1
          if(LP(I,J).EQ.LP(k,J)) go to 30
         end do
         if(LST3.GT.0) then
          d = (XL(I,J)-XL(I+N,J))*uanis(J-5)*atmn*XL(I,5)
          write(iconout,'(F12.6\)') d
          su = su + d*d
         end if
         d = SQRT(SMM(LP(I,J),LP(I,J)))*uanis(J-5)*atmn*ABS(A(I,J))
     *       *XL(I,5)
         pu = pu + d*d
         smu = smu + XL(I,5)*XL(I,5)
        else
         if(LST3.GT.0) write(iconout,'(F12.6\)') 0.
        end if
30     END DO
      END DO
c      DO I=1,3
c         d = SAVL(1,I)-SAVL(2,I)
c         sl = sl + d*d
c      END DO
      if(LST3.GT.0) then
       if(sm.GT.0) write(iddmout,40) 'Dx = ', SQRT(s/sm)
       if(smu.GT.0) write(iddmout,40) 'Du = ', SQRT(su/smu)
      end if
      if(sm.GT.0) write(iddmout,40)  ' XYZ precision = ', SQRT(p/sm)
      if(smu.GT.0) write(iddmout,40) ' U precision   = ', SQRT(pu/smu)
40    FORMAT(A,F10.6)
c
      RETURN
      END
c
      FUNCTION PSHIFT(DISP,SHASM,ANG)
        INCLUDE 'DDM.inc'
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(MPH,npar),APAR(MPH,npar),
     * LPAR(MPH,npar),XL(NATS,11),LP(NATS,11),A(NATS,11), ians(MPH,3),
     *  IPTR(NATS),RELAX(4),RATIO(2),fwhmlim(MPH,2),wddm,iddm,UZXYS(4)
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IWP,IPL,IPC,MAT,NXT,LST1,LST2,
     * LST3,LST4,IGEO,IFWE,MCYCLE,EPS,MAXS,INSTRM
     * ,IPREF, KNUM, ndec, MAXSi, iSzStr
c
      if(IGEO.EQ.0) then
       PSHIFT=DISP*COS(ANG*0.0087266462599716478846184)-SHASM*(1.56-ATAN(ANG))
      else
       PSHIFT=DISP*COS(ANG*0.0174532925199432957692369)-SHASM*EXP(-ANG*.084)
      end if
      RETURN
      END